{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,0}
Uses
  Crt;
Const
  Commands=9;
  Command:Array[1..Commands] Of String[6]=('DIR','VOLUME','LIST','TYPE','REF','CLS','VERIFY','EXIT','#$^%');
Type
  TReference=Record
    Volume:String[8];
    Article:String[132];
  End;
Var
  FMain:Text;
  CurVol,Vol:String[8];
  Cls,HaveRef:Boolean;
  RefCount:Byte;
  Ref:Array[1..255] Of TReference;

Function UCase(s:String):String;
Const
  LitChars:String[58]='abcdefghijklmnopqrstuvwxyz';
  BigChars:String[58]='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
Var
  i,j:Byte;
Begin
  For i:=1 To Byte(s[0]) Do
  Begin
    j:=Pos(s[i],LitChars);
    If j<>0 Then s[i]:=BigChars[j];
  End;
  UCase:=s;
End;

Procedure Init;
Begin
  WriteLn('ਢ!');
  Assign(FMain,'Input.Txt');
  Reset(FMain);
  ReadLn(FMain,Vol);
  CurVol:=Vol;
  Cls:=False;
  HaveRef:=False;
End;

Procedure Prompt;
Begin
  If Not Cls Then WriteLn Else Cls:=False;
  Write(Vol,'>');
End;

Procedure List;
Var
  f:Text;
  s:String;
  i:Integer;
Begin
  Assign(f,CurVol+'.Txt');
  Reset(f);
  If IOResult<>0 Then
  Begin
    WriteLn('  ');
    Exit;
  End;
  i:=0;
  HaveRef:=True;
  While Not SeekEof(f) Do
  Begin
    Inc(i);
    ReadLn(f,s);
    s:=Copy(s,1,Pos(' ',s)-1);
    WriteLn(i,'. ',s);
    Ref[i].Volume:=CurVol;
    Ref[i].Article:=s;
  End;
  RefCount:=i;
  Close(f);
End;

Procedure TypeArticle(s:String);
Var
  Status:(Find,Skip,Out);
  f:File Of Char;
  c:Char;
  LastWord,t:String;
  i:Byte;

  Procedure WriteWord;
  Begin
    If WhereX+Length(t)>81 Then
    Begin
      WriteLn;
      Write(t,' ');
    End
    Else
      If WhereX+Length(t)=81 Then Write(t) Else Write(t,' ');
  End;

  Procedure TestRef;
  Var
    i:Byte;
  Begin
    If Pos('(.',t)<>0 Then
    Begin
      HaveRef:=True;
      Inc(RefCount);
      Ref[RefCount].Article:=LastWord;
      If Pos('(.)',t)<>0 Then
        Ref[RefCount].Volume:=CurVol
      Else
        Ref[RefCount].Volume:=Copy(t,Pos('(.',t)+4,Pos(')',t)-Pos('(.',t)-4);
      For i:=Length(Ref[RefCount].Article) DownTo 1 Do
        If Not (Ref[RefCount].Article[i] In ['A'..'Z','a'..'z',''..'',''..'',''..'']) Then
        Begin
          Delete(Ref[RefCount].Article,1,i);
          Break;
        End;
    End;
  End;

Begin
  Assign(f,CurVol+'.Txt');
  Reset(f);
  If IOResult<>0 Then
  Begin
    WriteLn('  ');
    Exit;
  End;
  RefCount:=0;
  t:='';
  LastWord:='';
  Status:=Find;
  While Not Eof(f) Do
  Begin
    Read(f,c);
    Case c Of
      #13: Begin
             Case Status Of
               Skip: Status:=Find;
               Out: Begin
                      WriteWord;
                      TestRef;
                      If WhereX<>1 Then WriteLn;
                      Close(f);
                      If HaveRef Then
                      Begin
                        WriteLn;
                        For i:=1 To RefCount Do
                        Begin
                          Write(i,'. ',Ref[i].Article);
                          If UCase(Ref[i].Volume)<>CurVol Then Write(', ⮬ ',Ref[i].Volume);
                          WriteLn;
                        End;
                      End;
                      Exit;
                    End;
               Find: ;
             End;
             If Not Eof(f) Then Read(f,c);
             LastWord:=t;
             t:='';
           End;
      ' ': Begin
             Case Status Of
               Skip: ;
               Out: Begin
                      WriteWord;
                      TestRef;
                    End;
               Find: If t=s Then
                     Begin
                       Write(t,' ');
                       Status:=Out;
                     End
                     Else
                       Status:=Skip;
             End;
             LastWord:=t;
             t:='';
           End;
      Else t:=t+c;
    End;
  End;
  WriteLn('  ');
  Close(f);
End;

Procedure Verify;
Label
  iNext;
Type
  TAll=Record
    Volume:String[8];
    Article:String[32];
  End;
  TPnt=Record
    Volume:String[8];
    Article:String[32];
    pAll:Integer;
  End;
Var
  All:Array[1..700] Of TAll;
  Pnt:Array[1..700] Of TPnt;
  i,j,cAll,cPnt,cErr:Integer;
  t,LastWord:String;
  f:File Of Char;

  Procedure TestRef;
  Var
    i:Byte;
  Begin
    If Pos('(.',t)<>0 Then
    Begin
      Inc(cPnt);
      Pnt[cPnt].pAll:=cAll;
      Pnt[cPnt].Article:=LastWord;
      If Pos('(.)',t)<>0 Then
        Pnt[cPnt].Volume:=UCase(CurVol)
      Else
        Pnt[cPnt].Volume:=UCase(Copy(t,Pos('(.',t)+4,Pos(')',t)-Pos('(.',t)-4));
      For i:=Length(Pnt[cPnt].Article) DownTo 1 Do
        If Not (Pnt[cPnt].Article[i] In ['A'..'Z','a'..'z',''..'',''..'',''..'']) Then
        Begin
          Delete(Pnt[cPnt].Article,1,i);
          Break;
        End;
    End;
  End;

  Procedure ScanVolume;
  Var
    c:Char;
    Status:(Find,Skip);
  Begin
    Status:=Find;
    While Not Eof(f) Do
    Begin
      Read(f,c);
      Case c Of
        #13: Begin
               Case Status Of
                 Skip: Begin
                         TestRef;
                         Status:=Find;
                       End;
               End;
               If Not Eof(f) Then Read(f,c);
               LastWord:=t;
               t:='';
             End;
        ' ': Begin
               Case Status Of
                 Skip: TestRef;
                 Find: Begin
                         Inc(cAll);
                         All[cAll].Volume:=UCase(CurVol);
                         All[cAll].Article:=t;
                         Status:=Skip;
                       End;
               End;
               LastWord:=t;
               t:='';
             End;
        Else t:=t+c;
      End;
    End;
  End;

Begin
  cAll:=0;
  cPnt:=0;
  cErr:=0;
  Reset(FMain);
  While Not SeekEof(FMain) Do
  Begin
    ReadLn(FMain,t);
    Assign(f,t+'.Txt');
    CurVol:=t;
    t:='';
    LastWord:='';
    Reset(f);
    ScanVolume;
    Close(f);
  End;
  For i:=1 To cPnt Do
  Begin
    For j:=1 To cAll Do
      If (Pnt[i].Volume=All[j].Volume) And (Pnt[i].Article=All[j].Article) Then GoTo iNext;
    Inc(cErr);
    If cErr=1 Then WriteLn(' 뫪  騥 :');
    With Pnt[i] Do
      WriteLn(cErr,'.  ',All[pAll].Volume,':',All[pAll].Article,' 뫪  ',Volume,':',Article);
iNext:
  End;
  If cErr=0 Then WriteLn(' 뫪 ४');
End;

Procedure NewCommand;
Label
  NextReference;
Var
  s,t:String;
  i:Integer;
  j:Byte;
Begin
  ReadLn(s); s:=s+' ';
  t:='';
  While s[1]<>' ' Do
  Begin
    t:=t+s[1];
    Delete(s,1,1);
  End;
  Dec(s[0]);
  t:=UCase(t);
  For i:=1 To Commands Do
    If Command[i]=t Then Break;
  If i<>5 Then HaveRef:=False;
  Case i Of
    1: Begin
         Reset(FMain);
         While Not SeekEof(FMain) Do
         Begin
           ReadLn(FMain,t);
           WriteLn(t);
         End;
       End;
    2: Begin
         Delete(s,1,1);
         s:=UCase(s);
         Reset(FMain);
         While Not SeekEof(FMain) Do
         Begin
           ReadLn(FMain,t);
           If UCase(t)=s Then
           Begin
             Vol:=t;
             Exit;
           End;
         End;
         WriteLn('  ');
       End;
    3: Begin
         If (s[1]=' ') And (s<>'') Then
         Begin
           Delete(s,1,1);
           CurVol:=UCase(s);
         End
         Else
           CurVol:=UCase(Vol);
         Reset(FMain);
         While Not SeekEof(FMain) Do
         Begin
           ReadLn(FMain,t);
           If UCase(t)=CurVol Then
           Begin
             List;
             Exit;
           End;
         End;
         WriteLn('  ');
       End;
    4: Begin
         Delete(s,1,1);
NextReference:
         If Pos(':',s)<>0 Then
         Begin
           CurVol:=UCase(Copy(s,1,Pos(':',s)-1));
           Delete(s,1,Pos(':',s));
         End
         Else
           CurVol:=UCase(Vol);
         Reset(FMain);
         While Not SeekEof(FMain) Do
         Begin
           ReadLn(FMain,t);
           If UCase(t)=CurVol Then
           Begin
             TypeArticle(s);
             Exit;
           End;
         End;
         WriteLn('  ');
       End;
    5: Begin
         Delete(s,1,1);
         Val(s,j,i);
         If (i<>0) Or (Not HaveRef) Or (RefCount<j) Then
         Begin
           WriteLn('  뫪');
           HaveRef:=False;
         End
         Else
           With Ref[j] Do
           Begin
             HaveRef:=False;
             s:=Volume+':'+Article;
             GoTo NextReference;
           End;
       End;
    6: Begin
         ClrScr;
         Cls:=True;
       End;
    7: Verify;
    8: Begin
         WriteLn(' ᢨ.');
         Close(FMain);
         Halt;
       End;
    9: WriteLn(' ⠪ ');
  End;
End;

Begin
  Init;
  Repeat
    Prompt;
    NewCommand;
  Until False;
End.