uses Crt,Strings;
const Let:set of Char = ['a'..'z','','','','','','','','','','','',
                         '','','','','','','','','','','','','',
                         '','','','','','',''];
type PTopic = ^TTopic;
     PRefList = ^TRefList;
     TRefList = record
                 Idx : Word;
                 Ptr : PTopic;
                 Name : String[32];
                 VN : String[10];
                 Nxt,Prv : PRefList;
                end;
     TTopic = record
         Name:String[32];{   }
         Desc:String;{  }
         Ref:PRefList;{ ᯨ᮪ 뫮 }
         RefNum:Word;{ ᫮ 뫮 }
         Nxt:PTopic;
     end;
    PVolList = ^TVolList;
    PVolume = ^TVolume;
    TVolList = record
      Vol:PVolume;
      Nxt,Prv:PVolList;
    end;
    TVolume = object
         private
          VolumeExist : Boolean;
          VName:String[8];
          Topics:PTopic;
         public
         constructor Init(FN:String);
         procedure VList;
         function GetVTopic:PTopic;
         function GetVName:String;
         function Exist:Boolean;
         procedure VType(TName:String; var RefL:PRefList);
         procedure Verify(var msg:Boolean);
         destructor Done;
    end;

procedure AddRef(Top:PTopic; RTop:PTopic);
var RF:PRefList;
begin
  if Top=NIl then exit;
  inc(Top^.RefNum);
  New(RF);
  if RTop<>NIL then RF^.Ptr:=RTop
  else RF^.Ptr:=NIL;
  RF^.Idx:=Top^.RefNum;
  RF^.Nxt:=Top^.Ref^.Nxt;
  if Top^.Ref^.Nxt<>NIL then Top^.Ref^.Nxt^.Prv:=RF;
  RF^.Prv:=Top^.Ref;
  Top^.Ref^.Nxt:=RF;
  Top^.Ref:=RF;
end;
function PrevRef(Ref:PRefList):Boolean;
begin
  PrevRef:=false;
  if Ref=NIL then exit;
  if Ref^.Prv=NIL then exit;
  Ref:=Ref^.Prv;
  PrevRef:=true;
end;
function NextRef(Ref:PRefList):Boolean;
begin
  NextRef:=false;
  if Ref=NIL then exit;
  if Ref^.Nxt=NIL then exit;
  Ref:=Ref^.Nxt;
  NextRef:=true;
end;

procedure FirstRef(Ref:PRefList);
begin
  while PrevRef(Ref) do;
end;

procedure GetRef(Ref:PRefList; var NN:Word;XX:String);
begin
  if Ref=NIL then exit;
  NN:=Ref^.Idx;
  XX:=Ref^.Ptr^.Name;
end;

procedure InitTopics(var Top:PTopic);
begin
  Top:=NIL;
end;

procedure DispTopics(var Top:PTopic);
var TT:PTopic;
    XX:PRefList;
begin
  while Top<>NIL do begin
    TT:=Top^.Nxt;
    FirstRef(Top^.Ref);
    while Top^.Ref<>NIL do begin
      XX:=Top^.Ref^.Nxt;
     Dispose(Top^.Ref);
     Top^.Ref:=XX;
    end;
{    Dispose(Top^.Desc);}
    Dispose(Top);
    Top:=TT;
  end;
end;

procedure AddTopic(Name:String;Desc:String; var Top:PTopic);
var TT:PTopic;
begin
  if MaxAvail<SizeOf(PTopic) then begin
    WriteLn('No enough heap! Program terminated...');
  end;
  GetMem(TT,SizeOf(TTopic));
  TT^.Nxt:=Top;
  Top:=TT;
  Top^.Name:=Name;
  Top^.Desc:=Desc;
  Top^.RefNum:=0;
  Top^.Ref:=NIL;
end;

procedure GetTopic(Top:PTopic; var Name:String; Desc:String);
begin
 if Top=NIL then exit;
 Name:=Top^.Name;
 Desc:=Top^.Desc;
end;

function FindRef(Top:PTopic; Name:String):PTopic;
var TT:PTopic;
    Found:Boolean;
    NN,DD:String;
begin
   if Name='' then begin
     FindRef:=NIL;
     exit;
   end;
   if Top=NIL then begin
     FindRef:=NIL;
     exit;
   end;
   TT:=Top;
   found:=false;
   repeat
     GetTopic(TT,NN,DD);
     if NN<>Name then
       TT:=TT^.Nxt
       else Found:=true;
   until Found or (TT=NIL);
   if Found then FindRef:=TT
   else FindRef:=NIL;
end;

constructor TVolume.Init;
var VF:Text;
   tName:String;
   Ch:Char;
   Dest:String;
begin
  InitTopics(Topics);
  Assign(VF,FN+'.txt');
  VolumeExist:=true;
  VName:=FN;
  {$I-}
  Reset(VF);
  {$I+}
  if IOResult<>0 then begin
    VolumeExist:=false;
    exit;
  end;
  while not EOF(VF) do begin
    Dest:='';
    TName:='';
    repeat
      Read(VF,Ch);
      if Ch<>' ' then tName:=tName+Ch;
    until Ch=' ';
    ReadLn(VF,Dest);
    AddTopic(tname,Dest,Topics);
  end;
  Close(VF);
end;

function TVolume.GetVTopic:PTopic;
begin
  GetVTopic:=Topics;
end;

procedure TVolume.VList;
var TT:PTopic;
    NN,DD:String;
    Count:Word;
    NumR:Word;
    NameR:String;
begin
  TT:=Topics;
  Count:=0;
  while TT<>NIL do begin
    inc(Count);
    GetTopic(TT,NN,DD);
    WriteLn(Count,'. ',NN);
    TT:=TT^.Nxt;
  end;
end;

procedure TVolume.VType;
var Top:PTopic;
    Ch:Char;
    X,DX,EX,i:Word;
    NumR:Word;
    NameR:String;
begin
  Top:=FindRef(Topics,TName);
  if Top=NIL then begin
    WriteLn('  !');
    exit;
  end;
  with Top^ do begin
     DX:=1;
    X:=Length(Name)+1;
    Write(Name,' ');
    while DX<Length(Desc) do begin
      EX:=0;
      while EX+X<81 do begin
        inc(EX); if EX+DX>Length(Desc) then break;
        if Desc[EX+DX]=' ' then break;
        if DX+EX>SizeOf(Desc) then break;
      end;
      if EX+X>=81 then begin
        WriteLn;
        X:=1;
      end;
      while (Desc[DX]<>' ') do begin
        Write(Desc[DX]);
        inc(Ch); inc(DX); if DX>Length(Desc) then break;
      end;
      if DX<Length(Desc) then begin
        Write(Desc[DX]);
        inc(DX); inc(Ch);
      end;
    end;
    WriteLn;
    FirstRef(Topics^.Ref);
    for i:=1 to RefNum do begin
      GetRef(Topics^.Ref,NumR,NameR);
      WriteLn(NumR,'. ',NameR);
      NextRef(Topics^.Ref);
    end;
  end;
end;

procedure TVolume.Verify;
var i:Word;
   TT:PTopic;
begin
  TT:=Topics;
  repeat
   with TT^ do begin
    FirstRef(Ref);
    if Ref^.Ptr=Nil then begin
     if not msg then begin
       msg:=true;
       WriteLn(' 뫪  騥 :');
     end;
     WriteLn(' ',VName,':',Name,' 뫪  ',Ref^.VN,':',Ref^.Name);
   end;
   for i:=1 to RefNum do begin
     NextRef(Ref);
     if Ref^.Ptr=Nil then begin
      if not msg then begin
        msg:=true;
        WriteLn(' 뫪  騥 :');
      end;
     WriteLn(' ',VName,':',Name,' 뫪  ',Ref^.VN,':',Ref^.Name);
    end;
   end;
   end;
   TT:=TT^.Nxt;
  until TT=NIL;
end;

function TVolume.GetVName:String;
begin
  GetVNAme:=VName;
end;

function TVolume.Exist:Boolean;
begin
  Exist:=VolumeExist;
end;

destructor TVolume.Done;
begin
  DispTopics(Topics);
end;

procedure AddVol(FN:String; var VolList:PVolList);
var VV:PVolList;
begin
  New(VV);
  New(VV^.Vol,Init(FN));
  if VolList=NIL then begin
    VV^.Nxt:=NIL;
    VV^.Prv:=NIL
  end else begin
    VV^.Nxt:=VolList^.Nxt;
    VV^.Prv:=VolList;
  end;
  if VV^.Nxt<>NIL then VV^.Nxt^.Prv:=VV;
  if VV^.Prv<>NIL then VV^.Prv^.Nxt:=VV;
  VolList:=VV;
end;

function NextVol(var VolList:PVolList):Boolean;
begin
  NextVol:=false;
  if VolList=NIL then exit;
  if VolList^.Nxt=NIl then exit;
  VolList:=VolList^.Nxt;
  NextVol:=true;
end;

function PrevVol(var VolList:PVolList):Boolean;
begin
  PrevVol:=false;
  if VolList=NIL then exit;
  if VolList^.Prv=NIl then exit;
  VolList:=VolList^.Prv;
  PrevVol:=true;
end;

procedure FirstVol(var VolList:PVolList);
begin
  while PrevVol(VolList) do;
end;

procedure LastVol(var VolList:PVolList);
begin
  while NextVol(VolList) do;
end;

procedure DelVol(var VolList:PVolList);
var DD:PVolList;
begin
  if VolList=NIl then exit;
  DD:=VolList^.Prv;
  if DD<>NIL then DD^.Nxt:=VolList^.Nxt;
  if VolList^.Nxt<>Nil then VolList^.Nxt^.Prv:=DD;
    Dispose(VolList^.Vol,Done);
  Dispose(VolList);
  VolList:=DD;
end;

{===========================᭮ ணࠬ===============================}
var Data:PVolList;
   RefList:PRefList;

procedure StartUp;
var SF:Text;
    NN:String;
begin
  Assign(SF,'input.txt');
  {$I-}
  Reset(SF);
  {$I+}
  if IOResult<>0 then begin
    WriteLn(' input.txt  !');
    Halt(1);
  end;
  NN:='';
  while not EOF(SF) do begin
    ReadLn(SF,NN);
    AddVol(NN,Data);
  end;
  Close(SF);
  WriteLn('ਢ!');
end;

procedure ShutDown;
begin
  LastVol(Data);
  while Data<>Nil do DelVol(Data);
end;

function AskCommand:Boolean;
var PStr:String;
    Com,Par1,Par2:String;

procedure ListVols;
var OldData:PVolList;
begin
  OldData:=Data;
  FirstVol(Data);
  repeat
    WriteLn(Data^.Vol^.GetVName);
  until not NextVol(data);
  Data:=OldData;
end;

procedure ChangeVolume(var xData:PVolList);
var Found:Boolean;
   OldData:PVolList;
begin
  OldData:=xData;
  FirstVol(xData);
  Found:=false;
  repeat
    if (xData^.Vol^.GetVName=Par1)and xData^.Vol^.Exist then Found:=true;
  until Found or (not NextVol(xData));
  if not Found then begin
    WriteLn('  !');
    xData:=OldData;
  end;
end;

procedure ListContents;
var OO:PVolList;
begin
  OO:=Data;
  if Par1='' then OO^.Vol^.VList
  else begin
    ChangeVolume(OO);
    OO^.Vol^.VList
  end;
end;

procedure WriteTopic;
var OO:PVolList;
begin
  OO:=Data;
  if Par2='' then OO^.Vol^.VType(Par1,RefList)
  else begin
    ChangeVolume(OO);
    OO^.Vol^.VType(Par2,RefList)
  end;
end;

procedure WriteRef;
var NN,Idx:Word;
   Res:Integer;
   Name:String;
   OO:PVolList;
begin
  OO:=Data;
  Val(Par1,NN,res);
  FirstRef(RefList);
  repeat
    GetRef(RefList,NN,Name);
    if NN=Idx then
      begin
        Par1:=Reflist^.VN;
        ChangeVolume(OO);
        OO^.Vol^.VType(RefList^.Name,RefList);
        exit;
      end;
  until not NextRef(RefList);
  WriteLn('  뫪!');
end;

procedure VerifyAll;
var OO:PVolList;
    Msg:Boolean;
begin
  OO:=Data;
  Msg:=false;
  FirstVol(OO);
  repeat
    OO^.Vol^.verify(msg);
  until not nextvol(OO);
  if not Msg then WriteLn(' 뫪 ࠢ!');
end;


begin
  Com:='';
  Par1:=''; Par2:='';
  AskCommand:=true;
  WriteLn;
  Write(Data^.Vol^.GetVName,'>');
  ReadLn(PStr);
  if Pos(' ',PStr)=0 then Com:=PStr
  else begin
    Com:=Copy(PStr,1,Pos(' ',PStr)-1);
    Delete(PStr,1,Pos(' ',PStr));
    if Pos(':',PStr)<>0 then begin
      Par1:=Copy(PStr,1,Pos(':',PStr)-1);
      Delete(PStr,1,Pos(':',PStr));
      Par2:=PStr;
    end else Par1:=PStr;
  end;
  if Com='CLS' then ClrScr else
  if Com='EXIT' then AskCommand:=false else
  if Com='DIR' then ListVols else
  if Com='LIST' then ListContents else
  if Com='TYPE' then WriteTopic else
  if Com='REF'then WriteRef else
  if Com='VERIFY' then VerifyAll else
  if Com='VOLUME' then ChangeVolume(data)
  else begin
    WriteLn(' ⠪ ! 㯭 : ');
    WriteLn('      DIR - 뢥 ᯨ᮪ ⮬');
    WriteLn('      VOLUME -  ⮬');
    WriteLn('      LIST - 뢥  ⮬');
    WriteLn('      TYPE - 뢥 ');
    WriteLn('      REF - 뢥   뫪');
    WriteLn('      CLS -  ࠭');
    WriteLn('      VERIFY - ஢ 뫪');
    WriteLn('      EXIT - 室');
  end;
end;

begin
  StartUp;
  while AskCommand do;
  ShutDown;
end.