 uses CRT;
 type
  PRef = ^TRef;
  TRef = record
   Vol: String[8];
   Wrd: String[32];
   Next: PRef;
  end;

  PDList = ^TDList;
  TDList = record
   Dic: String[8];
   Next: PDList;
  end;

  PDict = ^TDict;
  TDict = record
   Word: String[32];
   Disc: String;
   Next: PDict;
  end;

 var
  CRef  : Boolean;
  DidST : Boolean;
  CurDic: String[8];
  Dict: PDict;
  SaveDict: PDict;
  DList: PDList;
  Command: String;
  Cm: String;
  Ref: PRef;
  CDic: String;

 {============================================================}
 {========================= Service ==========================}
 {============================================================}

 function LowStr(X: String): String;
  const
   Big: String = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   Sml: String = 'abcdefghigklmnopqrstuvwxyz';
  var
   i: Integer;
  begin
   for i := 1 to Length(X) do
    if Pos(X[i], Big) <> 0 then X[i] := Sml[Pos(X[i], Big)];
   LowStr := X;
  end;

 function PathStr(X: String): String;
  const
   Big: String = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   Sml: String = 'abcdefghigklmnopqrstuvwxyz';
  begin
   X := LowStr(X);
   if Pos(X[1], Sml) <> 0 then X[1] := Big[Pos(X[1], Sml)];
   PathStr := X;
  end;

 procedure AddRef(Vol, Wrd: String);
  var
   X,L: PRef;
  begin
   New(X);
   X^.Vol := Vol;
   X^.Wrd := Wrd;
   X^.Next := nil;

   if  Ref = nil then
    Ref := X
   else
    begin
     L := Ref;
     while L^.Next <> nil do L := L^.Next;
     L^.Next := X;
    end;
  end;

 procedure DelFRef;
  var
   X: PRef;
  begin
   if Ref = nil then Exit;
   X := Ref^.Next;
   Dispose(Ref);
   Ref := X;
  end;

 procedure AddDisc(Wrd,Dis: String);
  var
   X,L: PDict;
  begin
   New(X);
   X^.Word := Wrd;
   X^.Disc := Dis;
   X^.Next := nil;

   if  Dict = nil then
    Dict := X
   else
    begin
     L := Dict;
     while L^.Next <> nil do L := L^.Next;
     L^.Next := X;
    end;
  { X^.Next := Dict;
   Dict := X;}
  end;

 procedure DelFDisc;
  var
   X: PDict;
  begin
   if Dict = nil then Exit;
   X := Dict^.Next;
   Dispose(Dict);
   Dict := X;
  end;

 procedure AddDic(Name: String);
  var
   X: PDList;
  begin
   New(X);
   X^.Dic := Name;
   X^.Next := DList;
   DList := X;
  end;

 procedure InsDisc(X: String);
  var
   P: Integer;
   Disc: String;
   Wrd: String[32];
  begin
   P := Pos(' ', X);
   Disc := Copy(X, P+1, Length(X) - P);
   Wrd  := Copy(X, 1, P - 1);
   AddDisc(Wrd,Disc);
  end;

 function ExistDic(Name: String): Boolean;
  var
   X: PDList;
  begin
   ExistDic := True;
   X := DList;
   Name := LowStr(Name);
   while X <> nil do
    begin
     if LowStr(X^.Dic) = Name then Exit;
     X := X^.Next;
    end;
   ExistDic := False;
  end;

 procedure ReadDic(Name: String);
  var
   Inp: Text;
   A: String;
  begin
   Assign(Inp, Name+'.txt');
   Reset(Inp);
   while not EOF(Inp) do
    begin
     ReadLn(Inp,A);
     InsDisc(A);
    end;
   Close(Inp);
  end;

  function Exist(Wrd, Dic: String): Boolean;
   var
    X: PDict;
   begin
    if not ExistDic(Dic) then
     begin
      Exist := False;
      Exit;
     end;

    SaveDict := Dict;
    Dict := nil;
    ReadDic(Dic);

    X := Dict;
    while (X <> nil) and (X^.Word <> Wrd) do
                                       X := X^.Next;

    while Dict <> nil do DelFDisc;
    Dict := SaveDict;

    Exist := X <> nil;
   end;

 {========================================================}
 {====================== Commands ========================}
 {========================================================}
   procedure Prompt;
    begin
     Write(PathStr(CurDic),'>');
     ReadLn(Command);
     Cm := LowStr(Command);
    end;

   procedure Dir;
    var
     X: PDList;
    begin
     X := DList;
     while X <> nil do
      begin
       WriteLn(X^.Dic);
       X := X^.Next;
      end;

     DidST := True;
     CRef := False;
    end;

   procedure List;
    var
     X: PDict;
     N: Integer;
     P: Integer;
     Vol: String[8];
    begin
     DidST := True;

     if Cm <> 'list' then
      begin
       P := Pos(' ', Command);
       Vol := Copy(Command, P + 1, Length(Command) - P);

       if not ExistDic(Vol) then
        begin
         WriteLn('  ');
         Exit
        end;

       SaveDict := Dict;
       Dict := nil;
       ReadDic(Vol);
      end else Vol := CurDic;

     N := 0;
     X := Dict;
     while X <> nil do
      begin
       inc(N);
       WriteLn(N,'. ',X^.Word);
       AddRef(Vol, X^.Word);
       X := X^.Next;
      end;

     CRef := True;

     if Cm <> 'list' then
      begin
       while Dict <> nil do DelFDisc;
       Dict := SaveDict;
      end;
    end;

   procedure Volume;
    var
     Vol: String[8];
     P: Integer;
    begin
     P := Pos(' ', Command);
     Vol := Copy(Command, P+1, Length(Command) - P);
     if ExistDic(Vol) then
      begin
       while Dict <> nil do DelFDisc;
       ReadDic(Vol);
       CurDic := Vol;
      end else WriteLn('  ');

     DidST := True;
     CRef := False;
    end;

   procedure Cls;
    begin
     ClrScr;
     DidST := True;
     CRef := False;
    end;

   procedure Print(St: String);
    var
     S: String;
     i: Integer;
     Len: Integer;
    begin
     i := 1;
     Len := 0;
     while i <= Length(St) do
      begin
       S := '';
       while (St[i] <> ' ') and (i <= Length(St)) do
        begin
         S := S + St[i];
         inc(i);
        end;
       if Length(St) >= i then S := S + ' ';
       inc(i);

       if (Len + Length(S)) <= 80 then
        begin
         Write(S);
         Len := Len + Length(S);
        end else
       begin
        if Len < 80 then WriteLn;
        Len := 0;
       end;
      end;

     if (Len < 80) and (Len > 0) then WriteLn;
    end;

   procedure MakeRef(Txt: String);
    const
     Letters: set of Char = ['A'..'z',''..'',''..''];
    var
     P,i: Integer;
     Wrd,Vol: String;
     N: Integer;
     X: PRef;
     A: TRef;
    begin
     N := 0;
     repeat
      P := Pos(' (.', Txt);
      if P = 0 then exit;
      i := P - 1;
      while (Txt[i] in Letters) and (i >= 1) do dec(i);
      if i = 0 then
       begin
        Delete(Txt, P, 5);
        continue
       end;

      Wrd := Copy(Txt, i + 1, P - i - 1);
      i := P + 5;
      while (Txt[i] <> ')') and (i < Length(Txt)) do inc (i);
      if Txt[i] <> ')' then
       begin
        Delete(Txt, P, 5);
        continue
       end;

      Vol := Copy(Txt, P + 5, I - 5 - P);

      X := Ref;
      while (X <> nil) and
        ((X^.Wrd<>Wrd) or (X^.Vol <> Vol)) do X := X^.Next;

      if X = nil then
       begin
        inc(N);
        Write(N, '. ', Wrd);
        if Vol <> '' then WriteLn(', ⮬ ', Vol) else WriteLn;
        if Vol = '' then Vol := CDic;

        AddRef(Vol, Wrd);
       end;

      Delete(Txt, P, 5);
     until P = 0;
    end;

   procedure cmType;
    var
     PS,PD: Integer;
     Vol  : String;
     Name : String;
     X    : PDict;
    begin
     DidST := True;
     PS := Pos(' ',Command);
     Cm := Copy(Command, PS + 1, Length(Command) - PS);

     PS := Pos (' ', Cm);
     PD := Pos (':', Cm);

     if PD <> 0 then
      begin
       Vol := Copy(Cm, 1, PD - 1);
       if not ExistDic(Vol) then
        begin
         WriteLn('  ');
         Cm := '';
         Exit
        end;
       SaveDict := Dict;
       Dict := nil;
       ReadDic(Vol);

       Name := Copy (Cm, PD + 1, Length(Cm) - PD);
       CDic := Vol;
      end else
       begin
        Name := Cm;
        CDic := CurDic;
       end;

     X := Dict;
     while (X <> nil) and (X^.Word <> Name) do X := X^.Next;

     if X = nil then
       WriteLn('  ')
     else
      begin
       Print(X^.Word + ' ' + X^.Disc);
       MakeRef(X^.Disc);
      end;

     if PD <> 0 then
      begin
       while Dict <> nil do DelFDisc;
       Dict := SaveDict;
      end;

     CRef := True;
    end;

   procedure cmRef;
    var
     N,P: Integer;
     Num: String;
     Code: Integer;
     X: PRef;
    begin
     if not CRef then Exit;
     P := Pos(' ', Cm);
     Num := Copy(Cm, P + 1, Length(Cm) - P);
     Val(Num, N, Code);
     if Code <> 0 then
      begin
       DidST := True;
       WriteLn('  뫪');
       Exit
      end;

     X := Ref;
     P := 1;
     while (X <> nil) and (P < N) do
      begin
       X := X^.Next;
       Inc(P);
      end;

     if X = nil then
      begin
       DidST := True;
       WriteLn('  뫪');
       Exit
      end;

     Command := 'type ' + X^.Vol + ':' + X^.Wrd;
     while Ref <> nil do DelFRef;
     cmType;
    end;

   procedure MakeR(Txt: String);
    const
     Letters: set of Char = ['A'..'z',''..'',''..''];
    var
     P,i: Integer;
     Wrd,Vol: String;
    begin
     repeat
      P := Pos(' (.', Txt);
      if P = 0 then exit;
      i := P - 1;
      while (Txt[i] in Letters) and (i >= 1) do dec(i);
      if i = 0 then
       begin
        Delete(Txt, P, 5);
        continue
       end;

      Wrd := Copy(Txt, i + 1, P - i - 1);
      i := P + 5;
      while (Txt[i] <> ')') and (i < Length(Txt)) do inc (i);
      if Txt[i] <> ')' then
       begin
        Delete(Txt, P, 5);
        continue
       end;

      Vol := Copy(Txt, P + 5, I - 5 - P);
      if Vol = '' then Vol := CDic;

      AddRef(Vol, Wrd);
      Delete(Txt, P, 5);
     until P = 0;
    end;

   procedure Verify;
    var
     D: PDList;
     X: PDict;
     SD: PDict;
     N: Integer;
     R: PRef;
    begin
     DidST := True;
     D := DList;
     N := 0;
     while D <> nil do
      begin
       SD := Dict;
       Dict := nil;
       ReadDic(D^.Dic);

       X := Dict;
       while X <> nil do
        begin
         CDic := D^.Dic;
         MakeR(X^.Disc);
          R := Ref;
          while R <> nil do
           begin
            if not Exist(R^.Wrd, R^.Vol) then
             begin
              inc(N);
              WriteLn(N,'.  ', D^.Dic,':',X^.Word,' 뫪  ',
                      R^.Vol,':',R^.Wrd);
             end;
            R := R^.Next;
           end;
          while Ref <> nil do DelFRef;
         X := X^.Next;
        end;

       while Dict <> nil do DelFDisc;
       Dict := SD;
       D := D^.Next;
      end;
      CRef := False;
    end;

   procedure Run;
    begin
     repeat
      Prompt;
      DidST := False;
      if CRef and (Copy(Cm, 1, 4) <> 'ref ') then
                   while Ref <> nil do DelFRef;
      if Cm = 'dir' then Dir;
      if (Copy(Cm,1,5) = 'list ') or (Cm = 'list') then List;
      if Copy(Cm,1,7) = 'volume ' then Volume;
      if Cm = 'cls' then Cls;
      if Copy(Cm, 1, 5) = 'type ' then cmType;
      if Copy(Cm, 1, 4) = 'ref '  then cmRef;
      if Cm = 'verify' then Verify;

      if (Cm = 'exit') or (Cm = '') then DidST := True;
      if not DidST then WriteLn(' ⠪ ');
      WriteLn;
     until Cm = 'exit';
    end;

 {========================================================}
 {===================== INIT =============================}
 {========================================================}

 procedure Init;
  var
   I: Integer;
   Inp: Text;
   X: PDList;
   St: String;
  begin
   {== Dictionaries ==}
   CRef := False;
   DList := nil;
   Assign(Inp,'input.txt');
   Reset(Inp);
   while not EOF(Inp) do
    begin
     ReadLn(Inp,St);
     AddDic(St);
    end;
   Close(Inp);

   Dict := nil;
   X := DList;
   while X^.Next <> nil do X := X^.Next;
   ReadDic(X^.Dic);
   CurDic := X^.Dic;

   WriteLn('ਢ!');
   WriteLn;
  end;

  procedure Done;
   begin
    while Dict <> nil do DelFDisc;
    while Ref <> nil do DelFRef;
    WriteLn(' ᢨ.');
   end;
 begin
  Init;
  Run;
 end.