Uses Crt;
Type String63 = String[63];
     String12 = String[12];
Const Coms : Array [0.. 7] of String[8] =
('dir',
 'volume',
 'list',
 'type',
 'ref',
 'cls',
 'verify',
 'exit'
);
  TxtErr : Array [0.. 3] of String[21] =
(' ⠪ .',
 '  .',
 '  .',
 '  뫪.'
);

Var MaxNTom,
    MaxNSp,
    CurTom   : Integer;
    Toms     : Array [0.. 255] of String12;
    Pr       : Boolean;
    CurSp    : Array [1.. 127] of String63;
    CurTm    : Array [1.. 127] of String12;

Procedure Quit;
Begin
 WriteLn (' ᢨ.');
 Halt;
End;

Procedure WrError (NumError : Integer);
Begin
 WriteLn (TxtErr[NumError]);
End;

Procedure FormatStr (Var Str : String63);
Var Num : Integer;
Begin
 For Num := 1 to Length (Str) do
  If Str[Num] in ['A'.. 'Z'] then Str[Num] := Chr (Ord (Str[Num]) + 32);
End;

Procedure InitData;
Var f      : Text;
    s      : String[12];
    N,
    Number : Integer;
Begin
 CurTom := 0;
 Assign (f, 'input.txt');
 ReSet (f);
 Number := 0;
 While (not EOF (f)) and (Number < 256) do
 Begin
  ReadLn (f, Toms[Number]);
  Inc (Number);
 End;
 Close (f);
 MaxNTom := Number - 1;
End;

Procedure ReadCom (Var ComStr, Param : String63);
Var Num : Integer;
Begin
 WriteLn;
 Write (Toms[CurTom], '>');
 ReadLn (ComStr);
 FormatStr (ComStr);
 Num := 1;
 While (ComStr[Num] <> ' ') and (Num <= Length (ComStr)) do Inc (Num);
 Param := Copy (ComStr, Num + 1, Length (ComStr) - Num);
 ComStr[0] := Chr (Num - 1);
End;

Function GetNumTom (Param : String) : Integer;
Var Num,
    NumTom : Integer;
    s      : String63;
    Ok     : Boolean;
Begin
 Ok := false;
 For Num := 0 to MaxNTom do
 Begin
  s := Toms[Num];
  FormatStr (s);
  If Param = s then
  Begin
   NumTom := Num;
   Ok := true;
  End;
 End;
 If Ok then GetNumTom := NumTom
       else GetNumTom := - 1;
End;

Procedure ReadSt (Var f : Text; Var St : String63);
Var c : Char;
Begin
 St := '';
 Repeat
  Read (f, c);
  St := St + c;
 Until (c = ' ') or EOF (f);
End;

Procedure ReadLnSt (Var f : Text; Var St : String63);
Begin
 ReadSt (f, St);
 ReadLn (f);
End;

Procedure DelSpace (Var s : String63);
Var Num : Integer;
    str : String;
Begin
 str := '';
 For Num := 1 to Length (s) do
  If s[Num] <> ' ' then str := str + s[Num];
 s := str;
End;

Procedure Dir_;
Var Num : Integer;
Begin
 For Num := 0 to MaxNTom do
  WriteLn (Toms[Num]);
 Pr := false;
End;

Procedure Volume_ (Var Param : String63);
Var Num : Integer;
    s   : String;
Begin
 If param = '' then
 Begin
  Inc (CurTom);
  If CurTom > MaxNTom then CurTom := 0;
 End
               else
 Begin
  Num := GetNumTom (Param);
  If Num = - 1 then WrError (1)
               else CurTom := Num;
 End;
 Pr := false;
End;

Procedure List_ (Var Param : String63);
Var f      : Text;
    Num,
    NumSt,
    NumTom : Integer;
    St     : String;
    c      : Char;
Begin
 If Param = '' then NumTom := CurTom
               else
 Begin
  NumTom := GetNumTom (Param);
  If NumTom = - 1 then WrError (1);
 End;
 Assign (f, Toms[NumTom] + '.txt');
 {$I-}
 ReSet (f);
 {$I+}
 If IOResult <> 0 then
 Begin
  WriteLn ('   (', Toms[NumTom] + '.txt', ')');
  Exit;
 End;
 NumSt := 1;
 While not EOF(f) do
 Begin
  ReadLnSt (f, CurSp[NumSt]);
  CurTm[NumSt] := Toms[CurTom];
  WriteLn (NumSt, '. ', CurSp[NumSt]);
  Inc (NumSt);
 End;
 MaxNSp := NumSt - 1;
 Close (f);
 Pr := true;
End;

Procedure Type_ (Param : String63);
Var NumTom,
    co, n,
    d, max,
    Number,
    Num     : Integer;
    Sub     : String;
    CSt     : String63;
    dds,
    ds      : String63;
    Tom, St : String63;
    f       : Text;
    Stat    : Array [0.. 10240] of Char;
    Ok      : Boolean;
Begin
 Num := Pos (':', Param);
 Tom := '';
 If Num <> 0 then
 Begin
  Tom := Copy (Param, 1, Num - 1);
  St := Copy (Param, Num + 1, Length (Param) - Num);
 End
             else
  St := Param;
 If St = '' then
 Begin
  WriteLn ('  .');
  Exit;
 End;
 DelSpace (Tom);
 If Tom <> '' then
 Begin
  NumTom := GetNumTom (Tom);
  If NumTom = - 1 then
  Begin
   WrError (1);
   Exit;
  End;
 End
              else
  NumTom := CurTom;
 DelSpace (St);
 Assign (f, Toms[NumTom] + '.txt');
 {$I-}
 ReSet (f);
 {$I+}
 If IOResult <> 0 then
 Begin
  WriteLn ('   (', Toms[NumTom] + '.txt', ')');
  Exit;
 End;
 Ok := false;
 While not EOF (f) do
 Begin
  ReadSt (f, CSt);
  DelSpace (CSt);
  If CSt <> St then
  Begin
   ReadLn (f);
   Continue;
  End;
  Ok := true;
  co := 0;
  While (not Eoln (f)) and (co <= 10239) do
  Begin
   Read (f, Stat[co]);
   Inc (co);
  End;
  For Num := co to 10240 do
   Stat[Num] := ' ';
  Num := 0;
  max := 79 - Length (St) - 1;
  Write (St, ' ');
  While Num < co do
  Begin
   Sub := '';
   n := 0;
   While Stat[Num + n] = ' ' do Inc (n);
   For n := n to max do
    Sub := Sub + Stat[Num + n];
   max := 79;
   If Stat[Num + 80] = ' ' then
   Begin
    WriteLn (Sub);
    Inc (Num, 80);
   End
                           else
   Begin
    d := n;
    While Stat[Num + n] <> ' ' do Dec (n);
    WriteLn (Copy (Sub, 1, Length (Sub) - d + n));
    Inc (Num, n);
   End;
  End;
 End;
 Close (f);

 Number := 1;
 If not Ok then
 Begin
  WrError (2);
  Exit;
 End;
 Num := 0;
 While Num < co do
 Begin
  Sub := '';
  For n := 0 to 254 do
   Sub := Sub + Stat[Num + n];
  d := Pos ('(.', Sub);
  If (d = 0) or (d > 200) then
  Begin
   Inc (Num, 145);
   Continue;
  End;
  n := Pos (')', Sub);
  ds := Copy (Sub, d + 4, n - d - 4);
  DelSpace (ds);
  If ds = '' then ds := Toms[CurTom];
  CurTm[Number] := ds;
  n := d;
  Dec (d, 2);
  While Ord (Sub[d]) > 64 do
   Dec (d);
  Inc (d);
  dds := Copy (Sub, d, n - d);
  CurSp[Number] := dds;
  WriteLn (Number, '. ', dds, ', ⮬ ', ds);
  Inc (Number);
  Inc (Num, n);
 End;
 Pr := true;
 MaxNSp := Number;
End;

Procedure Ref_ (Param : String63);
Var er, n : Integer;
       ds : String63;
Begin
 If not Pr then
 Begin
  WriteLn ('맮 Ref  ⮫쪮 ᫥ Type, Ref  List.');
  Exit;
 End;
 Val (Param, n, er);
 If er <> 0 then
 Begin
  WriteLn (' ࠬ.');
  Exit;
 End;

 If (n < 1) or (n > MaxNSp) then
 Begin
  WrError (3);
  Exit;
 End;
 ds := CurTm[n] + ':' + CurSp[n];
 FormatStr (ds);
 DelSpace (ds);
 Type_ (ds);
End;

Procedure Cls_;
Begin
 ClrScr;
 Pr := false;
End;

Procedure Verify_;
Var NTom,
     NNC  : Integer;
Begin
 NNC := 0;
 For NTom := 0 to MaxNTom do
 Begin

 End;

 WriteLn ('筮  ,   ,    浪.');
 Pr := false;
End;


Procedure Run;
Var param,
    ComStr  : String63;
    NumCom,
    Num     : Integer;
Begin
 Repeat
  ReadCom (ComStr, param);
  NumCom := - 1;
  For Num := 0 to 7 do
   If ComStr = Coms[Num] then
   Begin
    NumCom := Num;
    Break;
   End;
  Case NumCom of 0 : Dir_;
                 1 : Volume_ (Param);
                 2 : List_ (Param);
                 3 : Type_ (Param);
                 4 : Ref_ (Param);
                 5 : Cls_;
                 6 : Verify_;
                 7 : Quit;
              else   WrError (0);
  End;{Case}
 Until false;
End;

Begin
 ClrScr;
 InitData;
 WriteLn ('ਢ');
 Run;
 Quit;
End.