{$N+}
program P3105_6;

const MaxN=100; small=1E-6; Many=1E+10;

type Graph = array[1..MaxN,1..MaxN] of single;
     Polygon = record
       X,Y : array[1..MaxN] of single;
     end;

var N : byte; G : Graph;
    Source, Dest : byte;
    Result : single;

{-------------------------------------}
function TestLine(AX1,AY1,AX2,AY2,BX1,BY1,BX2,BY2 : single) : byte;
  var DX1, DY1, DX2, DY2, T1, T2 : single;
      X01 : single absolute AX1; X02 : single absolute BX1;
      Y01 : single absolute AY1; Y02 : single absolute BY1;
begin
  DX1 := AX2-AX1; DY1 := AY2-AY1; DX2 := BX2-BX1; DY2 := BY2-BY1;
  if ABS(DY2*DX1-DX2*DY1)<Small then { 1 אַ/ࠫ}
    begin TestLine := 0; {⠥,   ᮢ}; exit end;
  T2 := ((X02-X01)*DY1-(Y02-Y01)*DX1)/(DY2*DX1-DX2*DY1);
  T1 := ((X01-X02)*DY2-(Y01-Y02)*DX2)/(DY1*DX2-DX1*DY2);
  if ((T1>Small) and (T1<1)) and ((T2>Small) and (T2<1)) then TestLine := 1 else TestLine := 0;
end;

function SubAngle(X,Y : single) : single;
begin
  if abs(X)<small then {90/270}
    begin if Y>0 then SubAngle:=Pi/2 else SubAngle:=-Pi/2; exit end;
  if abs(Y)<small then {0/180}
    begin if X>0 then SubAngle:=0 else SubAngle:=Pi*2; exit end;
  if X<0 then SubAngle:=Pi+arctan(Y/X) else
    if Y<0 then SubAngle:=2*Pi+arctan(Y/X) else SubAngle:=arctan(Y/X);
end;

function Angle(X0,Y0,X1,Y1,X2,Y2 : single) : single;
var t : single;
begin
  X1 := X1-X0; Y1:=Y1-Y0; X2 := X2-X0; Y2 := Y2-Y0;
  t := SubAngle(X2,Y2)-SubAngle(X1,Y1);
  if abs(t) > Pi then
    begin
      if t > 0 then Angle := t-2*Pi else Angle := 2*Pi+t;
    end else Angle:=t;
end;

procedure MakeGraph;
var P : Polygon;

function PsetInPolygon(X,Y : single) : boolean;
var Sum : single; i,i1 : byte;
begin
  { - " 㣫"}
  Sum := 0;
  for i := 1 to N do
    begin
      if i=N then i1 := 1 else i1 := i+1;
      Sum := Sum+Angle(X,Y,P.X[i],P.Y[i],P.X[i1],P.Y[i1]);
    end;
  if abs(Sum)<Small then PsetInPolygon := false else PsetInPolygon:=true;
end;

  {0 -  ᥪ, 1 - ᥪ, 2 - ᮢ (, 筮)}

  function Test(A,B : byte) : single; {頥    A  B  0, ᫨ אַ  }
    var i1,i2 : byte;
    label Cross, lab1;
    begin
      {᫨     設}
      if A=B then begin Test:=0; exit end;
      {᫨ ᥤ 設}
      if (abs(A-B)=1) or ((A=1) and (B=N)) or ((A=N) and (B=1)) then { 裡 ࠢ ﭨ  設}
lab1:   begin Test:=sqrt(sqr(P.X[A]-P.X[B])+sqr(P.Y[A]-P.Y[B])); exit end;
      for i1 := 1 to N do
        begin
          if i1=1 then i2 := N else i2 := i1-1;
          if not((i1=1) or (i2=A) or (i1=B) or (i2=B)) then
            begin
              if TestLine(P.X[i1],P.Y[i1],P.X[i2],P.Y[i2],P.X[A],P.Y[A],P.X[B],P.Y[B])=1 then goto Cross;
            end
        end;
        {஢ઠ ᮡ }
        if not(PsetInPolygon((P.X[A]+P.X[B])/2,(P.Y[A]+P.Y[B])/2)) then goto Cross;
        {室    ᥪ  ⥭}
        goto lab1;
Cross:  Test:=0;
    end;

procedure MinDir;
{室    Source  Dest, ᪫ "㫥" }
var D : array[1..MaxN] of single;
    i,K : byte; min : single;
    T : set of byte;
begin
  for i := 1 to N do
    if G[Source,i]<small then D[i]:=many else D[i]:=G[Source,i];
  T := [];
  for i := 1 to N do include(T,i);
  while t <> [] do
    begin
      min := Many;
      for i := 1 to N do
        if (i in T) then if (D[i]<=min) then begin min := D[i]; K:=i end;
      exclude(T,K);
      for i := 1 to N do
        if (i in T) and (D[i]>D[k]+G[k,i]) and (G[k,i]>small) then D[i]:=D[k]+G[k,i];
    end;
  result := D[Dest];
end;

var F : text; I,I1 : byte;
begin
  assign(F,'INPUT.TXT');
  reset(F);
  readln(F,N);
  for I := 1 to N do readln(F,P.X[i],P.Y[i]);
  readln(F,Source, Dest);
  close(F);
  {㣮쭨 ...}
  {ந ...}
  for i := 1 to N-1 do
    begin
      G[i,i]:=0;
      for i1 := i+1 to N do
        begin
          G[i,i1]:=Test(i,i1);
          G[i1,i]:=G[i,i1];
        end;
    end;
  { ந...}
  MinDir;
end;

procedure OutResult;
var F : text;
begin
  assign(F,'OUTPUT.TXT');
  rewrite(F);
  writeln(F,Result);
  close(F);
end;

begin
  MakeGraph;
  OutResult;
end.
