#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <conio.h>
#include <string.h>
#include <mem.h>

char letter[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

struct REF
{
 char topic[40];
 char tom[10];
};

struct VOLUME
{
 char name[10];
};

class TTopic
{
 protected:
  int Topics(char *vol);
  void GetTopic(int, char *vol, char *);
  void GetTopicText(int, char *vol, char *);
  int Refs(int, char*);
  void GetRef(int, int, char *, char *topic, char *tome);
};


class TVolume
{
 public:
  TVolume();
  ~TVolume();
 protected:
  int Volumes();
  void GetVolume(int, char *);
  int GetCurrentVolume();
  void SetCurrentVolume(int);
 private:
  int nVolumes;
  VOLUME *Volume;
  int CurVol;
};

class TInterface: public TVolume,
		  public TTopic
{
 public:
  void Run();
  TInterface();
 private:
  int IsTopicPresent(char *, char *);
  void ShowVolList(char *vol);
  void ShowPrompt();
  int DoWork();
  void ShowTopic(char *tom, char *topic);
  void ShowByString(char *);
  void ClearRefInfo();
  int rrr;
  REF *rrr1;
};

void main()
{
 TInterface *t=new TInterface();
 t->Run();
};

TInterface::TInterface()
{
 rrr=0;
}

void TInterface::ShowVolList(char *vol)
{
 int b=Topics(vol);
 rrr=b;
 if(b!=0)rrr1=new REF[b];
 for(int a=0;a<b;a++)
 {
  char buf[40];
  GetTopic(a, vol, buf);
  printf("%d. %s\n", a+1, buf);
  strcpy(rrr1[a].topic, buf);
  strcpy(rrr1[a].tom, vol);
 }
 printf("\n");
}

void TInterface::Run()
{
 clrscr();
 printf("ਢ!\n\n");
 for(;;)
 {
  ShowPrompt();
  if(DoWork()==0) break;
 }
 printf("\n\n ᢨ.\n\n");
}

void TInterface::ShowPrompt()
{
 int n=GetCurrentVolume();
 char buf[10];
 GetVolume(n, buf);
 printf("%s>", buf);
}

int TInterface::DoWork()
{
 char buf[256];
 gets(buf);
 if((strcmpi(buf, "REF")==0)||(strcmpi(buf, "VOLUME")==0)||(strcmpi(buf, "TYPE")==0))
 {
  printf("ய襭 易⥫ ࠬ\n\n");
  return 1;
 }
 if(strcmpi(buf, "VERIFY")==0)
 {
  int flag=0;
  int z=0;
  for(int a=0;a<Volumes();a++)
  {
   char vol[20];
   GetVolume(a, vol);
   int n=Topics(vol);
   for(int b=0;b<n;b++)
   {
    char topic1[40];
    GetTopic(b, vol, topic1);
    int n1=Refs(b, vol);
    for(int c=0;c<n1;c++)
    {
     char top[40], tom[20];
     GetRef(c, b, vol, top, tom);
     if(strlen(tom)==0) strcpy(tom, vol);

     if(IsTopicPresent(top, tom)==-1)
     {
      if(flag==0)
       printf(" 뫪  騥 :\n");
      flag=1;
   //   if(strlen(tom)==0) strcpy(tom, vol);
      z++;
      printf("%d.  %s:%s 뫪  %s:%s\n", z, vol, topic1, tom, top);
     }
    }
   }
  }
  if(flag==0)
   printf(" 뫪 ४\n");
  printf("\n");
  return 1;
 }
 if(strncmpi(buf, "REF ", 4)==0)
 {
  int a=atoi(&buf[4]);
  char topic[40];
  char tom[40];
  if((a<0)||(a>rrr))
  {
   printf("  뫪\n\n");
   ClearRefInfo();
   return 1;
  }
  strcpy(topic, rrr1[a-1].topic);
  strcpy(tom, rrr1[a-1].tom);
  ClearRefInfo();
  ShowTopic(tom, topic);
  return 1;
 }
 if(strncmpi(buf, "TYPE ", 5)==0)
 {
  ClearRefInfo();
  char *full=&buf[5];
  char *first=strchr(full, ':');
  if(first!=0)
  {
   full[strlen(full)-strlen(first)]=0;
   first++;
//   printf("tom: %s\ntopic: %s\n", full, first);
   ShowTopic(full, first);
  }
  else
  {
   char tom[20];
   GetVolume(GetCurrentVolume(), tom);
   ShowTopic(tom, full);
//   printf("topic: %s\n", full);
  }
  return 1;
 }
 if(strcmpi(buf, "LIST")==0)
 {
  ClearRefInfo();
  char buf[256];
  GetVolume(GetCurrentVolume(), buf);
  ShowVolList(buf);
  return 1;
 }
 if(strncmpi(buf, "LIST ", 5)==0)
 {
  ClearRefInfo();
  char *v=&buf[5];
  for(int a=0;a<Volumes();a++)
  {
   char v1[20];
   GetVolume(a, v1);
   if(strcmp(v, v1)==0)
   {
    ShowVolList(v);
    return 1;
   }
  }
  printf("  \n\n");
  return 1;
 }
 if(strncmpi(buf, "VOLUME ", 7)==0)
 {
  ClearRefInfo();
  char *v=&buf[7];
  for(int a=0;a<Volumes();a++)
  {
   char v1[20];
   GetVolume(a, v1);
   if(strcmp(v1, v)==0)
   {
    SetCurrentVolume(a);
    printf("\n");
    return 1;
   }
  }
  printf("  \n");
  return 1;
 }
 if(strcmpi(buf, "CLS")==0)
 {
  ClearRefInfo();
  clrscr();
  return 1;
 }
 if(strcmpi(buf, "DIR")==0)
 {
  ClearRefInfo();
  for(int a=0;a<Volumes();a++)
  {
   char vol[10];
   GetVolume(a, vol);
   printf("%s\n", vol);
  }
  printf("\n");
  return 1;
 }
 if(strcmpi(buf, "EXIT")==0) return 0;
 ClearRefInfo();
 printf("\n ⠪ \n\n");
 return 1;
}

int TInterface::IsTopicPresent(char *topic, char *tom)
{
 for(int a=0;a<Volumes();a++)
 {
  char b[20];
  GetVolume(a, b);
  if(strcmp(b, tom)==0) break;
  if(a==Volumes()-1)
   return -1;
 }
 int t=Topics(tom);
 for(a=0;a<t;a++)
 {
  char b[40];
  GetTopic(a, tom, b);
  if(strcmp(b, topic)==0) break;
  if(a==t-1)
   return -1;
 }
 return 0;
}




void TInterface::ShowTopic(char *tom, char *topic)
{
 for(int a=0;a<Volumes();a++)
 {
  char b[20];
  GetVolume(a, b);
  if(strcmp(b, tom)==0) break;
  if(a==Volumes()-1)
  {
   printf("  \n\n");
   return;
  }
 }
 int t=Topics(tom);
 for(a=0;a<t;a++)
 {
  char b[40];
  GetTopic(a, tom, b);
  if(strcmp(b, topic)==0) break;
  if(a==t-1)
  {
   printf("  \n\n");
   return;
  }
 }
 char buf[10000];
 GetTopicText(a, tom, buf);
 ShowByString(buf);
// printf("\n");

 int b=Refs(a, tom);
 rrr=b;
 if(b!=0)
  rrr1=new REF[rrr];
 if(b!=0){
 for(int c=0;c<b;c++)
 {
  char t1[40];
  char t2[20];
  GetRef(c, a, tom, t1, t2);
  strcpy(rrr1[c].topic, t1);
  if(strlen(t2)==0)
  {
   printf("%d. %s\n", c+1, t1);
//   GetVolume(GetCurrentVolume(), rrr1[c].tom);
   strcpy(rrr1[c].tom, tom);
//   printf("%d. %s, ⮬ %s\n", c+1, t1, rrr1[c].tom);
  }
  else
  {
   strcpy(rrr1[c].tom, t2);
   if(strcmp(t2, tom)==0)
    printf("%d. %s\n", c+1, t1);
//    printf("%d. %s, ⮬ %s\n", c+1, t1, t2);
   else
    printf("%d. %s, ⮬ %s\n", c+1, t1, t2);
  }
 }
 printf("\n");
 }
}

void TInterface::ClearRefInfo()
{
 if(rrr!=0) delete[] rrr1;
 rrr=0;
}

void TInterface::ShowByString(char *b1)
{
 char *buf=b1;
 for(;;)
 {
  if(strlen(buf)<80)
  {
   printf("%s\n", buf);
   return;
  }
  if(strlen(buf)==80)
  {
   printf("%s", buf);
   return;
  }

  if(buf[80]==' ')
  {
   buf[80]=0;
   printf("%s", buf);
   buf=&buf[81];
  }
  else
  {
   char str[90];
   memcpy(str, buf, 80);
   str[80]=0;
   for(int a=79;a>=0;a--)
   {
    if((str[a]==' ')||(str[a]=='.')||(str[a]==','))
     break;
   }
   str[a+1]=0;
   printf("%s", str);
   if(a!=79) printf("\n");
   buf+=a;
   buf++;
  }
 }
}


int TTopic::Refs(int n, char *tom)
{
 char *text=new char[10000];
 char *z=text;
 GetTopicText(n, tom, text);
 char buf[256];
 GetTopic(n, tom, buf);
 text=&(text[strlen(buf)]);
 int r=0;
 for(;;)
 {
  char *b=strchr(text, ' ');
  if(b==0)break;
  if(strncmp(b, " (.", 5)==0)
  {
   char *c=&b[5];
   char *d=strchr(c, ')');
   if(d!=0)
    if(d-c<=8)
    {
     r++;
     text=d;
    }
  }
  else
   text=b+1;
 }
 delete[] z;
 return r;
}


void TTopic::GetRef(int t, int n, char *tom, char *topic, char *tm1)
{
 char *text=new char[10000];
 char *z=text;
 GetTopicText(n, tom, text);
 char buf[256];
 GetTopic(n, tom, buf);
 text+=strlen(buf);
 int r=0;
 for(;;)
 {
  if(r==t+1)break;
  char *b=strchr(text, ' ');
  if(strncmp(b, " (.", 5)==0)
  {
   char *c=&b[5];
   char *d=strchr(c, ')');
   if(d!=0)
    if(d-c<=8)
    {
     r++;
     text=d;
    }
  }
  else text=b+1;
 }
 char *e=text;
 for(;;)
 {
  if(text[0]=='(')break;
  text--;
 }
 memcpy(tm1, &text[4], e-text-4);
 tm1[e-text-4]=0;
 e=text-1;
 text-=2;
 e[0]=0;
 for(;;)
 {
  int flag=0;
  for(int a=0;a<strlen(letter);a++)
  {
   flag=1;
   if(text[0]==letter[a]) break;
   flag=0;
   continue;
  }
  if(flag==0)
  {
   strcpy(topic, &text[1]);
   delete[] z;
   return;
  }
  text--;
 }
}

int TTopic::Topics(char *vol)
{
 char file[20];
 strcpy(file, vol);
 strcat(file, ".TXT");
 FILE *f=fopen(file, "rt");
 char buf[10000];
 int ret=0;
 for(;;)
 {
  if(fgets(buf, 10000, f)!=0) ret++;
  else break;
 }
 fclose(f);
 return ret;
}

void TTopic::GetTopic(int n, char *vol, char *buf)
{
 char file[20];
 strcpy(file, vol);
 strcat(file, ".TXT");
 FILE *f=fopen(file, "rt");
 char buf_t[10000];
 for(int a=0;a<=n;a++)
  fgets(buf_t, 10000, f);
 a=-1;
 for(;;)
 {
  a++;
  if(buf_t[a]!=' ') continue;
  buf_t[a]=0;
  break;
 }
 strcpy(buf, buf_t);
 fclose(f);
}

void TTopic::GetTopicText(int n, char *vol, char *buf)
{
 char file[20];
 strcpy(file, vol);
 strcat(file, ".TXT");
 FILE *f=fopen(file, "rt");
 char buf_t[10000];
 for(int a=0;a<=n;a++)
  fgets(buf_t, 10000, f);
 strcpy(buf, buf_t);
 fclose(f);
}




TVolume::TVolume()
{
 nVolumes=0;
 CurVol=0;
 FILE *f=fopen("input.txt", "rt");

 for(;;)
 {
  char buf[256];
  if(fgets(buf, 256, f)!=0) nVolumes++;
  else break;
 }
 fclose(f);
 f=fopen("input.txt", "rt");
 Volume=new VOLUME[nVolumes];
 memset(Volume, 0, sizeof(VOLUME)*nVolumes);
 for(int a=0;a<nVolumes;a++)
  fscanf(f, "%s", Volume[a].name);
 fclose(f);
}

TVolume::~TVolume()
{
 if(nVolumes!=0)
  delete[] Volume;
}

int TVolume::Volumes()
{
 return nVolumes;
}

void TVolume::GetVolume(int n, char *buf)
{
 strcpy(buf, Volume[n].name);
}

int TVolume::GetCurrentVolume()
{
 return CurVol;
}

void TVolume::SetCurrentVolume(int n)
{
 CurVol=n;
}