{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$D-,Q-,R-,S-,I-}
{$M 65520,0,655360}
var
  p: array [1..500] of integer;
  n, m: longint;

function max (a, b: integer): integer;
begin if a>b then max:=a else max:=b end;
function min (a, b: integer): integer;
begin if a<b then min:=a else min:=b end;

{-- VLI part -------}
const
  len=4096;
type
  vli = record
    rlen: integer;
    n: array [1..len] of byte;
  end;

procedure zero (var r: vli);
var i: integer;
begin
  r.rlen:=0;
  for i:=1 to len do r.n[i]:=0;
end;

procedure shift (n: integer; var r: vli);
var i: integer;
begin
  inc(r.rlen, n);
  for i:=r.rlen-n downto 1 do r.n[i+n]:=r.n[i];
  for i:=1 to n do r.n[i]:=0;
end;

procedure cvli (a: vli; var r: vli);
var i: integer;
begin
  r.rlen:=a.rlen;
  for i:=1 to a.rlen do r.n[i]:=a.n[i];
end;

procedure add (a, b:vli; var r: vli);
var
  i: integer;
  addon: integer;
  clen: integer;
begin
  addon:=0;
  clen:=max(a.rlen, b.rlen);
  zero(r); r.rlen:=clen;
  for i:=1 to clen do begin
    r.n[i]:=addon+a.n[i]+b.n[i];
    if (r.n[i] div 10)<>0 then begin
      r.n[i]:=r.n[i] mod 10;
      addon:=1;
    end else
      addon:=0;
  end;
  if addon<>0 then begin
    inc(r.rlen);
    r.n[r.rlen]:=addon;
  end;
end;

procedure muld (n: integer; var r: vli);
var
  i, addon: integer;
  clen: integer;
begin
  if n=0 then begin
    zero(r);
    exit;
  end;

  addon:=0;
  for i:=1 to r.rlen do begin
    r.n[i]:=r.n[i]*n+addon;
    if (r.n[i] div 10)<>0 then begin
      addon:=r.n[i] div 10;
      r.n[i]:=r.n[i] mod 10;
    end else
      addon:=0;
  end;
  if addon<>0 then begin
    inc(r.rlen);
    r.n[r.rlen]:=addon;
  end;
end;

procedure mul (a, b: vli; var r: vli);
var
  i: integer;
  t: vli;
begin
  zero(r);
  for i:=1 to b.rlen do begin
    cvli(a, t);
    muld(b.n[i], t);
    shift(i-1, t);
    add(t, r, r);
  end;
end;

procedure svli (n: longint; var r: vli);
begin
  zero(r);
  while n<>0 do begin
    inc(r.rlen);
    r.n[r.rlen]:=n mod 10;
    n:=n div 10;
  end;
end;

procedure incvli (var r: vli);
var i, addon: integer;
begin
  if r.rlen=0 then r.rlen:=1;
  r.n[1]:=r.n[1]+1;
  if (r.n[1] div 10)<>0 then begin
    r.n[1]:=r.n[1] mod 10;
    addon:=1;
  end else
    addon:=0;

  for i:=2 to r.rlen do begin
    r.n[i]:=r.n[i]+addon;
    if (r.n[i] div 10)<>0 then begin
      r.n[i]:=r.n[i] mod 10;
      addon:=1;
    end else
      addon:=0;
  end;

  if addon<>0 then begin
    inc(r.rlen);
    r.n[r.rlen]:=addon;
  end;
end;

procedure fact (n: longint; var r: vli);
var
  cur: vli;
  ind: integer;
begin
  svli(1, r);
  svli(2, cur);
  for ind:=2 to n do begin
    mul(r, cur, r);
    incvli(cur);
  end;
end;
{---------}
var
  res: vli;
  num: array [1..3000] of byte;
  c: integer;
  clear: boolean;

procedure maketree (node, using : integer);
var
  i, offs, j, nroffs, u: integer;
  e, ne: array [1..2] of integer;
  clear: boolean;
begin
  clear:=true;
  for i:=1 to n do
    if num[i]=0 then begin
      clear:=false;
      break;
    end;
  if clear then exit;

  e[1]:=(node-1) div (p[using]+1);
  e[2]:=(n-node) div (p[using]+1);
  for i:=-e[1] to e[2] do begin
    offs:=node+i*(p[using]+1);
    num[offs]:=c;
  end;

  for u:=1 to m do
    if ((p[u]+1) mod (p[using]+1)<>0) then begin
      for i:=-e[1] to e[2] do begin
        offs:=node+i*(p[using]+1);
        ne[1]:=(offs-1) div (p[u]+1);
        ne[2]:=(n-offs) div (p[u]+1);
        for j:=-ne[1] to ne[2] do begin
          nroffs:=offs+j*(p[u]+1);
          if num[nroffs]=0 then begin
            maketree(nroffs, u);
            if clear then exit;
          end;
        end;
      end;
    end;
end;

procedure run;
var
  i, j: integer;
  resc: array [1..5000] of integer;
  tmp: vli;
label further;
begin
  fillchar(num, sizeof(num), 0);
  c:=0;
  for j:=1 to m do
    for i:=1 to n do
      if num[i]=0 then begin
        inc(c);
        maketree(i, j);
        if clear then goto further;
      end;
further:
  fillchar(resc, sizeof(resc), 0);
  for i:=1 to n do inc(resc[num[i]]);
  svli(1, res);
  for i:=1 to c do begin
    fact(resc[i], tmp);
    mul(res, tmp, res);
  end;
end;

procedure init;
var
  f: text;
  i: integer;
begin
  assign(f, 'input.txt');
  reset(f);
  read(f, n, m);
  for i:=1 to m do
    read(f, p[i]);
  close(f);
end;

procedure done;
var
  f: text;
  i: integer;
begin
  assign(f, 'output.txt');
  rewrite(f);
  for i:=res.rlen downto 1 do
    write(f, res.n[i]);
  close(f);
end;

begin
  init;
  run;
  done;
end.