{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
{$D-,I-,R-,Q-,S-}

const
  max=100;
type
  node=record
    x, y: real;
  end;
var
  n: longint;
  nodes: array [1..max] of node;
  res: real;

  rnum: longint;
  rn: array [1..max] of longint;

function sign (a: real): integer;
begin
  if a>0 then
    sign:=1
  else if a<0 then
    sign:=-1
  else
    sign:=0;
end;

function lominside (x, y: real): boolean;
var
  i: longint;
  n1, n2, n3: node;
  dx1, dx2, dy1, dy2: real;
  mult: integer;
  d: real;

  rins: boolean;
begin
  rins:=false;
  for i:=1 to n do begin
    n1:=nodes[i];
    n2:=nodes[(i mod n)+1];
    dx1:=n1.x-x;
    dx2:=n2.x-x;
    if sign(dx1)=-sign(dx2) then begin {different sides}
      dy1:=n1.y-x;
      dy2:=n2.y-x;
      if dx1>0 then begin
        dx1:=-dx1;
        dx2:=-dx2;
        mult:=-1;
      end else
        mult:=1;
      d:=dy1*dx2-dy2*dx1;
      if d>0 then
        rins:=not rins;
    end;
  end;
  for i:=1 to n do begin
    n1:=nodes[i];
    n2:=nodes[(i mod n)+1];
    n3:=nodes[(((i mod n)+1) mod n)+1];
    if (n2.x=x) and (n2.y>y) then
      if sign(n1.x-x)<>sign(n3.x-x) then
        rins:=not rins;
  end;
  lominside:=rins;
end;

function inside (a, b, c: real): boolean;
begin
  if ((c>a) and (c<b)) or ((c>b) and (c<a)) then
    inside:=true
  else
    inside:=false;
end;

function peres (n1, n2, n3, n4: node): boolean;
var
  r: boolean;
  dx1, dy1, dx2, dy2, d, t1, t2: real;
begin
  dx1:=n2.x-n1.x; dy1:=n2.y-n1.y;
  dx2:=n4.x-n3.x; dy2:=n4.y-n3.y;
  d:=dx1*dy2-dy1*dx2;
  r:=false;
  if d<>0 then begin
    t1:= ( dx1*(n1.y-n3.y)+dy1*(n3.x-n1.x) )/d;
    t2:=-( dx2*(n3.y-n1.y)+dy2*(n1.x-n3.x) )/d;
    if ((t1>0) and (t1<1)) and ((t2>0) and (t2<1)) then
      r:=true;
  end else
    if inside(n1.x, n2.x, n3.x) or
       inside(n1.x, n2.x, n4.x) then
      r:=true;
  peres:=r;
end;

procedure insert (val: longint; pos: longint);
var
  i: longint;
begin
  for i:=rnum downto pos do
    rn[i+1]:=rn[i];
  inc(rnum);
  rn[pos]:=val;
end;

procedure insertafter (val: longint; sval: longint);
var
  i: integer;
begin
  for i:=1 to rnum do
    if rn[i]=sval then begin
      insert(val, i+1);
      break;
    end;
end;

function track(s, e, hs, he: longint): longint;
var
  i, j: integer;
  n1, n2, n3, n4, n5: node;
  ok: boolean;
begin
  n1:=nodes[s];
  n3:=nodes[e];

  i:=hs;
  while i<>he+1 do begin
    n2:=nodes[i];
    ok:=true;
    j:=hs;
    while j<=he-1 do begin
      n4:=nodes[j];
      n5:=nodes[(j mod n)+1];
      if peres(n1, n2, n4, n5) or peres (n2, n3, n4, n5) then begin
        ok:=false;
        break;
      end;
      j:=(j mod n)+1;
    end;
    if ok then break;
    i:=(i mod n)+1;
  end;
  track:=i;
end;

procedure process (a, b: longint);
var
  r: longint;
begin
  if abs(rn[a]-rn[b])<=2 then
    exit
  else begin
    r:=track(rn[a], rn[b], rn[a]+1, rn[b]-1);
    insert(r, a+1);
    process(a, a+1); process(a+1, b+1);
  end;
end;
{
var
  n1, n2, n3, n4, nn: node;
  i: longint;
  fp, ok: boolean;
  lasttr: longint;

  dx1, dx2, dy1, dy2: real;
begin
  n1:=nodes[rn[a]];
  n2:=nodes[rn[b]];

  fp:=false; ok:=false;

  lasttr:=a+1;
  i:=rn[a]+1;
  while i<>rn[b]-1 do begin
    n3:=nodes[i];
    n4:=nodes[(i mod n)+1];
    if peres(n1, n2, n3, n4) then begin
      fp:=true;
      dx1:=n2.x-n1.x; dx2:=n3.x-n1.x;
      dy1:=n2.y-n1.y; dy2:=n3.y-n1.y;
      if (dy1*dx2-dx1*dy2)<0 then begin
        insert(i, a+1); b:=b+1;
        process(a, a+1); process(i, b);
        ok:=true;
        break;
      end else begin
        insert((i mod n)+1, a+1); b:=b+1;
        process(a, a+1); process(a+1, b);
        ok:=true;
        break;
      end;
    end;
    i:=(i mod n)+1;
  end;

  if not ok then begin
  i:=rn[b]+1;
  while i<>rn[a]-1 do begin
    n3:=nodes[i];
    n4:=nodes[(i mod n)+1];
    if peres(n1, n2, n3, n4) then begin
      fp:=true;
      dx1:=n1.x-n2.x; dx2:=n3.x-n2.x;
      dy1:=n1.y-n2.y; dy2:=n3.y-n2.y;
      if (dy1*dx2-dx1*dy2)<0 then begin
        insert(i, a+1); b:=b+1;
        process(a, a+1); process(i, b);
        break;
      end else begin
        insert((i mod n)+1, a+1); b:=b+1;
        process(a, a+1); process(a+1, b);
        break;
      end;
    end;
    i:=(i mod n)+1;
  end;
  end;

  if not fp then begin
    nn.x:=(n1.x+n2.x)/2+0.0001;
    nn.y:=(n1.y+n2.y)/2+0.0001;
    if not lominside(nn.x, nn.y) then begin
      insert(rn[a]+1, a+1);
      process(a+1, b);
    end;
  end;
end;
}

function reslen: real;
var
  r: real;
  i: longint;
  n1, n2: node;
begin
  for i:=1 to rnum-1 do begin
    n1:=nodes[rn[i]];
    n2:=nodes[rn[i+1]];
    r:=r+sqrt(sqr(n2.x-n1.x)+sqr(n2.y-n1.y));
  end;
  reslen:=r;
end;

procedure run;
begin
  process(1, 2);
  res:=reslen;
end;

procedure init;
var
  f: text;
  i: longint;
begin
  assign(f, 'input.txt');
  reset(f);

  read(f, n);
  for i:=1 to n do
    read(f, nodes[i].x, nodes[i].y);
  read(f, rn[1], rn[2]);
  rnum:=2;

  close(f);
end;

procedure done;
var
  f: text;
begin
  assign(f, 'output.txt');
  rewrite(f);
  write(f, res);
  close(f);
end;

begin
  init;
  run;
  done;
end.