{v+}
program p3116_5;
uses crt,strings;
type
  T=array[0..65500] of char;
  PT=^T;
  PVolume=^Volume;
  PInfo=^Info;

  Volume=record
    name:string[8];
    next:PVolume;
    finfo:PInfo;
  end;

  Info=record
    name:string[32];
    txt:PT;
    next:PInfo;
  end;

var
  cmd,inst:string;
  tx:text;
  fvol,chvol:PVolume;
  refs:array[1..1000] of record
    vol:PVolume;
    info:PInfo;
  end;
  nrefs:integer;

procedure up(var s:string);
var i:integer;
begin
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
end;
function strtok(var s:string;w:string):string;
var str:string;p:integer;
begin
  if s='' then begin strtok:='';exit;end;
  while s[1]=' ' do begin
    delete(s,1,1);
    if s='' then begin strtok:='';exit;end;
  end;
  p:=pos(w,s);
  if p=0 then begin strtok:=s;s:='';exit;end;
  str:=copy(s,p+1,length(s)-p);
  strtok:=copy(s,1,p-1);
  s:=str;
end;

procedure dir;
var p:PVolume;
begin
  p:=chvol;
  while p<>nil do begin
    writeln(p^.name);
    p:=p^.next;
  end;
end;

function svol(c:string):PVolume;
var p:PVolume;str:string;
begin
  p:=fvol;
  while p<>nil do begin
    str:=p^.name;
    up(str);
    if str=c then begin
      svol:=p;exit;
    end;
    p:=p^.next;
  end;
  svol:=nil;
end;
function sinfo(vol:PVolume;c:string):PInfo;
var p:PInfo;str:string;
begin
  p:=vol^.finfo;
  while p<>nil do begin
    str:=p^.name;
    up(str);
    if str=c then begin
      sinfo:=p;exit;
    end;
    p:=p^.next;
  end;
  sinfo:=nil;
end;

procedure vol;
var v:PVolume;
begin
  v:=svol(cmd);
  if v<>nil then chvol:=v;
end;


procedure list;
var vol:PVolume;i:PInfo;j:integer;
begin
  nrefs:=0;
  if cmd='' then vol:=chvol else vol:=svol(cmd);
  i:=vol^.finfo;
  j:=1;
  while i<>nil do begin
    refs[nrefs+1].vol:=vol;
    refs[nrefs+1].info:=i;
    inc(nrefs);
    writeln(j,'. ',i^.name);
    i:=i^.next;
    inc(j);
  end;
end;

procedure typeit;
var vol,rvol:PVolume;i,j,k,l:integer;inf,str:string;
    p,rinfo:PInfo;
    vstr,istr:string;
begin
  nrefs:=0;
  i:=pos(':',cmd);
  if i<>0 then begin
    vol:=svol(copy(cmd,1,i-1));
    delete(cmd,1,i);
  end else vol:=chvol;
  inf:=cmd;
  up(inf);
  p:=vol^.finfo;
  while p<>nil do begin
    str:=p^.name;
    up(str);
    if str=inf then begin
      write(p^.name,' ');
      i:=0;
      j:=length(p^.name)+1;
      while p^.txt^[i]<>#0 do begin
        while p^.txt^[i]=' ' do begin
          write(' ');inc(j);inc(i);
        end;
        j:=j mod 80;
        for k:=i to 12000 do begin
          if p^.txt^[k] in [#0,#32] then break;
        end;
        if j+k-i>79 then begin
          writeln;j:=0;
        end;
        while not (p^.txt^[i] in [#0,' ']) do begin
          write(p^.txt^[i]);
          inc(i);
          inc(j);
        end;
      end;
      if j<>0 then writeln;
      writeln;
      i:=1;
      j:=0;
      while p^.txt^[j]<>#0 do begin
        if (p^.txt^[j]='(') and
           (p^.txt^[j+1]='') and
           (p^.txt^[j+2]='') and
           (p^.txt^[j+3]='.') then begin
          k:=j;
          while not (p^.txt^[k] in [#0,')']) do inc(k);
          if p^.txt^[k]<>#0 then begin
            istr:='';
            for l:=j+4 to k-1 do istr:=istr+p^.txt^[l];
            k:=j-2;
            while (k>=0) and
              (pos(p^.txt^[k],'㪥뢠஫ᬨqwertyuiopasdfghjklzxcvbnm')<>0)
                do dec(k);
            if k>=0 then begin
              inc(k);
              vstr:='';
              while p^.txt^[k]<>' ' do begin
                vstr:=vstr+p^.txt^[k];
                inc(k);
              end;
              write(i,'. ',istr);
              if vstr<>vol^.name then writeln(', ⮬ ',vstr)
                 else writeln;
              inc(i);
              rvol:=svol(vstr);
              if rvol<>nil then begin
                rinfo:=sinfo(rvol,istr);
                if rinfo<>nil then begin
                  refs[nrefs+1].vol:=rvol;
                  refs[nrefs+1].info:=rinfo;
                  inc(nrefs);
                end else begin
                  refs[nrefs+1].vol:=nil;
                  refs[nrefs+1].info:=nil;
                end
              end else begin
                  refs[nrefs+1].vol:=nil;
                  refs[nrefs+1].info:=nil;
              end;
            end;
          end;
        end;
        inc(j);
      end;
      exit;
    end;
    p:=p^.next;
  end;



end;

procedure readdata;
var p:^PVolume;q:PVolume;
    str:string;
    f:file;
    buf:PT;
    i,j:integer;
    t:^PInfo;
begin
  p:=@fvol;
  assign(tx,'input.txt');
  reset(tx);
  while not eof(tx) do begin
    readln(tx,str);
    new(p^);
    p^^.name:=str;
    p:=@(p^^.next);
  end;
  p^:=nil;
  close(tx);
  q:=fvol;
  getmem(buf,12*1024);
  while q<>nil do begin
    t:=@q^.finfo;
    str:=q^.name;
    if pos('.',str)=0 then str:=str+'.txt';
    assign(f,str);
    reset(f,1);
    blockread(f,buf^,filesize(f));
    for i:=0 to 9 do buf^[filesize(f)+i]:=#0;
    close(f);
    i:=0;
    while buf^[i]<>#0 do begin
      while byte(buf^[i]) in [0..31] do inc(i);
      new(t^);
      t^^.name:='';
      repeat
        t^^.name:=t^^.name+buf^[i];
        inc(i);
      until buf^[i]=' ';
      inc(i);
      for j:=i to 10000 do if buf^[j]=#13 then break;
      getmem(t^^.txt,j-i+10);
      move(buf^[i],t^^.txt^,j-i);
      t^^.txt^[j-i]:=#0;
      i:=j+2;
      t:=@(t^^.next);
    end;
    t^:=nil;
    q:=q^.next;
  end;
  freemem(buf,12*1024);
end;
procedure ref;
var code,i:integer;
begin
  val(cmd,i,code);
  if (code<>0) or (i<1) or (i>nrefs) then begin
    writeln('  뫪');
    exit;
  end;
  if refs[i].vol=nil then begin
    writeln('  ');
    exit;
  end;
  if refs[i].info=nil then begin
    writeln('  ');
    exit;
  end;
  cmd:=refs[i].vol^.name+':'+refs[i].info^.name;
  up(cmd);
  typeit;
end;


begin
  readdata;
  chvol:=fvol;
  clrscr;
  nrefs:=0;
  repeat
    writeln;
    write(chvol^.name,'>');
    readln(cmd);
    up(cmd);
    inst:=strtok(cmd,' ');
    if inst='EXIT' then halt else
    if inst='VOLUME' then vol else
    if inst='DIR' then dir else
    if inst='LIST' then list else
    if inst='CLS' then clrscr else
    if inst='TYPE' then typeit else
    if inst='REF' then ref else writeln(' ⠪ ');
  until false;
end.