{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
Const MaxPeak = 100;
      Delta : Real = 0.0000001;
      MaxReal = 1e37;

Type
TPoint = record
  X,Y : Real;
End;
TLine = record
  A,B,C : Real;
End;
TSegment = record
  A,B : TPoint;
End;
TPolygon = record
  N : Integer;
  A : Array[1..MaxPeak] of TPoint;
End;

Var K,L : Byte;
Po,Q : TPolygon;
A,B,C,I1,I2 : LongInt;
R,Min,Sum : Real;
P1,P2,_Point : TPoint;
S1,S2 : TSegment;
P : Array[1..MaxPeak,1..MaxPeak] of Boolean;
T : Array[1..MaxPeak] of Boolean;
Pa : Array[1..MaxPeak] of record
                            A : Real;
                            B : Boolean;
                            P : Byte;
                          End;

Procedure ReadFile;
Begin
  Assign(Input,'input.txt');
  ReSet(Input);
  Read(Po.N);
  For A:=1 to Po.N do
  Begin
    Read(Po.A[A].X);
    Read(Po.A[A].Y);
  End;
  Read(K);
  Read(L);
  Close(Input);
End;

Function Compare(A1,A2 : Real) : ShortInt;
Begin
  If a1-a2>Delta then Compare:=1 else
  If a2-a1>Delta then Compare:=-1 else Compare:=0;
End;

Function EqlPoints(P1,P2 : TPoint) : Boolean;
Begin
  EqlPoints:=(Compare(P1.X,P2.X)=0) and (Compare(P1.Y,P2.Y)=0);
End;

Function LenPoints(P1,P2 : TPoint) : Real;
Begin
  LenPoints:=Sqrt(Sqr(P1.X-P2.X)+Sqr(P1.Y-P2.Y));
End;

Procedure MakeLine(Var L : TLine;P1,P2 : TPoint);
Begin
  L.A:=P1.Y-P2.Y;
  L.B:=P2.X-P1.X;
  L.C:=P1.X*P2.Y-P2.X*P1.Y;
End;

Function CrossLines(Var P : TPoint;L1,L2 : TLine) : Boolean;
Var D : Real;
Begin
  D:=L1.A*L2.B-L2.A*L1.B;
  If Compare(D,0)=0 then CrossLines:=False else
  Begin
    CrossLines:=True;
    P.X:=(L2.C*L1.B-L1.C*L2.B)/D;
    P.Y:=(L2.A*L1.C-L1.A*L2.C)/D;
  End;
End;

Function CrossSL(Var P : TPoint;S : TSegment;L : TLine) : Boolean;
Var L1 : TLine;
Begin
  If Compare((L.A*S.A.X+L.B*S.A.Y+L.C)*(L.A*S.B.X+L.B*S.B.Y+L.C),0)=1 then
    CrossSL:=False else
    Begin
      CrossSL:=True;
      MakeLine(L1,S.A,S.B);
      CrossLines(P,L,L1);
    End;
End;

Function CrossSeg(Var P : TPoint;S1,S2 : TSegment) : Boolean;
Var L1,L2 : TLine;
Begin
  MakeLine(L1,S1.A,S1.B);
  MakeLine(L2,S2.A,S2.B);
  If CrossSL(_Point,S1,L2) and CrossSL(_Point,S2,L1) then
  Begin
    CrossSeg:=True;
    CrossLines(P,L1,L2);
  End else
    CrossSeg:=False;
End;

Function InSidePoly(P : TPoint;Var Poly : TPolygon) : Boolean;
Var I,K : Integer;
O,M : TPoint;
L : TLine;
S : TSegment;
Begin
  L.A:=0;
  L.B:=1;
  L.C:=-P.Y;
  k:=0;
  S.A:=Poly.A[Poly.N];
  For i:=1 to Poly.N do
  Begin
    S.B:=Poly.A[i];
    If Compare(S.A.Y,S.B.Y)=1 then M:=S.A else
                                   M:=S.B;
    If CrossSL(O,S,L) then
      If not EqlPoints(O,M) and (Compare(O.X,P.X)>=0) then
      inc(k);
    S.A:=S.B;
  End;
  InSidePoly:=k and 1=1;
End;

Procedure Div2(var P : TPoint;P1,P2 : TPoint);
Begin
  P.X:=P1.X+(P2.X-P1.X)/2;
  P.Y:=P1.Y+(P2.Y-P1.Y)/2;
End;

Function CanPass(A1,A2 : LongInt) : Boolean;
Var A : LongInt;
Begin
  S1.A:=Po.A[A1];
  S1.B:=Po.A[A2];
  For A:=1 to Po.N do
  Begin
    S2.A:=Po.A[A];
    If A=Po.N then
      S2.B:=Po.A[1] else
      S2.B:=Po.A[A+1];
    If not (EqlPoints(S1.A,S2.A) or EqlPoints(S1.A,S2.B) or
            EqlPoints(S1.B,S2.A) or EqlPoints(S1.B,S2.B)) then
    If CrossSeg(P1,S1,S2) then
    Begin
      CanPass:=False;
      Exit;
    End;
  End;
  Div2(P1,S1.A,S1.B);
  CanPass:=InSidePoly(P1,Po);
End;

Procedure Work;
Begin
  Assign(Output,'output.txt');
  ReWrite(Output);
  {  設  ᮥ १ }
  FillChar(P,SizeOf(P),False);
  For A:=1 to Po.N-1 do
  Begin
    P[A,A+1]:=True;
    P[A+1,A]:=True;
  End;
  P[K,L]:=CanPass(K,L);
  P[L,K]:=P[K,L];
  P[1,Po.N]:=True;
  P[Po.N,1]:=True;
  If P[k,l] then
  Begin
    WriteLn(LenPoints(Po.A[K],Po.A[L]));
    Close(Output);
    Halt(0);
  End;
  For A:=1 to Po.N-1 do
    For B:=A+1 to Po.N do
    If Not P[A,B] then
    Begin
      P[A,B]:=CanPass(A,B);
      P[B,A]:=P[A,B];
    End;
  For A:=1 to Po.N do
  Begin
    Pa[A].A:=MaxReal;
    Pa[A].P:=0;
    Pa[A].B:=False;
  End;
  Pa[k].P:=101;
  Pa[k].B:=True;
  Pa[k].A:=0;
  For A:=1 to Po.N do
  Begin
    C:=0;
    Min:=MaxReal;
    For B:=1 to Po.N do
      If Pa[B].B and (Compare(Min,Pa[B].A)=1) then
      Begin
        Min:=Pa[B].A;
        C:=B;
      End;
    For B:=1 to Po.N do
      If (C<>B) and P[C,B] then
      Begin
        R:=LenPoints(Po.A[C],Po.A[B]);
        If Compare(Pa[B].A,R+Pa[C].A)=1 then
        Begin
          Pa[B].A:=R+Pa[C].A;
          Pa[B].P:=C;
          Pa[B].B:=True;
        End;
      End;
    Pa[C].B:=False;
  End;
{  A:=l;
  Sum:=0;
  Repeat
    Sum:=Sum+LenP;
    A:=Pa[A].P;
  Until A=k;}
  WriteLn(Pa[l].A);
  Close(Output);
  Release(HeapOrg);
End;

Begin
  ReadFile;
  Work;
End.