Program Macro;

{ Problem 1
  by Nick V. Durov }

Type
  Arr      = Array [0..1023] Of Word;
  PArr     = ^Arr;

Var
  A, B     : Arr;
  T        : Array [0..239] Of PArr;

  K, N, M  : Word;
  Words    : Array [1..50] Of String[7];
  LW, PW   : Array [1..50] Of Word;
  Pnl      : Array [1..50] Of Word;
  AddPen   : Array [0..4095] Of Word;


Function Str2Num (S : String) : Word;
Var i, R : Word;
Begin
  R := 0;
  For i:=1 To Length(S) Do
    Begin
      R := R Shl 2;
      Case S[i] Of
      'W' : R := R + 1;
      'I' : R := R + 2;
      'N' : R := R + 3;
      End
    End;
  Str2Num := R;
End;

Procedure Process0;
Var
  i  : Word;
Begin
  For i:=1 To M Do
    Begin
      LW[i] := Length (Words [i]);
      PW[i] := Str2Num (Words [i])
    End
End;

Procedure CalcAddPen;
Var
  i, j, f, k, N   : Word;
Begin
  For i:=0 To 4095 Do AddPen[i] := 0;
  For j:=1 To M Do
    Begin
      f:=1;
      N := PW[j];
      k := Pnl [j];
      While ((N And (f*3))<>0) Do f:=f*4;
      Repeat
        AddPen[N] := AddPen[N] + k;
        N := N + f
      Until N >= 4096
    End;
End;

Procedure InitAB;
Var i : Word;
Begin
  For i:=0 To 1023 Do A[i] := 30000;
  For i:=0 To 1023 Do B[i] := 30000;
  A[0] := 0;
  K := 0;
  New (T[0]);
  T[0]^ := A;
End;

Function C (i : Word) : Word;
Begin
  C := B[i shr 2] + AddPen[i];
End;

Procedure CalcA;
Var
  i, j, k, R, S        : Word;
Begin
  For i:=0 To 1023 Do
    If (i And 3) = 0 Then A[i]:=30000 Else
      Begin
        j:=i; R:=30000;
        Repeat
          S := C(j);
          If S<R Then R:=S;
          j := j + 1024
        Until j>=4096;
        A[i] := R
      End
End;

Procedure MakeStep;
Begin
  Inc (K);
  New (T[K]);
  B := A;
  CalcA;
  T[K]^ := A
End;

Var
  Res, Rw       : Word;
  Ri            : Word;
  RS            : String;

Procedure GetRsStep;
Var j, Nj      : Word;
Begin
  j := Ri;
  Repeat
    If C(j) = Rw Then Nj := j;
    j := j + 1024
  Until j>=4096;
  Rw := Rw - AddPen[Nj];
  Case Nj And 3 Of
  1:   RS := 'W' + RS;
  2:   RS := 'I' + RS;
  3:   RS := 'N' + RS;
  End;
  Ri := Nj Shr 2;
  A := B;
  Dispose (T[K]);
  Dec (K);
  If K>0 Then B := T[K-1]^;
End;

Procedure GetRes;
Var i : Word;
Begin
  Res := 30000;
  Ri := 0;
  For i:=0 To 1023 Do
    If A[i]<Res Then Begin Res:=A[i]; Ri:=i End;
  Rw := Res;
  RS := '';
  While K>0 Do GetRsStep;
End;

Var
  S            : String;
  i, fenka     : Word;

Begin
  Assign (Input, 'INPUT.TXT');
  Reset (Input);
  Read (N);  ReadLn(M);
  For i:=1 To M Do
    Begin
      ReadLn (S);
      While S[1]=' ' Do Delete (S, 1, 1);
      Words [i] := Copy (S, 1, Pred (Pos (' ', S)));
      Delete (S, 1, Pos (' ', S));
      While S[1]=' ' Do Delete (S, 1, 1);
      While S[Length(S)]=' ' Do Delete (S, Length(S), 1);
      Val (S, Pnl[i], fenka)
    End;
  Process0;
  CalcAddPen;
  InitAB;
  For i:=1 To N Do MakeStep;
  GetRes;
  Assign (Output, 'OUTPUT.TXT');
  ReWrite (Output);
  WriteLn (Res);
  WriteLn (RS)
End.
