Program Macro;
{$X+}
Uses Crt, Strings;

Var
  Files, Vols   : Integer;
  CurVol        : Integer;
  Ptr           : Array [0..4095] Of PChar;
  Len           : Array [0..4095] Of Integer;
  Refs          : Array [0..4095] Of PChar;
  RefCnt        : Integer;
  All           : Array [0..16383] Of Char;
  ReadBytes     : Integer;
  Stop          : Boolean;
  Comm, Pars    : String;
  Err           : Integer;
  RefAllowed    : Boolean;

Procedure ReadF (S : String);
Var
   F : File;
   L : Integer;
Begin
  Assign (F, S);
  Reset (F, 1);
  BlockRead (F, All[ReadBytes], 16383-ReadBytes, L);
  Close (F);
  Ptr [Files] := @All[ReadBytes];
  Len [Files] := L;
  Inc (Files);
  ReadBytes := ReadBytes + L;
  All [ReadBytes] := #0;
  Inc (ReadBytes);
  If ReadBytes = 16384 Then RunError (239)
End;

Procedure SkipSpc (Var P : PChar);
Begin
  While P[0] in [' '] Do Inc(P)
End;

Function TestEnd (Var P : PChar) : Boolean;
Begin
  TestEnd := (P[0] = #0)
End;

Function GetWord (Var P : PChar) : String;
Var S : String;
Begin
  S := '';
  SkipSpc (P);
  Repeat
    Inc (S[0]);
    S [Length(S)] := P[0];
    Inc (P)
  Until P[0] in [' ',#13,#0];
  GetWord := S;
End;

Function GetWordU (Var P : PChar) : String;
Var S : String;
Begin
  S := '';
  SkipSpc (P);
  Repeat
    Inc (S[0]);
    S [Length(S)] := UpCase (P[0]);
    Inc (P)
  Until P[0] in [' ',#13,#0];
  GetWordU := S;
End;

Procedure ToEOL (Var P : PChar);
Begin
  While Not (P[0] in [#13,#0]) Do Inc(P);
  If P[0]=#13 Then Begin Inc(P); Inc(P) End;
End;

Function Nth (P : PChar; i : Integer) : String;
Begin
  While i>1 Do Begin ToEOL(P); Dec(i) End;
  Nth := GetWord (P)
End;

Function SearchWord (Var Q : PChar; Var S : String) : Integer;
Var i : Integer;
    T : String;
    P : PChar;
Begin
  P:=Q;
  i:=0;
  SkipSpc (P);
  While Not TestEnd (P) Do
    Begin
      Inc(i);
      Q := P;
      T := GetWord (P);
      If T=S Then Begin SearchWord:=i; Exit End;
      ToEOL (P);
      SkipSpc (P)
    End;
  SearchWord := 0
End;

Function SearchWordU (Var Q : PChar; Var S : String) : Integer;
Var i : Integer;
    T : String;
    P : PChar;
Begin
  For i:=1 To Length(S) Do S[i] := UpCase (S[i]);
  P:=Q;
  i:=0;
  SkipSpc (P);
  While Not TestEnd (P) Do
    Begin
      Inc(i);
      Q := P;
      T := GetWordU (P);
      If T=S Then Begin SearchWordU:=i; Exit End;
      ToEOL (P);
      SkipSpc (P)
    End;
  SearchWordU := 0
End;

Function Vol2Num (S : String) : Integer;
Var P : PChar;
Begin
  P := Ptr[0];
  Vol2Num := SearchWordU (P, S);
End;


Procedure ReadAllFiles;
Var
   i   : Integer;
   P   : PChar;
   S   : String;
Begin
  For i:=0 To 4095 Do Begin Ptr[i] := Nil; Len[i] := 0 End;
  FillChar (All, SizeOf (All), 0);
  Files := 0;
  ReadBytes := 0;
  ReadF ('INPUT.TXT');
  P := Ptr[0];
  Repeat
    S := GetWord (P);
    ToEOL (P);
    If S<>'' Then ReadF (S+'.txt')
  Until TestEnd (P);
  Vols := Files - 1;
End;

Procedure WritePrompt;
Begin
  WriteLn;
  Write (Nth (Ptr[0], CurVol), '>');
End;

Procedure GetCommand;
Var i : Integer;
Begin
  ReadLn (Comm);
  Pars := '';
  i := Pos (' ',Comm);
  If i > 0 Then
    Begin
      Pars := Copy (Comm, i+1, 255);
      Comm[0] := Chr (i-1)
    End;
  For i:=1 To Length(Comm) Do Comm[i] := UpCase (Comm[i]);
End;

Procedure ExecDIR;
Var i : Integer;
Begin
  For i:=1 To Vols Do
    WriteLn (Nth (Ptr[0], i));
End;

Procedure ExecVOLUME;
Var i : Integer;
Begin
  If Pars='' Then Begin Err:=2; Exit End;
  i := Vol2Num (Pars);
  If i=0 Then Err:=2 Else CurVol:=i
End;

Procedure ExecLIST;
Var
  V, i  : Integer;
  P     : PChar;
  S     : String;
Begin
  If Pars='' Then V:=CurVol Else V:=Vol2Num(Pars);
  If V=0 Then Begin Err:=2; Exit End;
  i := 0;
  P := Ptr[V];
  SkipSpc (P);
  RefCnt := 0;
  Repeat
    Inc (i);
    Refs [i] := P;
    WriteLn(i,'. ', GetWord(P));
    ToEOL (P)
  Until TestEnd (P);
  RefCnt := i;
End;

Procedure DispReference (P : PChar; Num, Volume : Integer);
Var   Q                 : PChar;
      S1, S2            : String;
Begin
  Q := P;
  Dec (P);
  Repeat
    Dec (P)
  Until Not (P[0] in ['A'..'Z','a'..'z',''..'',#224..#239,''..'']);
  S1 := '';
  Inc(P);
  Repeat
    S1 := S1 + P[0];
    Inc(P);
  Until P[0] = ' ';
  P := P + 5;
  S2 := '';
  If P[0] <> ')' Then
  Repeat
    S2 := S2 + P[0];
    Inc(P)
  Until P[0] = ')';
  If S2 = Nth (Ptr[0], Volume) Then S2:='';
  Write (Num,'. ',S1);
  If S2 = '' Then WriteLn Else WriteLn (', ⮬ ',S2);
End;

Procedure Display (Volume : Integer; P : PChar);
Var
  Q, QQ          : PChar;
  S, Pr1         : String;
  Ps, Spc, T, i  : Integer;
Begin
  Q := P;
  Pr1 := '@@@';
  Ps := 0;
  RefCnt := 0;
  Repeat
    Spc := 0;
    While P[0]=#32 Do Begin Inc(P); Inc(Spc) End;
    QQ := P;
    S := GetWord (P);
    If (Spc=1) And (Copy(S,1,4)='(.') And (Pr1<>'@@@') And (Pos(')',S)<>0) Then
      Begin
        Inc (RefCnt);
        Refs [RefCnt] := QQ
      End;
    Pr1 := S;
    If Ps = 0 Then Spc := 0;
    T := Ps + Spc + Length(S);
    If T<=80 Then
      Begin
        For i:=1 To Spc Do Write(' ');
        Write (S);
        Ps := T;
        If Ps=80 Then Ps := 0;
      End
    Else
      Begin
        WriteLn;
        Write (S);
        Ps := Length (S)
      End
  Until P[0] in [#13,#0];
  WriteLn;
  If RefCnt>0 Then
    Begin
      WriteLn;
      For i:=1 To RefCnt Do
        DispReference (Refs[i], i, Volume)
    End;
End;

Procedure ExecTYPE;
Var
  V, i     : Integer;
  P        : PChar;
Begin
  If Pars='' Then Begin Err:=3; Exit End;
  i := Pos (':', Pars);
  V := CurVol;
  If i>0 Then
    Begin
      V := Vol2Num (Copy(Pars,1,i-1));
      If V=0 Then Begin Err:=2; Exit End;
      Delete (Pars, 1, i)
    End;
  P := Ptr [V];
  If SearchWord (P, Pars) = 0 Then Begin Err:=3; Exit End;
  Display (V, P)
End;

Procedure ExecCLS;
Begin
  ClrScr;
End;

Procedure ProcRef (P : PChar);
Var
  S1, S2   : String;
  Q        : PChar;
  V        : Integer;
Begin
  Q := P;
  If P[0]='(' Then
    Begin
      Dec (P);
      Repeat
        Dec (P)
      Until Not (P[0] in ['A'..'Z','a'..'z',''..'',#224..#239,''..'']);
      S1 := '';
      Inc(P);
      Repeat
        S1 := S1 + P[0];
        Inc(P);
      Until P[0] = ' ';
      P := P + 5;
      S2 := '';
      If P[0] <> ')' Then
      Repeat
        S2 := S2 + P[0];
        Inc(P)
      Until P[0] = ')';
      Pars := S1;
      If S2 = '' Then
        Begin
          V := 1;
          While (V<Vols) And (Ofs(P[0])>=Ofs(Ptr[V+1,0])) Do Inc(V);
          S2 := Nth (Ptr[0], V);
        End;
      Pars := S2 + ':' + S1;
      ExecTYPE;
    End
  Else
    Begin
      V := 1;
      While (V<Vols) And (Ofs(P[0])>=Ofs(Ptr[V+1,0])) Do Inc(V);
      Display (V, P)
    End;
End;


Procedure ExecREF;
Var
  i, code          : Integer;
Begin
  If Not RefAllowed Then Begin Err:=4; Exit End;
  Val (Pars, i, code);
  If (code<>0) Or (i<1) Or (i>RefCnt) Then Begin Err:=4; Exit End;
  ProcRef (Refs[i])
End;

Procedure ExecVERIFY;
Var V, i, Ou            : Integer;
    P, Q                : PChar;
    Vol, Art            : String;

Procedure IncRef (S1, S2  : String);
Begin
  If Ou=0 Then WriteLn (' 뫪  騥 :');
  Inc (Ou);
  WriteLn (Ou,'.  ',Vol,':',Art,' 뫪  ',S2,':',S1)
End;

Procedure VerifyRef (P : PChar; V, N : Integer);
Var
  S1, S2        : String;
  VV            : Integer;
  Q             : PChar;
Begin
  Dec (P);
  Repeat
    Dec (P)
  Until Not (P[0] in ['A'..'Z','a'..'z',''..'',#224..#239,''..'']);
  S1 := '';
  Inc(P);
  Repeat
    S1 := S1 + P[0];
    Inc(P);
  Until P[0] = ' ';
  P := P + 5;
  S2 := '';
  If P[0] <> ')' Then
  Repeat
    S2 := S2 + P[0];
    Inc(P)
  Until P[0] = ')';
  If S2='' Then S2 := Nth (Ptr[0], V);
  VV := Vol2Num (S2);
  Q := Ptr[VV];
  If VV=0 Then IncRef(S1,S2) Else
    If SearchWord (Q, S1) = 0 Then IncRef (S1, S2)
End;

Procedure Verify (V, N : Integer; P : PChar);
Var
  Spc           : Integer;
  QQ            : PChar;
  S, Pr1        : String;
Begin
  Pr1 := '@@@';
  Repeat
    Spc := 0;
    While P[0]=#32 Do Begin Inc(P); Inc(Spc) End;
    QQ := P;
    S := GetWord (P);
    If (Spc=1) And (Copy(S,1,4)='(.') And (Pr1<>'@@@') And (Pos(')',S)<>0) Then
      Begin
        VerifyRef (QQ, V, N)
      End;
    Pr1 := S;
  Until P[0] in [#13,#0];
End;

Begin
  Ou := 0;
  For V:=1 To Vols Do
    Begin
      Vol := Nth (Ptr[0], V);
      P := Ptr[V];
      i := 0;
      Repeat
        Inc (i);
        Q := P;
        Art := GetWord (P);
        Verify (V, i, Q);
        ToEOL (P)
      Until TestEnd (P);
    End;
  If Ou=0 Then WriteLn (' 뫪 ४');
End;

Procedure Interpret;
Begin
  Stop := False;
  Err  := 0;
  If Comm = 'DIR'    Then ExecDIR       Else
  If Comm = 'VOLUME' Then ExecVOLUME    Else
  If Comm = 'LIST'   Then ExecLIST      Else
  If Comm = 'TYPE'   Then ExecTYPE      Else
  If Comm = 'REF'    Then ExecREF       Else
  If Comm = 'CLS'    Then ExecCLS       Else
  If Comm = 'VERIFY' Then ExecVERIFY    Else
  If Comm = 'EXIT'   Then Stop := True  Else
  Err := 1;
  Case Err Of
  1:     WriteLn (' ⠪ ');
  2:     WriteLn ('  ');
  3:     WriteLn ('  ');
  4:     WriteLn ('  뫪');
  End;
  RefAllowed := ((Comm='TYPE') Or (Comm='LIST') Or (Comm='REF')) And (Err=0);
End;


Begin
  ReadAllFiles;
  WriteLn;
  WriteLn ('ਢ!');
  CurVol := 1;
  RefAllowed := False;
  Repeat
    WritePrompt;
    GetCommand;
    Interpret
  Until Stop;
  WriteLn (' ᢨ.');
  WriteLn
End.
