Program Macro;
{$N+,E+}

Type
  Float = Extended;
  Point = Record  X, Y : Float End;
Const
  eps   = 1e-12;
Var
  N     : Integer;
  P     : Array [0..100] Of Point;
  G     : Array [1..100, 1..100] Of Boolean;
  Mark  : Array [1..100] Of Boolean;
  D     : Array [1..100] Of Real;
  k, l  : Integer;
  Result: Float;
  MaxX, MaxY  : Float;
  CP          : Point;

Procedure MakeInput;
Var i : Integer;
Begin
  Assign (Input, 'INPUT.TXT');
  ReSet (Input);
  Read (N);
  For i:=1 To N Do Read(P[i].X, P[i].Y);
  Read (k, l);
  MaxX := P[1].X;  MaxY := P[1].Y;
  For i:=1 To N Do If P[i].X > MaxX Then MaxX := P[i].X;
  For i:=1 To N Do If P[i].Y > MaxY Then MaxY := P[i].Y;
  CP.X := MaxX + 1.7  * Abs (MaxX);
  CP.Y := MaxY + 2.39 * Abs (MaxY);
  P[0] := P[N];
End;

Function Between (Var A, B, C : Point) : Boolean;
Begin
  If (abs(A.X-C.X)>eps) Then
    Begin
      If A.X < C.X Then Between := (A.X < B.X) And (B.X < C.X)
                   Else Between := (A.X > B.X) And (B.X > C.X);
    End
  Else
    Begin
      If A.Y < C.Y Then Between := (A.Y < B.Y) And (B.Y < C.Y)
                   Else Between := (A.Y > B.Y) And (B.Y > C.Y);
    End
End;

Function Intersect (Var A, B, C, D   : Point) : Boolean;
Var
  c11, c12, c13, c21, c22, c23  : Float;
  det, detX, detY               : Float;
  P                             : Point;
Begin
  c11 := B.Y - A.Y;
  c12 := A.X - B.X;
  c13 := c11*A.X + c12*A.Y;
  c21 := D.Y - C.Y;
  c22 := C.X - D.X;
  c23 := c21*C.X + c22*C.Y;
  det  := c11*c22 - c12*c21;
  detX := c13*c22 - c12*c23;
  detY := c11*c23 - c13*c21;
  If Abs(det)<eps Then
    Begin
      If (abs(detX)>eps) Or (abs(detY)>eps) Then
        Begin Intersect := False; Exit End;
      Intersect := True;
      Exit
    End;
  P.X := detX / det;
  P.Y := detY / det;
  Intersect := Between (A, P, B) And Between (C, P, D)
End;


Function IsIn (Var Pt : Point) : Boolean;
Var
  C     : Integer;
  i     : Integer;
Begin
  C := 0;
  For i:=1 To N Do
    If Intersect (Pt, CP, P[i-1], P[i]) Then Inc (C);
  IsIn := Odd (C)
End;


Function GetR (N1, N2 : Integer) : Boolean;
Var
  P1, P2, P3, P4 : Point;
  i              : Integer;
Begin
  i := Abs (N1-N2);
  If (i=1) Or (i=N-1) Then Begin GetR := True; Exit End;
  GetR := False;
  P1 := P[N1];
  P2 := P[N2];
  For i:=1 To N Do
    Begin
      P3 := P[i-1];
      P4 := P[i];
      If Intersect (P1, P2, P3, P4) Then Exit
    End;
  P3.X := (P1.X + P2.X) / 2;
  P3.Y := (P1.Y + P2.Y) / 2;
  GetR := IsIn (P3)
End;

Function Dst (i, j  : Integer) : Float;
Begin
  Dst := Sqrt (Sqr (P[i].X - P[j].X) + Sqr (P[i].Y - P[j].Y))
End;

Procedure Solve;
Var
  i, j, BN   : Integer;
  BD, TD     : Float;
Begin
  For i:=1 To N Do
    For j:=1 To N Do
      If i=j Then G[i,j]:=False Else
        G[i,j] := GetR (i, j);
  FillChar (Mark, SizeOf (Mark), 0);
  Mark [k] := True;
  D [k] := 0;
  Repeat
    BD := 1e20;
    For i:=1 To N Do
      If Mark[i] Then
        For j:=1 To N Do
          If (Not Mark[j]) And G[i,j] Then
            Begin
              TD := D[i] + Dst (i,j);
              If TD<BD Then Begin BD:=TD; BN:=j End
            End;
    Mark [BN] := True;
    D [BN] := TD;
  Until Mark[l];
  Result := D[l]
End;

Procedure MakeOutput;
Begin
  Assign (Output, 'OUTPUT.TXT');
  ReWrite (Output);
  WriteLn (Result:10:10)
End;

Begin
  MakeInput;
  Solve;
  MakeOutput
End.
