{$A+,B-,D-,E-,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}

Program Flow_Lines;

Const
  NoSol = 'Impossible';
  Nmax = 10;  { ᨬ쭮 ⢮  }
  Eps = 1e-6; { 樫 }
  Inf = 1e37; { ᪮筮 }

Type
  Real = Extended; {  筮 ᫥ }
  { ଠ஢ ࠢ אַ }
  TLine = Record
            A, B, C : Real;
            Vx, Vy : Real
          End;
  { 窠 }
  TPoint = Record X, Y : Real End;

Var
  N, m : word; { ⢮   㤠  ਤ }
  R : TPoint;  { 砫쭮  ஡ }
  U : Real;    { ᪮ ஡ }
  Lines : array [0..Nmax]of TLine; {    ᪮ }
  Matr : array [0..Nmax, 0..Nmax]of Real; {  ⥩ }
  Cnt : array [0..Nmax, 0..Nmax]of byte;

{ ଠ ࠢ אַ }
Procedure Normalize (Var L : TLine);
Var R : Real;
Begin
  R := Sqrt (Sqr(L.A)+Sqr(L.B));
  L.A := L.A / R;
  L.B := L.B / R;
  L.C := L.C / R
End;  (*  Normalize  *)


{ ஢ઠ  ࠢ⢮  ⢥ ᥫ }
Function Eq (X, Y : Real) : boolean;
Begin
  Eq := Abs (X-Y) < Eps
End;  (*  Eq *)


{ ࠢ  ⢨⥫ ᫠ }
Function Less (X, Y : Real) : boolean;
Begin
  Less := Y-X > Eps
End;  (* Less *)


{   窠 -  }
Procedure Point2Line (Const P1, P2 : TPoint; Var L : TLine);
Begin
  L.A := P1.Y-P2.Y;
  L.B := P2.X-P1.X;
  L.C := P1.X*P2.Y-P1.Y*P2.X;
  Normalize (L)
End;  (*  Point2Line  *)


{ 祭   --> 窠 }
Function Line2Point (Const L1, L2 : TLine; Var P : TPoint) : boolean;
Var R : Real;
Begin
  R := L1.A*L2.B-L1.B*L2.A;
  If Eq (R, 0) then
    Line2Point := false
  Else Begin
    Line2Point := true;
    P.X := (L1.B*L2.C-L1.C*L2.B)/R;
    P.Y := (L1.C*L2.A-L1.A*L2.C)/R
  End
End;


{ ஢ઠ ਭ 窨 אַ }
Function PointOnLine (Const P : TPoint; Const L : TLine) : boolean;
Begin
  PointOnLine := Eq (L.A*P.X+L.B*P.Y+L.C, 0)
End;  (* PointOnLine *)


{ 楤 砫쭮 樠樨 }
Procedure Init;
Begin
  Assign (InPut, 'INPUT.TXT');
  ReSet (Input);
  Assign (OutPut, 'OUTPUT.TXT');
  Rewrite (OutPut)
End;  (*  Init  *)


{ 楤 室 }
Procedure Done;
Begin
  Close (Input);
  Close (OutPut);
  Halt
End;  (*  Done  *)


{  砫  }
Procedure ReadData;
Var i : word;
    P1, P2 : TPoint;
Begin
  Read (N, m);
  Read (R.x, R.y, U);
  For i := 1 to N do
   With Lines[i] do Begin
     Read (P1.x, P1.y, P2.x, P2.y);
     Point2Line (P1, P2, Lines[i]);
     Normalize (Lines [i]); { ଠ㥬 }
     Read (Vx, Vy)
   End
End;  (*  ReadData  *)


{ 뢮 १ }
Procedure OutResult (Dist : Real; Cnt : word);
Begin
  If Not Eq (Dist, Inf) then { ᫨  ன } Begin
    WriteLn (Dist:5:10,#10#13,Cnt);
    Close (OutPut);
    Halt (Cnt)
  End
  Else
    WriteLn (NoSol);
End;  (*  OutResult  *)


{ ६頥   ६ }
Procedure Move (Const L : TLine; Var L2 : TLine; T : Real);
Begin
  L2.A := L.A;
  L2.B := L.B;
  L2.C := -(L.A*L.Vx+L.B*L.Vy)*T+L.C;
  L2.Vx := L.Vx;
  L2.Vy := L.Vy;
  Normalize (L2)
End;  (*  Move  *)


{ ﭨ  窠 }
Function Dist (P1, P2 : TPoint) : Real;
var r : real;
Begin
  Dist := Sqrt (Sqr(P1.X-P2.X) + Sqr(P1.Y-P2.Y));
  r := Sqrt (Sqr(P1.X-P2.X) + Sqr(P1.Y-P2.Y))
End;  (* Dist *)


{ 頥 쭮 ६ 室   窨  㣮  אַ }
Function GetTime (L, L2 : TLine; p : Tpoint) : Real;
Var r : integer;
    r2, Res : TPoint;
    vr : TPoint;
    v, u1 : real;
Begin
  Line2Point(l, l2, res);
  If Eq (Dist(res,p),0) then
    GetTime:=0
  Else Begin
    vr.x:=l2.vx-l.vx;
    vr.y:=l2.vy-l.vy;
    v := (vr.x*l2.a+vr.y*l2.b)/(l.a*l2.b-l.b*l2.a);
    u1:=((res.x-p.x)*(-l.b)+(res.y-p.y)*l.a)/Dist(res,p);
    If u1<0 then Begin u1:=-u1*u; v:=-v; End
    Else u1:=u1*u;
    If u1<=v+eps then
      GetTime := Inf
    Else
      GetTime := Dist(res,p)/(u1-v);
  End
End;  (*  GetTime  *)


{ 楤 宦  אַ }
Procedure Go (i, j : word; T : Real);
Var L : array [0..Nmax] of TLine;
    k : word;
    t1 : Real;
    F : TPoint;
Begin
  { ᤢ   ६ }
  L[0] := Lines [0];
  For k := 1 to N do
   Move (Lines[k], L[k], T);
  Line2Point (L[i], L[j], F);

  { 蠥 ६, ᫨   }
  For k := 1 to N do
   If (j<>k) and (i<>k) then Begin
     t1 := GetTime (L[i], L[k], F);
     If Less (Matr[i,j] + t1, Matr [i,k]) then Begin
       Cnt [i,k] := Cnt [i,j] + 1;
       Matr [i,k] := Matr [i,j] + t1;
       Cnt [k,i] := Cnt [i,k];
       Matr [k,i] := Matr [i,k]
     End
   End
End;  (*  Go  *)


Procedure Solve;
Var P : TPoint;
    i, j, k : word;
Begin
   ReadData;

   { 䨪⨢ ﬠ  ।  ࢮ 窨 }
   P := R;
   P.x := P.x + 1.38792577257; {  砩 稭      }
   P.y := P.y + 0.94597625982;
   Point2Line (R, P, Lines[0]);
   Lines[0].Vx := 0;
   Lines[0].Vy := 0;

   { 樠  ⥩ }
   For i := 1 to N do
    For j := 1 to N do
      Matr [i,j] := Inf;
   FillChar (Cnt, SizeOf(Cnt), 1);

   { 室  砫쭮 窨 }
   For i := 1 to N do
    If PointOnLine (R, Lines[i]) then
     If i = m then OutResult (0, 0)
     Else Begin
       Matr [0,i] := 0;
       Go (i, 0, 0);
     End;

   {  ठ- }
   For k := 1 to N-2 do
    For i := 1 to N do
     For j := 1 to N do
      If i<>j then Go (i, j, Matr[i,j]);

  { 室 襥 襭 }
  j := 0;
  For i := 1 to N do
   If (j=0) or Less (Matr[m,i],Matr[m,j]) then j := i;

  { ᫨ 諨 -  뢮  }
  If j = 0 then OutResult (Inf, 0)
  Else 
    OutResult (Matr [m,j], Cnt[m,j])
End;  (*  Solve  *)


BEGIN
  Init;
  Solve;
  Done
END.