program DDL;
 const MaxN=200;

       RusSmall:string[33]=('񦧨');
       RusBig:  string[33]=('');
{
       Basa:array[1..4] of string[8]=('INTEGER','CHAR','BYTE','STRING');
}
 type TLexem=(_Plus,_Mul,_Div,_Minus,_Or,_And,_Ord,_Chr,_Not,_Srav);
      PTree=^TTree;
      TTree=record
            Left,Right:PTree;
            L:TLexem;
            S:string;
            end;
 type PTreeAr=array[1..18] of PTree;
      TTreeAr=array[1..18] of string[8];
 var Consts:array[1..MaxN] of record
                              name:string[8];
                              zn:PTreeAr;
                              number:integer;
                              end;
     Types:array[1..MaxN] of record
                             name:string[8];
                             zn:TTreeAr;
                             number:integer;
                             end;

      sp,NumC,NumT,num_of_str:integer;
      S:string;
      ch:char;
      P:PTree;
      fin,fout:text;

 procedure Init;
  begin
  assign(fin,'program.ddl');
  reset(fin);
  assign(fout,'program.out');
  rewrite(fout);
  end;

 function DownCase(ch:char):char;
  var i:integer;
  begin
  if (Ord(ch)>64)and(Ord(ch)<91) then
   begin
   DownCase:=Chr(Ord(ch)+32);
   Exit;
   end;
  for i:=1 to 33 do if RusBig[i]=ch then
   begin
   DownCase:=RusSmall[i];
   Exit;
   end;
  DownCase:=ch;
  end;

 function UpCaseA(ch:char):char;
  var i:integer;
  begin
  if (Ord(ch)>96)and(Ord(ch)<123) then
   begin
   UpCaseA:=Chr(Ord(ch)-32);
   Exit;
   end;
  for i:=1 to 33 do if RusSmall[i]=ch then
   begin
   UpCaseA:=RusBig[i];
   Exit;
   end;
  UpCaseA:=ch;
  end;

 procedure ErrorMessage(num_of_er:integer);
  var f:text;
  begin
  close(fout);
  assign(f,'program.err');
  rewrite(f);
  case num_of_er of
   1:begin
     writeln(f, 'String ',num_of_str,':"Define" expected');
     writeln('String ',num_of_str,':"Define" expected');
     end;
   2:begin
     writeln(f, 'String ',num_of_str,':"Constant" of "Type" expected');
     writeln('String ',num_of_str,':"Constant" of "Type" expected');
     end;
   3:begin
     writeln(f, 'String ',num_of_str,':Syntax error');
     writeln('String ',num_of_str,':Syntax error');
     end;
   4:begin
     writeln(f, 'String ',num_of_str,':"OF" expected');
     writeln('String ',num_of_str,':"OF" expected');
     end;
   5:begin
     writeln(f, 'String ',num_of_str,':Invalid identifier name');
     writeln('String ',num_of_str,':Invalid identifier name');
     end;
   6:begin
     writeln(f, 'String ',num_of_str,':"SET" expected');
     writeln('String ',num_of_str,':"SET" expected');
     end;
   7:begin
     writeln(f, 'String ',num_of_str,':"=" expected');
     writeln('String ',num_of_str,':"=" expected');
     end;
   8:begin
     writeln(f, 'String ',num_of_str,':")" or "}" expected');
     writeln('String ',num_of_str,':")" or "}" expected');
     end;
   9:begin
     writeln(f, 'String ',num_of_str,':";" expected');
     writeln('String ',num_of_str,':";" expected');
     end;
   end;
  close(f);
  end;

 procedure Scan;
  begin
  while S[sp]=' ' do Inc(sp);
  end;

 function ReadWord:string;
  var S1:string;
  begin
  S1:='';
  while (S[sp]<>#0)and(S[sp]<>';')and(S[sp]<>' ') do
   begin
   S1:=S1+UpCaseA(S[sp]);
   Inc(sp);
   end;
  if S[sp]=#0 then begin ErrorMessage(3);Halt; end;
  ReadWord:=S1;
  end;

 function NewTree(Le,R:PTree;L1:TLexem;y:integer):PTree;
  begin

  end;

 procedure ReadType(numl:integer);
  var i:integer;
      rezsp:integer;
      S1:string;
      Ok:boolean;
  begin
  Scan;
  if S[sp]<>'=' then begin ErrorMessage(7);Halt; end;
  sp:=sp+1;
  Scan;
  rezsp:=sp;
  while (S[sp]<>' ')and(S[sp]<>'(')and(S[sp]<>#0)and(S[sp]<>'.')do Inc(sp);
  S1:=Copy(S,rezsp,sp-rezsp);
  if S[sp]=#0 then begin ErrorMessage(3);Halt; end;
  for i:=1 to length(S1) do S1[i]:=UpCase(S1[i]);
  if (rezsp<>sp)and(S[sp]<>'.')  then
   begin
   if (S1<>'MULTI')and(S1<>'SET')and(S1<>'SEQUENCE') then
    begin
    ErrorMessage(3);
    Halt;
    end;
   if S1='SEQUENCE' then
    begin
    sp:=sp+1;
    Scan;
    rezsp:=sp;
    while (S[sp]<>' ')and(S[sp]<>'(')and(S[sp]<>#0) do Inc(sp);
    if (Copy(S,rezsp,rezsp-sp)<>'OF')and(rezsp<>sp) then
       begin
       ErrorMessage(4);
       Halt;
       end;
    Scan;
    Ok:=true;
    if (S[sp]='(')or(S[sp]='{') then begin Inc(sp);Ok:=false; end;
    while (S[sp]<>#0)and(S[sp]<>')')and(S[sp]<>'}')and(S[sp]<>';')do Inc(sp);
    if (Ok=False)and((S[sp]=';')or(S[sp]='#0')) then
     begin
     ErrorMessage(8);
     Halt;
     end;
    if S[sp+1]=#0 then begin ErrorMessage(9);Halt; end;
    end else
   if S1='MULTI' then
    begin
    sp:=sp+1;
    Scan;
    rezsp:=sp;
    while (S[sp]<>' ')and(S[sp]<>'(')and(S[sp]<>#0) do Inc(sp);
    if (Copy(S,rezsp,rezsp-sp)<>'SET') then
       begin
       ErrorMessage(6);
       Halt;
       end;
    sp:=sp+1;
    Scan;
    rezsp:=sp;
    while (S[sp]<>' ')and(S[sp]<>'(')and(S[sp]<>#0) do Inc(sp);
    if (Copy(S,rezsp,rezsp-sp)<>'OF') then
       begin
       ErrorMessage(4);
       Halt;
       end;
    Scan;
    Ok:=true;
    if (S[sp]='(')or(S[sp]='{') then begin Inc(sp);Ok:=false; end;
    while (S[sp]<>#0)and(S[sp]<>')')and(S[sp]<>'}')and(S[sp]<>';')do Inc(sp);
    if (Ok=False)and((S[sp]=';')or(S[sp]='#0')) then
     begin
     ErrorMessage(8);
     Halt;
     end;
    if S[sp+1]=#0 then begin ErrorMessage(9);Halt; end;
    end else
   if S1='SET' then
    begin
    sp:=sp+1;
    Scan;
    rezsp:=sp;
    while (S[sp]<>' ')and(S[sp]<>'(') do Inc(sp);
    if (Copy(S,rezsp,rezsp-sp)<>'OF')and(rezsp<>sp) then
       begin
       ErrorMessage(4);
       Halt;
       end;
    Scan;
    Ok:=true;
    if (S[sp]='(')or(S[sp]='{') then begin Inc(sp);Ok:=false; end;
    while (S[sp]<>#0)and(S[sp]<>')')and(S[sp]<>'}')and(S[sp]<>';')do Inc(sp);
    if (Ok=False)and((S[sp]=';')or(S[sp]='#0')) then
     begin
     ErrorMessage(8);
     Halt;
     end;
    if S[sp+1]=#0 then begin ErrorMessage(9);Halt; end;
    end;
   end;
  end;

 procedure ReadConst(numpl:integer);
  var i,rezsp:integer;
      S1:string;
      Ok:boolean;
  begin
  Scan;
  if S[sp]<>'=' then begin ErrorMessage(7);Halt; end;
  sp:=sp+1;
  Scan;
  rezsp:=sp;
  Ok:=True;
  if (S[sp]='(')or(S[sp]='{') then begin Inc(sp);Ok:=False;end;
  while (S[sp]<>#0)and(S[sp]<>')')and(S[sp]<>'}')and(S[sp]<>';')do Inc(sp);
  if (Ok=False)and((S[sp]=';')or(S[sp]='#0')) then
   begin
   ErrorMessage(8);
   Halt;
   end;
  if (S[sp+1]=#0) then begin ErrorMessage(9);Halt; end;
  end;

 procedure FirstWay;
  var S1,Sn:string;
      rezsp,i:integer;
  begin
  numT:=0;numC:=0;
  num_of_str:=0;
  while not seekeof(fin) do
   begin
   readln(fin,S);
   Inc(num_of_str);
   sp:=1;
   Scan;
   S:=S+#0;
   if (S[sp]<>#0)and(S[sp]<>'/')and(S[sp+1]<>'/') then
    begin
    S1:=ReadWord;
    if S1<>'DEFINE' then begin ErrorMessage(1);Halt; end;
    sp:=sp+1;
    Scan;
    S1:=ReadWord;
    if (S1<>'CONSTANT')and(S1<>'TYPE') then begin ErrorMessage(2);Halt; end;
    sp:=sp+1;
    rezsp:=sp;
    while (S[sp]<>' ')and(S[sp]<>'=')and(S[sp]<>#0) do Inc(sp);
    if S[sp]=#0 then begin ErrorMessage(3);Halt; end;
    if sp-rezsp<8 then Sn:=Copy(S,rezsp,sp-rezsp)
                  else Sn:=Copy(S,rezsp,8);
    for i:=1 to length(Sn) do Sn[i]:=UpCaseA(Sn[i]);
    if (Sn='CONSTANT')or(Sn='DEFINE')or(Sn='TYPE')or(Sn='OPTIONAL') then
     begin
     ErrorMessage(5);
     Halt;
     end;
    if (Sn='OF')or(Sn='SEQUENCE')or(Sn='INTEGER')or(Sn='SET') then
     begin
     ErrorMessage(5);
     Halt;
     end;
    if (Sn='CHAR')or(Sn='BOOLEAN')or(Sn='STRING') then
     begin
     ErrorMessage(5);
     Halt;
     end;
    if S[1] in ['0'.. '9'] then begin ErrorMessage(5);Halt; end;
    for i:=2 to length(Sn) do if S[i]='.' then begin ErrorMessage(5);Halt;end;
    for i:=1 to length(Sn) do if S[i]='@' then begin ErrorMessage(5);Halt;end;
    if S1='TYPE' then begin Inc(NumT);ReadType(NumT);Types[numT].name:=Sn;end;
    if S1='CONSTANT' then
     begin
     Inc(NumT);ReadConst(NumT);Consts[numC].name:=Sn;
     end;
    end;
   end;
  end;

 procedure Sort;
  begin
  end;

 function Check(Q:PTreeAr;T:TTreeAr):boolean;
  begin
  end;

 procedure Solve;
  var i,j:integer;
      Ok,Ex:boolean;
  begin
  FirstWay; {...}
  New(P);
  for i:=1 to NumC do
   for j:=1 to Consts[j].number do
    begin
    Consts[i].zn[j]^.S:=P^.S;
    end;
  Sort;
  Ex:=False;
  for i:=1 to NumC do
   begin
   Ok:=False;
    for j:=1 to NumT do if Check(Consts[i].zn,Types[j].zn) then
     begin
     if Ok=False then
      begin
      write(Consts[i].name,':');
      write(Types[i].name);
      end;
     Ok:=True;
     Ex:=True;
     write(',',Types[i].name);
     end;
   write('=');
   if Consts[i].number>1 then
    begin
    write('{');
    for j:=1 to Consts[i].number do write(Consts[i].zn[j]^.S);
    write('}');
    end
   else write(Consts[i].zn[1]^.S);
   writeln;
   end;
  if Ex then Exit;

  end;

 procedure Done;
  begin
  close(fin);
  close(fout);
  end;

 BEGIN
 Init;
 Solve;
 END.