program _9_9_9_; { DDL }

type TLexema = ( _plus, _minus, _mul, _div, _open, _close, _comma, _dog,
                 _ident, _const, _end, _lt, _gt, _le, _ge, _ne, _eq,
                 _Fopen, _FClose, _pc, _pp, _tail,
                 _Mod, _Or, _pred, _succ, _and, _ord, _not, _chr,
                 _define, _set, _constant, _type, _optional, _of,
                 _sequence, _multi, _integer, _char, _boolean,
                 _Single,
                 _string, _str, _true, _false );
     TIdent = String [8];

const SkipSet = [' ',#13,#10];
      EndChar = #26;
      MaxTypes = 1000;
      MaxConsts = 1000;
type
      TData = array [0..65000] of byte;
      PData = ^TData;
      PTypePiece = ^TTypePiece;
      TTypePiece = record
                    typ : TLexema; { Seq, int, char, str, bool, set, multi }
                    nxt : PTypePiece;
                      v : PTypePiece;
                    opt : boolean;
                   end;
      PConstPiece = ^TConstPiece;
      TConstPiece = record
                     typ : TLexema; { Seq, int, char, str, bool, set, multi }
                     nxt : PConstPiece;
                       v : PConstPiece;
                     vs : string;
                     vi : integer;
                    end;
      TType = record
              name : TIdent;
              p : PTypePiece;
             df : boolean;
             end;
    TConst = record
              name : TIdent;
              p : PConstPiece;
             end;
     PType = ^TType;
     PConst = ^TConst;
     TTypeList = array [1..MaxTypes] of PType;
     TConstList = array [1..MaxTypes] of PConst;

var CurChar : char;
    Found : boolean;
    Updated : boolean;
    CurString : String;
    CurLex : TLexema;
    CurIdent : TIdent;
    CurConst : integer;
    lc : integer;
    LexFile : text;
    TempString : string;
    TypeList : TTypeList;
    ConstList : TConstList;
    Types : integer;
   Consts : integer;
   FirstPhase : boolean;
procedure ParseConstDef;forward;
procedure Error(s:string);
var ErrorFile:text;
    s1,h:string;
 begin
  Assign(ErrorFile, 'program.err');
  rewrite(ErrorFile);
  str(lc,h);
  s1 := 'Error in line '+h+':  '+s;
  writeln(ErrorFile,s1);
  writeln(s1);
  close(ErrorFile);
  halt;
 end;

function MUpCase(c:char):char;
 begin
  c := Upcase(c);
  if c = '' then MupCase:='' else
  if c in ['a'..'z',''..''] then MUpCase := char(byte(c)-32)
  else
  if c in [''..''] then MUpCase := char(byte(c)-80) else Mupcase:=c;
 end;

procedure DownCase(var c:char);
 begin
  if c = '' then c:='';
  if c in ['A'..'Z',''..''] then c := char(byte(c)+32);
  if c in [''..''] then c := char(byte(c)+80);
 end;

procedure NextChar;
 begin
  if CurChar = #13 then inc(LC);
  if eof(LexFile) then CurChar := EndChar else
  Read(LexFile,CurChar);
 end;

procedure Next;
label 1,2;
 begin
  while CurChar in SkipSet do NextChar;
  case MUpCase(CurChar) of
  '''' : begin
          CurLex := _Str;
          CurString := '';
       1: nextChar;
          while CurChar<>'''' do
           begin
            if CurChar = #13 then Error('String constant exceeds line.');
            CurString := CurString + CurChar;
            NextChar;
           end;
          nextChar;
          if curchar = '''' then begin
                                  CurString := CurString + '''';
                                  goto 1;
                                 end;
         end;
   '"' : begin
          CurLex := _Str;
          CurString := '';
       2: nextChar;
          while CurChar<>'"' do
           begin
            if CurChar = #13 then Error('String constant exceeds line.');
            CurString := CurString + CurChar;
            NextChar;
           end;
          nextChar;
          if curchar = '"' then begin
                                  CurString := CurString + '"';
                                  goto 2;
                                 end;
         end;
   ';' : begin
          CurLex := _pc;
          nextchar;
         end;
   '(' : begin
          CurLex := _open;
          nextchar;
         end;
   ')' : begin
          CurLex := _close;
          nextchar;
         end;
   '{' : begin
          CurLex := _fopen;
          nextchar;
         end;
   '}' : begin
          CurLex := _fclose;
          nextchar;
         end;
   ',' : begin
          CurLex := _comma;
          nextchar;
         end;
   '@' : begin
          CurLex := _dog;
          nextchar;
         end;
   '+' : begin
          CurLex := _plus;
          nextchar;
         end;
   '-' : begin
          CurLex := _minus;
          nextchar;
         end;
   '*' : begin
          CurLex := _mul;
          nextchar;
         end;
   '/' : begin
          CurLex := _div;
          nextchar;
          if CurChar = '/' then { Comment }
           begin
            inc(lc);
            ReadLn(LexFile,TempString);
            NextChar;
            Next;
           end;
         end;
   '=' : begin
          CurLex := _eq;
          nextchar;
         end;
   '<' : begin
          NextChar;
          if CurChar = '>' then begin
                                 CurLex := _ne;
                                 NextChar;
                                end else
          if CurChar = '=' then begin
                                 CurLex := _le;
                                 NextChar;
                                end else CurLex := _lt;
         end;
   '>' : begin
          NextChar;
          if CurChar = '=' then begin
                                 CurLex := _ge;
                                 NextChar;
                                end else CurLex := _gt;
         end;
   '0'..'9': begin
              CurConst := 0;
              repeat
               CurConst := CurConst * 10 + ord(CurChar) - ord('0');
               NextChar;
              until not (CurChar in ['0'..'9']);
              CurLex := _Const;
             end;
''..'',''..'','A'..'Z','_','.','$','?': begin
               CurIdent := '';
               repeat
                if CurIdent[0] < #8 then
                    CurIdent := CurIdent + MUpCase(CurChar);
                NextChar;
               until not ((MUpCase(CurChar) in ['A'..'Z','0'..'9','_','$','?',
               ''..'',''..'']));
               CurLex := _Ident;
               if CurIdent = 'DEFINE' then CurLex := _define;
               if CurIdent = 'CONSTANT' then CurLex := _constant;
               if CurIdent = 'TYPE' then CurLex := _type;
               if CurIdent = 'OPTIONAL' then CurLex := _optional;
               if CurIdent = 'SEQUENCE' then CurLex := _sequence;
               if CurIdent = 'OF' then CurLex := _of;
               if CurIdent = 'SET' then CurLex := _set;
               if CurIdent = 'MULTI' then CurLex := _multi;
               if CurIdent = 'PRED' then CurLex := _pred;
               if CurIdent = 'MOD' then CurLex := _Mod;
               if CurIdent = 'ORD' then CurLex := _Ord;
               if CurIdent = 'PRED' then CurLex := _pred;
               if CurIdent = 'SUCC' then CurLex := _succ;
               if CurIdent = 'TRUE' then CurLex := _true;
               if CurIdent = 'FALSE' then CurLex := _false;
               if CurIdent = 'OR' then CurLex := _or;
               if CurIdent = 'AND' then CurLex := _and;
               if CurIdent = 'NOT' then CurLex := _not;
               if CurIdent = 'CHR' then CurLex := _chr;
               if CurIdent = 'INTEGER' then CurLex := _integer;
               if CurIdent = 'CHAR' then CurLex := _char;
               if CurIdent = 'BOOLEAN' then CurLex := _boolean;
               if CurIdent = 'STRING' then CurLex := _string;
               if CurIdent = '.' then
                if CurChar = '.' then
                 begin
                  next;
                  CurLex := _pp;
                 end;
              end;
   EndChar : CurLex := _End;
    else Error('Unknown symbol');
  end;
 end;

procedure Expected(l:TLexema;s:string);
 begin
  if CurLex <> l then Error(s+' expected') else next;
 end;

procedure LexInit;
 begin
  Assign(LexFile,'program.ddl');
  reset(LexFile);LC := 1;
  NextChar;
  Next;
 end;

procedure LexDone;
 begin
  close(LexFile);
 end;

{ ************************* Syn.Analys *************************** }

procedure NewConstPiece(var p:PConstPiece);
 begin
    new(p);
    with p^ do
     begin
      nxt := nil;
      v := nil;
      typ := _end;
     end;
 end;

procedure NewConst(var id:TIdent);
 begin
  inc(Consts);
  new(ConstList[consts]);
  with ConstList[consts]^ do
   begin
    name := id;
    NewConstPiece(p);
   end;
 end;

procedure NewTypePiece(var p:PTypePiece);
 begin
    new(p);
    with p^ do
     begin
      nxt := nil;
      v := nil;
      typ := _end;
     end;
 end;

procedure NewType(var id:TIdent);
 begin
  inc(Types);
  new(TypeList[Types]);
  with TypeList[Types]^ do
   begin
    df := false;
    name := id;
    NewTypePiece(p);
   end;
 end;

function GetConstN(var id:TIdent) : integer;
var i:integer;
 begin
  GetConstN := 0;
  for i := 1 to Consts do
   if ConstList[i]^.name = id then GetConstN := i;
 end;

function GetTypeN(var id:TIdent) : integer;
var i:integer;
 begin
  for i := 1 to Types do
   if TypeList[i]^.name = id then begin GetTypeN := i;exit;end;
  NewType(id);
  GetTypeN := Types;
 end;

procedure ReadType(p:PTypePiece);
var i:integer;
label 1,2;
 begin
  if CurLex = _Multi then next;
  with p^ do
  case CurLex of
   _Ident :
     begin
      typ := _single;
      i := GetTypeN(CurIdent);
      p^.v := TypeList[i]^.p;
      next;
     end;

   _Integer, _Char, _String, _Boolean :
     begin
      p^.typ := CurLex;
      next;
     end;
   _sequence :
    begin
     next;
     if CurLex = _of then
       begin
        next;
        p^.typ := _of;
        NewTypePiece(p^.v);
        ReadType(p^.v);
       end else
     if CurLex = _open then
       begin
        next;
    1: p^.typ := _Sequence;
       if CurLex = _Optional then
           begin p^.opt := true;next;end
            else p^.opt := false;
        NewTypePiece(p^.v);
        ReadType(p^.v);
        if CurLex = _comma then
          begin
           next;
           NewTypePiece(p^.nxt);
           p := p^.nxt;
           goto 1;
          end;
        if CurLex <> _close then Error('No matching ")" in Sequence(...)');
        next;
       end else Error('"Of" or "(" expected.');
    end;

   _set :
    begin
     next;
     if CurLex = _of then
       begin
        next;
        p^.typ := _of;
        NewTypePiece(p^.v);
        ReadType(p^.v);
       end else
     if CurLex = _open then
       begin
        next;
    2: p^.typ := _Set;
       if CurLex = _Optional then
           begin p^.opt := true;next;end
            else p^.opt := false;
        NewTypePiece(p^.v);
        ReadType(p^.v);
        if CurLex = _comma then
          begin
           next;
           NewTypePiece(p^.nxt);
           p := p^.nxt;
           goto 2;
          end;
        if CurLex <> _close then Error('No matching ")" in Set(...)');
        next;
       end else Error('"Of" or "(" expected.');
    end;

   else Error(' ᠭ ⨯.');
  end;

 end;

procedure ParseTypeDef;
var id : TIdent;
    i : integer;
 begin
  next;
  Expected(_Ident,'Identifier');
  if FirstPhase then
   begin
     i := GetTypeN (CurIdent);
     if typelist[i]^.df = true then Error('Duplicate identifier');
   end;
  typelist[i]^.df := true;
  Expected(_eq,'"="');
  ReadType(TypeList[i]^.p);
 end;

procedure ParseSentence;
 begin
  if CurLex <> _Define then exit;
  next;
  if CurLex = _type then ParseTypeDef else
  if CurLex = _constant then ParseConstDef else
    Error(' ᠭ ⨯  ᠭ ⠭.');
 end;


procedure ParseProgram;
 begin
  ParseSentence;
  while curlex <> _End do
   begin
    if CurLex <> _pc then Error('";" expected.') else Next;
    ParseSentence;
   end;
 end;

procedure SynInit;
 begin
  Types := 0;
  Consts := 0;
 end;

procedure CheckTypes;
var i:integer;
    s:string;
 begin
  for i := 1 to Types do
   if typelist[i]^.df = false then
    begin
     s:='Undefined type ('+typelist[i]^.name+').';
     Error(s);
    end;
 end;

procedure UpdatePiece(p:PTypePiece);
var h:PTypePiece;
 begin
  h := p;
  while h<>nil do
   begin
    if h^.v^.typ = _single then
     begin
      h^.v^ := h^.v^.v^;
      UpDated := true;
     end;
    h := h^.nxt;
   end;
 end;

procedure UpdateTypes;
var i:integer;
    s:string;
 begin
  Updated := false;
  for i := 1 to Types do
   UpDatePiece(Typelist[i]^.p)
 end;

procedure UpdateTypes2;
var i:integer;
    s:string;
 begin
  Updated := false;
  for i := 1 to Types do
   if Typelist[i]^.p^.typ = _single then
     begin
      typelist[i]^.p := typelist[i]^.p^.v;
      updated := true;
     end;
 end;

procedure ConstExpr(var p:PConstPiece);forward;

procedure ConstFactor(var p:PConstPiece);
var h,h1:PConstPiece;
    i:integer;
 begin
  case CurLex of
 _Chr: begin
        next;
        if CurLex<>_open then error('"(" expected.');
        next;
        ConstFactor(p);
        if p^.typ <> _integer then error('Integer value expected.');
        p^.typ := _str;
        p^.vs[0]:=#1;
        p^.vs[1]:=char(p^.vi mod 256);
        if CurLex<>_close then error('")" expected.');
        next;
       end;
 _ord: begin
        next;
        if CurLex<>_open then error('"(" expected.');
        next;
        ConstFactor(p);
        if p^.typ <> _str then error('Character value expected.');
        p^.typ := _integer;
        p^.vi:=ord(p^.vs[1]);
        if CurLex<>_close then error('")" expected.');
        next;
       end;
 _Ident: begin
          i := GetConstN(CurIdent);
          if i = 0 then Error('Sorry, I''m so stupid that I can''t parse this file.');
          h := p;
          h1 := ConstList[i]^.p;
          h^ := h1^;
          while h1^.nxt<>nil do
           begin
            newConstPiece(h^.nxt);
            h := h^.nxt;
            h1 := h1^.nxt;
            h^ := h1^;
           end;
          next;
         end;
 _Fopen: begin { Sequence  :-( }
          p^.typ := _Sequence;
          h := p;
          while CurLex <> _FClose do
           begin
            if (CurLex<>_FOpen) and (CurLex<>_Comma)
             then Error('No matching "}" in sequence/set.');
            next;
            if CurLex<>_FClose then begin
                                     newConstPiece(h^.nxt);
                                     h := h^.nxt;
                                     h^.typ := _tail;
                                     NewConstPiece(h^.v);
                                     ConstExpr(h^.v);
                                    end;
           end;
          next;
         end;
 _open: begin
         next;
         ConstExpr(p);
         if CurLex <> _close then Error('No matching ")" in expression.');
         next;
        end;
   _str : begin
           p^.typ := CurLex;
           next;
           p^.vs := CurString;
          end;
 _const : begin
           p^.typ := _integer;
           next;
           p^.vi := CurConst;
          end;
 _true : begin
           p^.typ := _boolean;
           next;
           p^.vi := byte(true);
          end;
 _false : begin
           p^.typ := _boolean;
           next;
           p^.vi := byte(false);
          end;
 _minus : begin
           next;
           ConstFactor(p);
           if p^.typ = _integer then p^.vi := -p^.vi else
             Error('Type mismatch.');
          end;
 _plus : begin
           next;
           ConstFactor(p);
           if p^.typ = _integer then else
             Error('Type mismatch.');
          end;
 _not : begin
         next;
           ConstFactor(p);
           if p^.typ = _boolean then p^.vi := 1-p^.vi else
             Error('Type mismatch.');
          end;
   else Error('Unexpected lexema in ConstFactor');
  end;
 end;

procedure ConstTerm(var p:PConstPiece);
var p1,p2:PConstPiece;
    op:TLexema;
 begin
  newConstPiece(p1);
  newConstPiece(p2);
  ConstFactor(p1);
  while CurLex in [_mul,_div,_mod] do
   begin
    op := CurLex;next;
    ConstFactor(p2);
    if (p1^.typ <> p2^.typ) then error('Type mismatch');
    if p1^.typ = _integer then
    case op of
     _mul : p1^.vi := p1^.vi * p2^.vi;
     _div : p1^.vi := p1^.vi div p2^.vi;
     _mod : p1^.vi := p1^.vi mod p2^.vi;
    end;
   end;
  p^ := p1^;
  dispose(p1);
  dispose(p2);
 end;

procedure ConstExpr(var p:PConstPiece);
var h,p1,p2:PConstPiece;

    op:TLexema;
 begin
  newConstPiece(p1);
  newConstPiece(p2);
  ConstTerm(p1);
  while CurLex in [_plus,_minus,_or,_and,_dog,_eq,_ne,_lt,_le,_gt,_ge] do
   begin
  op := CurLex;next;
  ConstTerm(p2);
  if (p1^.typ <> p2^.typ) then error('Type mismatch');
  if p1^.typ = _sequence then
   case op of
   _dog :
       begin
        h := p1;
        while h^.nxt <> nil do h := h^.nxt;
        h^.nxt := p2^.nxt;
       end;
   else Error('Type mismatch');
   end else
  if p1^.typ = _string then
   case op of
   _plus : p1^.vs := p1^.vs + p2^.vs;
   else Error('Type mismatch');
   end else
  if p1^.typ = _boolean then
   case op of
    _or : p1^.vi := byte( boolean(p1^.vi) or boolean(p2^.vi));
   _and : p1^.vi := byte( boolean(p1^.vi) and boolean(p2^.vi));
   else Error('Type mismatch');
   end else
  if p1^.typ = _integer then
   case op of
      _eq : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi=p2^.vi);
            end;
      _ne : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<>p2^.vi);
            end;
      _lt : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<p2^.vi);
            end;
      _gt : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi>p2^.vi);
            end;
      _le : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<=p2^.vi);
            end;
      _ge : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi>=p2^.vi);
            end;
    _plus : p1^.vi := p1^.vi + p2^.vi;
   _minus : p1^.vi := p1^.vi - p2^.vi;
   else Error('Type mismatch');
   end;
  end;
  p^ := p1^;
  dispose(p1);
  dispose(p2);
 end;

procedure ParseConstDef;
 begin
  next;
  Expected(_Ident,'Ident');
  if FirstPhase then
  if (GetConstN(CurIdent) <> 0) then
     Error('Duplicate identifier');
  NewConst(CurIdent);
  Expected(_eq,'"="');
  ConstExpr(ConstList[Consts]^.p);
 end;

procedure ChangeToLower;
var i,t:integer;
 begin
  for i:=1 to consts do
   with ConstList[i]^ do
   begin
    for t:= 1 to length(name) do
     DownCase(name[t]);
   end;
 end;

procedure SortConstants;
var i,t:integer;
 begin
  for i:=1 to Consts-1 do
   for t:=i+1 to Consts do
    if ConstList[i]^.name > ConstList[t]^.name then
      begin
       ConstList[MaxConsts] := ConstList[i];
       ConstList[i] := ConstList[t];
       ConstList[t] := ConstList[MaxConsts];
      end;
 end;

procedure WriteString(var s:string);
var i:integer;
 begin
  for i:=1 to length(s) do
    if s[i] = '''' then write('''''') else write(s[i]);
 end;
procedure WriteCPiece(p:PConstPiece);
var b:boolean;
 begin
  with p^ do
  case typ of
   _integer : write(vi);
       _str : begin
               write('''');
               writestring(vs);
               write('''');
              end;
   _boolean : write(boolean(vi));
   _sequence : begin
                write('{');
                p:=p^.nxt;b:=false;
                while p<>nil do
                 begin
                  if b then write(',');
                  WriteCPiece(p^.v);
                  p := p^.nxt;
                  b:=true;
                 end;
                write('}');
               end;
  end;
 end;

procedure WriteCPieceT(p:PConstPiece);
var b:boolean;
 begin
  with p^ do
  case typ of
   _integer : write('integer');
       _str : write('string');
   _boolean : write('boolean');
   _sequence : begin
                write('sequence (');
                p:=p^.nxt;b:=false;
                if p = nil then
                 write('optional char');
                while p<>nil do
                 begin
                  if b then write(',');
                  WriteCPieceT(p^.v);
                  p := p^.nxt;
                  b:=true;
                 end;
                write(')');
               end;
  end;
 end;

function Suitable(c:PConstPiece;t:PTypePiece) : boolean;
 begin
  if (c = nil) and (t<>nil) then begin Suitable:=false;exit;end;
  if (t = nil) and (c<>nil) then begin Suitable:=false;exit;end;
  if t^.typ = _set then
     begin
      while t<>nil do
       begin
        if Suitable(c,t^.v) then begin Suitable:=true;exit;end;
        t:=t^.nxt;
       end;
      Suitable := false;exit;
     end;
  if t^.typ = _of then
     begin
      if c^.typ<>_Sequence then begin Suitable := false;exit;end;
      c:=c^.nxt;
      while c<>nil do
       begin
        if not Suitable(c^.v,t^.v) then begin Suitable:=false;exit;end;
        c:=c^.nxt;
       end;
      Suitable := true;exit;
     end;
  if (c^.typ<>t^.typ) and
  (not ((c^.typ=_str) and (t^.typ =_String))) and
  (not ((c^.typ=_str) and (c^.vs[0]=#1) and (t^.typ =_char)))
  then begin Suitable := false;exit;end;
  if c^.typ <> _Sequence then begin Suitable := true;exit;end;
  c:=c^.nxt;
  while (c<>nil) and (t<>nil) do
   begin
    if not Suitable(c^.v,t^.v) then begin Suitable := false;exit;end;
    c:=c^.nxt;
    t:=t^.nxt;
   end;
  if (c<>nil) or (t<>nil) then Suitable := false else Suitable := true;
 end;

procedure PrintConstants;
var i,t,c : integer;
 begin
  for i:=1 to consts do
   with ConstList[i]^ do
   begin
    write(name,':');
    Found := false; c := 0;
    for t := 1 to Types do
     if Suitable(ConstList[i]^.p,TypeList[t]^.p) then
      begin
       found := true;
       if c>0 then write(', ') else inc(c);
       write(TypeList[t]^.name);
      end;
    if not Found then writeCPieceT(p);
    write(' = ');
    writeCPiece(p);
    writeln;
   end;
 end;

procedure Answer;
 begin
  ChangeToLower;
  SortConstants;
  PrintConstants;
 end;

begin
 FirstPhase := true;
  repeat
   LexInit;
   SynInit;
   ParseProgram;
   LexDone;
   FirstPhase := false;
  until true;
 CheckTypes;
 repeat UpdateTypes;until not Updated;
 repeat UpdateTypes2;until not Updated;
 Assign(output,'program.out');rewrite(output);
 Answer;
 close(output);
end.