Type    TLexem=
        (_Define,_Type,_Constant,
         _tInteger,_tString,_tChar,_tBoolean,_Comment,_SemiColon,
         _Plus,_Minus,_Mul,_Div,_Mod,_Equ,_Less,_Bigger,_EquLess,_EquBigger,
         _NotEqu,
         _Ord,_Chr,
         _Or,_And,_Not,
         _Pred,_Succ,
         _Sequence,_Of,_Optional,_Set,_Multi,
         _Integer,_String,_FALSE,_TRUE,_End,_Error,
         _OpenF,_CloseF,_Open,_Close,_Zpt,_ID,
         _SetPlus,_SetMinus,_SetMul);

         TTypeDesc=(tdInteger,tdString,tdChar,tdBoolean,tdSequence_Of,
                    tdSequence,tdSet_Of,tdMulti_Set,tdSet,tdLimited,tdPere);

         PType=^TType;
         POfType=^TOfType;
         TOfType=Record
                  OfType:PType;
                  Next:POfType;
                 End;
         TType=Record
                Name:String[8];
                Desc:TTypeDesc;
                OT:POfType;
                Next:PType;
               End;

         PValue=^TValue;
         TValue=Record
                 BT:TTypeDesc;
                 Value:Pointer;
                 Next:PValue;
                End;

         PConst=^TConst;
         TConst=Record
                 Name:String[8];
                 Save:PValue;
                 Next:PConst;
                End;

         TErr=(erDefine,erIdC,erStr,erStrA,erStrK,erDoubleType,erDoubleID,
               erInID,erTypeDesc,erPere,erPereIDEx,erOpenEx,erCloseEx,erNET,
               erOfEx,erSCEx,erDefEx);

Const    Id:Set Of Char=['A'..'Z','a'..'z',''..'',''..'',''..'',
                         '0'..'9','.','$','_','?'];
         CS:Set Of Char=['{','}','(',')',';','/','*','+','-',','];

Var      CWord:String;
         ERR,OUT,DLL:Text;
         S:String;
         Lex:TLexem;
         Types:PType;
         TypeN:Byte;
         SN:Word;

         Int:Integer;
         Str:String;
         FirstType:PType;
         LastType:PType;
         FirstC:PConst;
         LastC:PConst;
         LSP:Byte;

Const    SP:Byte=1;

Procedure DoneAll; Forward;

{ ---- Begin Lexem Analizer }

Function DC(Ch:Char):Char;
Begin
 Case Ch Of
  'A'..'Z',''..'':DC:=Chr(Ord(Ch) Or 32);
   Else DC:=Ch;
 End;
End;

Procedure DownCase(Var S:String);
Var       I:Byte;
Begin
 For I:=1 To Length(S) Do
 Case S[I] Of
  'A'..'Z',''..'':Byte(S[I]):=Byte(S[I]) Or 32;
 End;
End;

Procedure NextWord;
Var       K:Char;
          St:Boolean;
Label     1;
Begin
 CWord:=''; LSP:=SP;
 1:
 If SP>Length(S) Then
  If Not EOF(DLL) Then Begin Inc(SN); ReadLn(DLL,S); SP:=1; End Else
                       Exit;
 While (S[SP]=' ') And (SP<=Length(S)) Do Inc(SP);
 If SP>Length(S) Then Goto 1;
 If (S[SP]='''') Or (S[SP]='"') Then
  Begin St:=True; K:=S[SP]; CWord:=K; Inc(SP); End Else
  St:=False;
 While ((S[SP] In ID) Or (St And (S[SP]<>K))) And (SP<=Length(S)) Do
 Begin
  CWord:=CWord+DC(S[SP]); Inc(SP);
 End; If St Then Begin CWord:=CWord+S[SP]; Inc(SP); End;
 If Length(CWord)>0 Then Exit;
 CWord:=S[SP]; Inc(SP);
 If CWord='/' Then
 If S[SP]='/' Then Begin CWord:=CWord+S[SP]; Inc(SP); End;
End;

Procedure SkipLine;
Begin
 ReadLn(DLL,S); Inc(SN); SP:=1;
End;

Procedure FileInit;
Begin
 Assign(DLL,'program.dll'); Reset(DLL);
End;

Procedure FileDone;
Begin
 Close(DLL);
End;

Procedure WriteError(S:String);
Begin
 Assign(Err,'Program.Err'); ReWrite(Err);
 WriteLn(Output,'訡  ப ',SN,' : ',S);
 WriteLn(Err,'訡  ப ',SN,' : ',S);
 Close(Err);
End;

Procedure Error(Err:TErr);
Begin
 Case Err Of
  erDefine:WriteError('᫥ 祢 ᫮ DEFINE  ᫥ CONSTANT  TYPE');
  erIdC:WriteError('䨪   稭  ');
  erStr:WriteError('䨪  ࠧ ஡/ॢ ப');
  erStrA,erStrK:
   WriteError('1.᫨ ப 稭 䮬/窮,    稢 䮬/窮'+
   #13#10'     2. ப ॢ ப ⨬');
  erDoubleType:WriteError('୮ ᠭ ⨯');
  erDoubleID:WriteError('୮ ᠭ ⠭');
  erInID:WriteError('⨬  䨪');
  erTypeDesc:WriteError('訡  ᠭ ⨯ (ய饭  "=")');
  erPere:WriteError('訡  ᠭ ᫨ ⨯');
  erPereIDEx:WriteError('䨪 ய饭');
  erCloseEx:WriteError('ய饭 ᨬ ")"');
  erNET:WriteError(' ⨯');
  erOpenEx:WriteError('ய饭 ᨬ "("');
  erOfEx:WriteError('ய饭 祢 ᫮ "Of"');
  erSCEx:WriteError('ய饭 ᨬ ";"');
  erDefEx:WriteError('।  稭  祢 ᫮ "Define"');
 End; DoneAll;
End;

Procedure NextLexem;
Var       I:Byte;
Begin
 If CWord='' Then Lex:=_END Else
 If CWord='//' Then Lex:=_COMMENT Else
 If CWord='define' Then Lex:=_DEFINE Else
 If CWord='constant' Then Lex:=_CONSTANT Else
 If CWord='type' Then Lex:=_TYPE Else
 If CWord='string' Then Lex:=_tSTRING Else
 If CWord='integer' Then Lex:=_tInTEGER Else
 If CWord='char' Then Lex:=_tCHAR Else
 If CWord='boolean' Then Lex:=_tBOOLEAN Else
 If CWord='+' Then Lex:=_PLUS Else
 If CWord='-' Then Lex:=_MINUS Else
 If CWord='*' Then Lex:=_MUL Else
 If CWord='/' Then Lex:=_DIV Else
 If CWord='mod' Then Lex:=_MOD Else
 If CWord='=' Then Lex:=_EQU Else
 If CWord='<' Then Lex:=_LESS Else
 If CWord='>' Then Lex:=_BIGGER Else
 If CWord=',' Then Lex:=_ZPT Else
 If CWord='<=' Then Lex:=_EQULESS Else
 If CWord='>=' Then Lex:=_EQUBIGGER Else
 If CWord='<>' Then Lex:=_NOTEQU Else
 If CWord='ord' Then Lex:=_ORD Else
 If CWord='chr' Then Lex:=_CHR Else
 If CWord='or' Then Lex:=_OR Else
 If CWord='and' Then Lex:=_AND Else
 If CWord='not' Then Lex:=_NOT Else
 If CWord='pred' Then Lex:=_PRED Else
 If CWord='succ' Then Lex:=_SUCC Else
 If CWord='sequence' Then Lex:=_SEQUENCE Else
 If CWord='of' Then Lex:=_OF Else
 If CWord='optional' Then Lex:=_OPTIONAL Else
 If CWord='not' Then Lex:=_NOT Else
 If CWord='set' Then Lex:=_SET Else
 If CWord='multi' Then Lex:=_MULTI Else
 If CWord='{' Then Lex:=_OPENF Else
 If CWord='}' Then Lex:=_CLOSEF Else
 If CWord='(' Then Lex:=_OPEN Else
 If CWord=')' Then Lex:=_CLOSE Else
 If CWord='false' Then Lex:=_FALSE  Else
 If CWord='true' Then Lex:=_TRUE Else
 If CWord=';' Then Lex:=_SEMICOLON Else
 If CWord='plus' Then Lex:=_SetPlus Else
 If CWord='minus' Then Lex:=_SetMinus Else
 If CWord='mul' Then Lex:=_SetMul Else
 If CWord[1] In ['0'..'9'] Then
  Begin
   Int:=0; Lex:=_Integer; For I:=1 To Length(CWord) Do
    If CWord[I] In ['0'..'9'] Then Int:=Int*10+Ord(CWord[I])-48 Else
    Error(ErIdC);
  End Else
 If CWord[1]='''' Then If CWord[Length(CWord)]='''' Then
  Begin
   Str:='';
   For I:=2 To Length(CWord)-1 Do If CWord[I]<>'''' Then
                                     Str:=Str+CWord[I] Else
                                     If CWord[I+1]<>'''' Then Error(erStr) Else
                                     Str:=Str+''''; Lex:=_String;
  End Else
   Error(erStrA) Else
  If CWord[1]='"' Then If CWord[Length(CWord)]='"' Then
  Begin
   Str:='';
   For I:=2 To Length(CWord)-1 Do If CWord[I]<>'"' Then
                                     Str:=Str+CWord[I] Else
                                     If CWord[I+1]<>'"' Then Error(erStr) Else
                                     Str:=Str+'"'; Lex:=_String;
  End Else
   Error(erStrK) Else
 Begin
  Lex:=_ID;
  Str:=CWord;
 End;
 NextWord;
End;

{ ---- End Lexem Analizer }

Function ExistType(N:String):Boolean;
Var      C:PType;
Begin
 C:=FirstType;
 While C<>Nil Do With C^ Do
 Begin
  If Name=N Then Begin ExistType:=True; Exit; End;
  C:=Next;
 End;
 ExistType:=False;
End;

Function GetType(N:String):PType;
Var      C:PType;
Begin
 C:=FirstType;
 While C<>Nil Do With C^ Do
 Begin
  If Name=N Then Begin GetType:=C; Exit; End;
  C:=Next;
 End;
 GetType:=Nil;
End;

Function AddType(N:String;D:TTypeDesc;O:POfType):PType;
Var      P:PType;
Begin
 If ExistType(N) Then Error(erDoubleType);
 If LastType=Nil Then New(LastType) Else
 Begin
 New(LastType^.Next); LastType:=LastType^.Next;
 End;
 With LastType^ Do
 Begin
  Name:=N; Desc:=D; OT:=O; Next:=Nil;
 End;
 AddType:=LastType;
End;

Procedure InitBasicTypes;
Begin
 TypeN:=4;
 AddType('integer',tdInteger,Nil);
 AddType('string',tdString,Nil);
 AddType('char',tdChar,Nil);
 AddType('boolean',tdBoolean,Nil);
End;

Function ValidID(S:String):Boolean;
Var      I:Byte;
Begin
 For I:=1 To Length(S) Do if Not (s[I] In ID) Then Begin ValidID:=False; Exit; End;
 ValidID:=True;
End;

Procedure AddPerConst(ID:String;I:Integer);
Var       P:PConst;
          PI:^Integer;
Begin
 AddType(Str,tdPere,Nil);
 New(LastC^.Next); LastC:=LastC^.Next;
 With LastC^ Do
 Begin
  Name:=ID; New(Save); Save^.Next:=Nil; Save^.BT:=tdInteger;
  New(PI); PI^:=I; Save^.Value:=PI;
 End;
End;

Procedure SkipSemi;
Begin
 Repeat NextLexem; Until (Lex=_SEMICOLON) Or (Lex=_End);
 If Lex=_End Then Error(erSCEX);
End;

Procedure Main;
Var       Name:String;
          I:Integer;
          OT,OT1:POfType;
Label     1;
Begin
 NextWord;
 Repeat
  NextLexem;
  Case Lex Of
   _DEFINE:Begin
            NextLexem;
            Case Lex Of
             _TYPE:Begin
                    NextLexem;
                    If Lex<>_ID Then Error(erInID);
                    If Not ValidID(Str) Then Error(erInID);
                    Name:=Str;
                    NextLexem;
                    If Lex<>_EQU Then Error(erTypeDesc);
                    NextLexem;
                    Case Lex Of
                     _tINTEGER:AddType(Name,tdInteger,Nil);
                     _tSTRING:AddType(Name,tdString,Nil);
                     _tCHAR:AddType(Name,tdChar,Nil);
                     _tBOOLEAN:AddType(Name,tdBoolean,Nil);
                     _OPEN:Begin
                            AddType(Name,tdPere,Nil);
                            NextLexem; I:=0;
                            Repeat
                             If Lex<>_ID Then Error(ErPereIDEx);
                             AddPerConst(Str,I); Inc(I);
                             NextLexem;
                             If (Lex<>_Zpt) Then Error(ErCloseEx);
                             NextLexem;
                            Until Lex<>_ID;
                            If Lex<>_CLOSE Then Error(ErCloseEx);
                           End;
                     _SEQUENCE:Begin
                                NextLexem;
                                If Lex=_OF Then
                                Begin
                                 NextLexem;
                                 If (Lex<>_ID) And (Lex<>_tInteger) And (Lex<>_tString)
                                 And (Lex<>_tChar) And (Lex<>_TBoolean) Then Error(erNET);
                                 If Lex<>_ID Then Str:=CWord;
                                 If Not ExistType(Str) Then Error(erNet);
                                 New(OT); OT^.OfType:=GetType(Str); OT^.Next:=Nil;
                                 AddType(Name,tdSequence_Of,OT);
                                End Else
                                Begin
                                 NextLexem;
                                 If Lex<>_OPEN Then Error(ErOpenEx);
                                 New(OT); OT1:=OT;
                                 I:=0;
                                 Repeat
                                  1:
                                  NextLexem;
                                  If (Lex<>_OPTIONAL) And (Lex<>_ID) And (Lex<>_tInteger) And (Lex<>_tString)
                                  And (Lex<>_tChar) And (Lex<>_TBoolean) Then
                                   Error(erPereIDEx);
                                  If Lex=_Optional then Goto 1; {!    !}
                                  If Lex<>_ID Then Str:=CWord;
                                  If Not ExistType(Str) Then Error(erNet);
                                  Inc(I); If I>0 Then
                                  Begin New(OT1^.Next); OT1:=OT1^.Next; End;
                                  OT1^.OfType:=GetType(Str); OT1^.Next:=Nil;
                                  NextLexem;
                                  If (Lex<>_ZPT) Then Error(erCloseEx);
                                 Until Lex<>_ID;
                                 NextLexem;
                                 If Lex<>_Close Then Error(erCloseEx);
                                 AddType(Name,tdSequence_Of,OT);
                                End;
                               End;
                     _Multi:Begin
                             NextLexem;
                             If Lex<>_Of Then Error(erOfEx);
                             If (Lex<>_ID) And (Lex<>_tInteger) And (Lex<>_tString)
                              And (Lex<>_tChar) And (Lex<>_TBoolean) Then Error(erPereIDEx);
                             If Lex<>_ID Then Str:=CWord;
                             If Not ExistType(Str) Then Error(erNET);
                             AddType(Name,tdMulti_Set,Nil); {!  OfType !}
                           End;
                     _Set:Begin
                           NextLexem;
                           Case Lex Of
                            _Of:Begin
                                 If (Lex<>_ID) And (Lex<>_tInteger) And (Lex<>_tString)
                                 And (Lex<>_tChar) And (Lex<>_TBoolean) Then
                                  Error(erPereIDEx);
                                 If Lex<>_ID Then Str:=CWord;
                                 If Not ExistType(Str) Then Error(erNET);
                                 AddType(Name,tdSet_Of,Nil); {!  OfType !}
                                End;
                            Else
                            Begin
                             NextLexem;
                             If Lex<>_OPEN Then Error(ErOpenEx);
                             I:=0;
                             Repeat
                              NextLexem;
                              If (Lex<>_ID) And (Lex<>_tInteger) And (Lex<>_tString)
                              And (Lex<>_tChar) And (Lex<>_TBoolean) Then Error(erPereIDEx);
                              If Lex<>_ID Then Str:=CWord;
                              If Not ExistType(Str) Then Error(erNet);
                              NextLexem;
                              If (Lex<>_ZPT) Then Error(erCloseEx);
                             Until Lex<>_ID;
                             NextLexem;
                             If Lex<>_Close Then Error(erCloseEx);
                             AddType(Name,tdSequence_Of,Nil); {!  OfType !}
                            End;
                           End;
                          End;
                    End;
                    NextLexem; If Lex<>_SEMICOLON Then Error(ErSCEx);
                   End;
             _CONSTANT:Begin
                        SkipSemi;
                       End;
             Else Error(erDefine);
            End;
           End;
   Else Error(erDefEx);
  End;
 Until Lex=_END;
End;

Procedure DoneAll;
Begin
 Halt;
End;

Begin
 FileInit;
 InitBasicTypes;

 Main;
 FileDone;
End.