Const
  Unknown_Type='Error 01 : Unknown Type !';
  UnExpected_End_Of_String='Error 02 : Unexpected End Of String !';
  Define_Expected='Error 03 : "Define" Expected !';
  Type_Or_Constant_Expected='Error 04 : "Type" Or "Constant" Expected !';
  Too_Many_Types_And_Constants='Error 05 : Too Many Types And Constants !';
  Duplicate_Intendifier='Error 06 : Duplicate Intendifier !';
  Of_Or_OtkrSkobka_Expected='Error 07 : "Of" Or "(" Expected !';
  Type_Mismatch='Error 08 : Type Mismatch !';
  Cannot_Use_Reserved_Words_As_Intendifiers='Error 09 : Cannot Use Reserved Words As Intendifiers !';
  Syntax_Error='Error 10 : Syntax Error !';
  Structure_Too_Large='Error 11 : Structure Too Large !';
  Ravno_Expected='Error 12 : "=" Expected !';
  ZakrSkobka_Expected='Error 13 : ")" Expected !';
  Set_Expected='Error 14 : "SET" Expected !';
  String_Constant_Exceeds_Line='Error 15 : String Constant Exceeds Line !';
  Unknown_Type_Constructor='Error 16 : Unknown Type Constructor !';
  Too_Big_Type='Error 17 : Too Big Type !';

  NumReserved=22;
  Reserved:Array[1..NumReserved]Of String=('INTEGER','CHAR','BOOLEAN',
                                           'STRING','TRUE','FALSE','MOD',
                                           'ORD','CHR','OR','AND','NOT',
                                           'PRED','SUCC','SEQUENCE','OF',
                                           'OPTIONAL','SET','MULTI','DEFINE',
                                           'TYPE','CONSTANT');

  MaxPart=100;
  MaxType=100;
  MaxName=100;
  MaxPere=50;
  MaxPereNum=100;

Var
  Fi,Fo,Fe:Text;
  Ns:LongInt;
  St:String;
  IsErrors:Boolean;
  UsedNames:Array[1..MaxName]Of String[8];
  UsedTypes:Array[1..MaxType]Of String[8];
  UsedPere:Array[1..MaxPere,1..MaxPereNum]Of String[8];
  NUN:Byte;
  NUT:Byte;
  NUP:Byte;
  NUPN:Array[1..MaxPere]Of Byte;

Procedure Error(S:String;N:Byte);
Begin
  IsErrors:=True;
  WriteLn('In String ',N,' ',S);
  WriteLn(Fe,'In String ',N,' ',S);
End;

Procedure OpenFiles;
Begin
  Assign(Fi,'Program.DDL');
  Assign(Fo,'Program.OUT');
  Assign(Fe,'Program.ERR');
  ReSet(Fi);
  ReWrite(Fo);
  ReWrite(Fe);
End;

Procedure CloseFiles;
Begin
  Close(Fi);
  Close(Fo);
  Close(Fe);
  If Not IsErrors Then Erase(Fe);
End;

Procedure DelSpaces(Var S:String;SN:Byte);
Var
  I:Byte;
  Is:Boolean;
  sc:Char;
Function UpRus(C:Char):Char;
Begin
  If C In ['a'..'z'] Then C:=Chr(Ord(C)-32);
  If C In [''..''] Then C:=Chr(Ord(C)-32);
  If C In [''..''] Then C:=Chr(Ord(C)-80);
  UpRus:=C;
End;
Begin
  If Pos('//',S)>0 Then Delete(S,Pos('//',S),255);
  Is:=False;
  I:=0;
  While I<Length(S) Do Begin
    Inc(I);
    Case S[I] Of
      ' ':If Not Is Then If (I=1) Or (I=Length(S)) Or
                            ((I>1) And (S[I-1] In [' ','=',';','+','-','*','/','(',')','{','}',',']) Or
                            ((I<Length(S)) And (S[I+1] In [' ','=',';','+','-','*','/','(',')','{','}',',']))) Then
                            Begin Delete(S,I,1);Dec(I); End;
      '''':If Is And (sc='''') Then Is:=False Else If Not Is Then Begin sc:='''';Is:=True; End;
      '"':If Is And (sc='"') Then Is:=False Else If Not Is Then Begin sc:='"';Is:=True; End;
      Else If Not Is Then S[I]:=UpRus(S[i]);
    End;
  End;
  If Is Then Error(String_Constant_Exceeds_Line,SN+1);
End;

Function NextString(N:LongInt):Boolean;
Var
  I:Longint;
Begin
  ReSet(Fi);
  NextString:=False;
  For I:=1 To N Do If SeekEof(Fi) Then Exit Else ReadLn(Fi);
  NextString:=True;
End;

Procedure Check;
Var
  S,S1:String;
  SS1,SS2:String;
  ONs:Longint;
  I,J:Byte;
  ok,stl:Boolean;
  ONUN:Byte;
  II,Cnt:Integer;
Function Min(a,b:Byte):Byte;
Begin
  If A=0 Then Min:=B Else If B=0 Then Min:=A Else
  If A<b Then Min:=A Else Min:=B;
End;
Begin
  NUT:=4;
  UsedTypes[1]:='INTEGER';
  UsedTypes[2]:='CHAR';
  UsedTypes[3]:='BOOLEAN';
  UsedTypes[4]:='STRING';
  IsErrors:=False;
  Ns:=0;
  NUN:=0;
  NUP:=0;
  While NextString(Ns) Do Begin
    St:='';
    Ons:=Ns;
    Stl:=False;
    Repeat
      ReadLn(Fi,S);
      DelSpaces(S,ONs);
      if Not Stl Then If Length(St)+Length(S)>255 Then Begin Error(Structure_Too_Large,ONs+1);Stl:=True; End;
      If Not Stl Then St:=St+S;
      Inc(Ns);
    Until Eof(Fi) Or (S[Length(S)]=';');
    If Stl Then Continue;
    If St[Length(St)]=';' Then Dec(St[0]);
    If St='' Then Continue;
    If (Length(St)<6) Or (Copy(St,1,7)<>'DEFINE ') Then Begin Error(Define_Expected,ONs+1);Continue; End;
    Delete(St,1,7);
    If (length(St)>=5) And (Copy(St,1,5)='TYPE ') Then Begin
      Delete(St,1,5);
      If Pos('=',St)=0 Then Begin Error(Ravno_Expected,ONs+1);Continue; End;
      S:=Copy(St,1,Pos('=',St)-1);
      For I:=1 To Length(S) Do If Not (S[I] In ['A'..'Z',''..'','0'..'9','$','_','?']) Then Break;
      If Not (S[I] In ['A'..'Z',''..'','0'..'9','$','_','?']) Then Begin Error(Syntax_Error,ONs+1);Continue; End;
      For I:=1 To NumReserved Do If Copy(S,1,8)=Reserved[I] Then Break;
      If Copy(S,1,8)=Reserved[I] Then Begin Error(Cannot_Use_Reserved_Words_As_Intendifiers,ONs+1);Continue; End;
      For I:=1 To NUN Do If Copy(S,1,8)=UsedNames[I] Then Break;
      If Copy(S,1,8)=UsedNames[I] Then Begin Error(Duplicate_Intendifier,ONs+1);Continue; End;
      If NUN=MaxName Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Continue; End;
      Delete(St,1,Pos('=',St));
      s1:=s;
      s:=Copy(St,1,Min(Pos(' ',St),Min(Pos('(',St),Pos('.',St)))-1);
      ok:=False;
      If S='SEQUENCE' Then Begin
        ok:=true;
        If Min(Pos(' ',St),Pos('(',St))=0 Then Begin Error(Of_Or_OtkrSkobka_Expected,ONs+1);Continue; End;
        Delete(St,1,Min(Pos(' ',St),Pos('(',St))-1);
        If (St='') Or ((St[1]<>'(') And ((St[0]=#1) Or (St[1]+St[2]+St[3]+St[4]<>' OF '))) Then
          Begin Error(Of_Or_OtkrSkobka_Expected,ONs+1);Continue; End;
        If St[1]='(' Then Begin
          Delete(St,1,1);
          If St[Length(St)]<>')' Then Begin Error(ZakrSkobka_Expected,ONs+1);Continue; End;
          Dec(St[0]);
          St:=St+',';
          Repeat
            S:=Copy(St,1,Pos(',',St)-1);
            If (Length(S)>8) And (Copy(S,1,9)='OPTIONAL ') Then Delete(S,1,9);
            For I:=1 To NUT Do If Copy(S,1,8)=UsedTypes[I] Then Break;
            If Copy(S,1,8)<>UsedTypes[I] Then Begin Error(Unknown_Type,ONs+1);Break; End;
            Delete(St,1,Pos(',',St));
          Until St='';
          If St<>'' Then Continue;
        End Else Begin
          Delete(St,1,4);
          For I:=1 To NUT Do If Copy(St,1,8)=UsedTypes[I] Then Break;
          If Copy(St,1,8)<>UsedTypes[I] Then Begin Error(Unknown_Type,ONs+1);Continue; End;
        End;
      End;
      If S='MULTI' Then Begin
        If (ST[0]<=#5) Or (St[6]<>' ') Then Begin Error(Set_Expected,ONs+1);Continue; End;
        Delete(St,1,6);
        S:=Copy(St,1,Min(Pos(' ',St),Min(Pos('(',St),Pos('.',St)))-1);
        If S<>'SET' Then Begin Error(Set_Expected,ONs+1);Continue; End;
      End;
      If S='SET' Then Begin
        ok:=true;
        If Min(Pos(' ',St),Pos('(',St))=0 Then Begin Error(Of_Or_OtkrSkobka_Expected,ONs+1);Continue; End;
        Delete(St,1,Min(Pos(' ',St),Pos('(',St))-1);
        If (St='') Or ((St[1]<>'(') And ((St[0]=#1) Or (St[1]+St[2]+St[3]+St[4]<>' OF '))) Then
          Begin Error(Of_Or_OtkrSkobka_Expected,ONs+1);Continue; End;
        If St[1]='(' Then Begin
          Delete(St,1,1);
          If St[Length(St)]<>')' Then Begin Error(ZakrSkobka_Expected,ONs+1);Continue; End;
          Dec(St[0]);
          St:=St+',';
          Repeat
            S:=Copy(St,1,Pos(',',St)-1);
            For I:=1 To NUT Do If Copy(S,1,8)=UsedTypes[I] Then Break;
            If Copy(S,1,8)<>UsedTypes[I] Then Begin Error(Unknown_Type,ONs+1);Break; End;
            Delete(St,1,Pos(',',St));
          Until St='';
          If St<>'' Then Continue;
        End Else Begin
          Delete(St,1,4);
          For I:=1 To NUT Do If Copy(St,1,8)=UsedTypes[I] Then Break;
          If Copy(St,1,8)<>UsedTypes[I] Then Begin Error(Unknown_Type,ONs+1);Continue; End;
        End;
      End;
      If S='' Then Begin
        Ok:=True;
        Delete(St,1,1);
        If St[Length(St)]<>')' Then Begin Error(ZakrSkobka_Expected,ONs+1);Continue; End;
        Dec(St[0]);
        St:=St+',';
        ONUN:=NUN;
        If NUP=MaxPere Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Continue; End;
        Inc(NUP);
        NUPN[NUP]:=0;
        Repeat
          S:=Copy(St,1,Pos(',',St)-1);
          For I:=1 To NUN Do If Copy(S,1,8)=UsedNames[I] Then Break;
          If Copy(S,1,8)=UsedNames[I] Then Begin Error(Duplicate_Intendifier,ONs+1);NUN:=ONUN;Dec(NUP);Break; End;
          If NUN=MaxName Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Continue; End;
          Inc(NUN);
          For I:=1 To Length(S) Do If Not (S[I] In ['A'..'Z',''..'','0'..'9','$','_','?']) Then Break;
          If Not (S[I] In ['A'..'Z',''..'','0'..'9','$','_','?']) Then Begin Error(Syntax_Error,ONs+1);Break; End;
          For I:=1 To NumReserved Do If Copy(S,1,8)=Reserved[I] Then Break;
          If Copy(S,1,8)=Reserved[I] Then Begin Error(Cannot_Use_Reserved_Words_As_Intendifiers,ONs+1);Break; End;
          For I:=1 To NUN Do If Copy(S,1,8)=UsedNames[I] Then Break;
          If Copy(S,1,8)=UsedNames[I] Then Begin Error(Duplicate_Intendifier,ONs+1);Break; End;
          If NUN=MaxName Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Break; End;
          UsedNames[NUN]:=Copy(S,1,8);
          If NUPN[NUP]=MaxPereNum Then Begin Error(Too_Big_Type,ONs+1);Break; End;
          Inc(NUPN[NUP]);
          UsedPere[NUP,NUPN[NUP]]:=Copy(S,1,8);
          Delete(St,1,Pos(',',St));
        Until St='';
        If St<>'' Then Continue;
      End;
      If Not Ok Then
        If (Min(Pos(' ',St),Min(Pos('(',St),Pos('.',St)))<Length(St)) And
           (Copy(St,Min(Pos(' ',St),Min(Pos('(',St),Pos('.',St))),2)='..') Then Begin
             SS1:=Copy(St,1,Pos('.',St)-1);
             SS2:=Copy(St,Pos('.',St)+2,255);
             Val(SS1,II,Cnt);
             If Cnt=0 Then Begin
               Val(SS2,II,Cnt);
               If Cnt=0 Then Continue;
             End;
             If (SS1[0]=#3) And (SS2[0]=#3) Then
               If (SS1[1] in ['''','"']) And (SS1[3]=SS1[1]) Then
                 If (SS2[1] in ['''','"']) And (SS2[3]=SS2[1]) Then Continue;
             If (SS1='TRUE') Or (SS1='FALSE') Then
               If (SS2='TRUE') Or (SS2='FALSE') Then Continue;
             For I:=1 To NUP Do Begin
               For J:=1 To NUPN[NUP] Do If Copy(SS1,1,8)=UsedPere[I,J] Then Begin J:=0;Break; End;
               If J=0 Then Begin
                 For J:=1 To NUPN[NUP] Do If Copy(SS2,1,8)=UsedPere[I,J] Then Begin J:=0;Break; End;
                 If J=0 Then Begin I:=0;Break; End;
               End;
             End;
             If I>0 Then Error(Type_Mismatch,ONs+1);
        End Else
          Error(Unknown_Type_Constructor,ONs+1);
      If NUN=MaxName Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Continue; End;
      Inc(NUN);
      UsedNames[NUN]:=Copy(S1,1,8);
      If NUT=MaxType Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Continue; End;
      Inc(NUT);
      UsedTypes[NUT]:=Copy(S1,1,8);
    End Else
    If (length(St)>=9) And (Copy(St,1,9)='CONSTANT ') Then Begin
      Delete(St,1,9);
      If Pos('=',St)=0 Then Begin Error(Ravno_Expected,ONs+1);Continue; End;
      S:=Copy(St,1,Pos('=',St)-1);
      For I:=1 To Length(S) Do If Not (S[I] In ['A'..'Z',''..'','0'..'9','$','_','?']) Then Break;
      If Not (S[I] In ['A'..'Z',''..'','0'..'9','$','_','?']) Then Begin Error(Syntax_Error,ONs+1);Continue; End;
      For I:=1 To NumReserved Do If Copy(S,1,8)=Reserved[I] Then Break;
      If Copy(S,1,8)=Reserved[I] Then Begin Error(Cannot_Use_Reserved_Words_As_Intendifiers,ONs+1);Continue; End;
      For I:=1 To NUN Do If Copy(S,1,8)=UsedNames[I] Then Break;
      If Copy(S,1,8)=UsedNames[I] Then Begin Error(Duplicate_Intendifier,ONs+1);Continue; End;
      If NUN=MaxName Then Begin Error(Too_Many_Types_And_Constants,ONs+1);Continue; End;
      Inc(NUN);
      UsedNames[NUN]:=Copy(S,1,8);
    End Else Error(Type_Or_Constant_Expected,Ons+1);
  End;
End;

Procedure Solve;
Begin
End;

Begin
  OpenFiles;
  Check;
  If Not IsErrors Then Solve;
  CloseFiles;
End.