{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,0}
Uses
  Crt;
Const
  Count=19;
  Reserved:Array[1..Count] Of String[8]=('INTEGER','CHAR','BOOLEAN','STRING',
    'ORD','CHR','PRED','SUCC','OR','AND','NOT','DEFINE','CONSTANT','TYPE',
    'SET','SEQUENCE','OF','OPTIONAL','MULTI');
  LitChars:String[62]='abcdefghijklmnopqrstuvwxyz';
  BigChars:String[62]='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  Letter:Set Of Char=['A'..'Z','a'..'z',''..'',''..'',''..'','0'..'9','.','$','_','?'];
Type
  TDifType=(Int,Bool,Str,Cnt,FromTo);
  TType=Record
    Name:String[100];
    v:TDifType;
    xFrom,xTo:Record
      t:(tInt,tCh,tBool,tCnt);
      Value:Integer;
    End;
  End;
  TConst=Record
    Name:String[100];
    v:(cInt,cBool,cStr,cCnt,cFromTo);
    x:Integer;
    Value:String;
  End;

Var
  HaveErrors:Boolean;
  Line:Integer;
  f:File Of Char;
  g,e:Text;
  c:Char;
  Types,Consts:Byte;
  Typ:Array[1..100] Of TType;
  Con:Array[1..100] Of TConst;
  sp:Byte;

Procedure FindTypes;
Var
  l:TDifType;
  k:Boolean;
  i,j:Byte;
Begin
  Rewrite(g);
  For i:=1 To Consts Do
  Begin
    Write(g,Con[i].Name,': ');
    k:=True; l:=FromTo;
    Case Con[i].v Of
      cInt:  Begin If k Then Write(g,'Integer') Else Write(g,', Integer'); k:=False; l:=Int;  End;
      cBool: Begin If k Then Write(g,'Boolean') Else Write(g,', Boolean'); k:=False; l:=Bool; End;
      cStr:  Begin If k Then Write(g,'String')  Else Write(g,', String');  k:=False; l:=Str;
                   If Con[i].Value[0]=#1 Then Write(g,', Char'); End;
    End;
    If Con[i].v=cStr Then
    Begin
      j:=1;
      While j<=Byte(Con[i].Value[0]) Do
        If Con[i].Value[j]=#39 Then Begin Insert(#39,Con[i].Value,j); Inc(j,2) End Else Inc(j);
      Con[i].Value:=#39+Con[i].Value+#39;
    End;
    For j:=1 To Types Do
      If Typ[j].v=l Then
      Begin
        If k Then k:=False Else Write(g,', ');
        Write(g,Typ[j].Name);
      End;
    Write(g,' = ');
    If Con[i].v=cInt Then WriteLn(g,Con[i].x) Else WriteLn(g,Con[i].Value);
  End;
End;

Procedure EndProgram;
Begin
  Close(f);
  If HaveErrors Then Close(e) Else
  Begin
    Rewrite(g);
    FindTypes;
    Close(g);
  End;
  Halt;
End;

Function UCase(s:String):String;
Var
  i:Byte;
Begin
  For i:=1 To Byte(s[0]) Do
   If Pos(s[i],LitChars)<>0 Then s[i]:=BigChars[Pos(s[i],LitChars)];
  UCase:=s;
End;

Procedure Error(s:String);
Begin
  TextAttr:=12; Write('   ',Line,':'); While WhereX<>24 Do Write(' ');
  TextAttr:= 7; WriteLn(s);
  If Not HaveErrors Then
  Begin
    HaveErrors:=True;
    Rewrite(e);
  End;
  WriteLn(e,'  ',Line:6,': ',s);
End;

Procedure Spaces;
Begin
  While (c In [' ',#13,#10]) And (Not Eof(f)) Do
  Begin
    If c=#13 Then Inc(Line);
    Read(f,c);
  End;
End;

Procedure GoToNext;
Begin
  While Not (Eof(f) Or (c=';')) Do
  Begin
    If c=#13 Then Inc(Line);
    Read(f,c);
  End;
End;

Function ReadName(Types:Boolean):String;
Var
  i:Byte;
  s:String;
Begin
  s:='';
  While c In Letter Do
  Begin
    s:=s+c;
    If Eof(f) Then
    Begin
      Error('०६  䠩');
      ReadName:=''; Exit;
    End;
    Read(f,c);
  End;
  Spaces;
  s:=UCase(Copy(s,1,8));
  If s='' Then
  Begin
    Error(' 䨪');
    ReadName:=''; Exit;
  End;
  If (s[1] In ['0'..'9']) Or (Pos('.',s)>1) Then
  Begin
    Error(' 䨪');
    ReadName:=''; Exit;
  End;
  For i:=1 To Count Do
    If Reserved[i]=s Then
      If Not ((Types) And (i<5)) Then
      Begin
        Error('祢 ᫮  ⢥ 䨪');
        ReadName:=''; Exit;
      End;
  ReadName:=s;
End;

Function ReadWord:String;
Label
  Restart;
Const
  Avail:Set Of Char=[#33..#58,#60..#255];
Var
  s:String;
Begin
Restart:
  s:='';
  While c In Avail Do
  Begin
    s:=s+c;
    If Eof(f) Then
    Begin
      c:=' ';
      Break;
    End;
    Read(f,c);
  End;
  If Copy(s,1,2)='//' Then
  Begin
    While c<>#13 Do
      Read(f,c);
    Spaces;
    GoTo Restart;
  End;
  If c In [' ',',',';',#13,#10] Then Spaces Else
  Begin
    s:='';
    Error('⨬ ᨬ: '''+c+'''');
  End;
  ReadWord:=s;
End;

Function CountValue(Var s:String):Integer;
Var
  n:Integer;

  Procedure Spaces;
  Begin
    While s[sp]=' ' Do Inc(sp);
  End;

  Function ReadFact:Integer;
  Var
    Sign:Boolean;
    n:Integer;
  Begin
    Spaces;
    n:=0; Sign:=False;
    While s[sp] In ['+','-'] Do
    Begin
      If s[sp]='-' Then Sign:=Not Sign;
      Inc(sp);
    End;
    If s[sp]='(' Then
    Begin
      Inc(sp);
      n:=CountValue(s);
      Inc(sp);
    End
    Else
      While s[sp] In ['0'..'9'] Do
      Begin
        n:=n*10+Byte(s[sp])-48;
        Inc(sp);
      End;
    Spaces;
    If Sign Then n:=-n;
    ReadFact:=n;
  End;

  Function ReadTerm:Integer;
  Var
    n:Integer;
  Begin
    n:=ReadFact;
    While s[sp] In ['*','/','M'] Do
      Case s[sp] Of
        '*': Begin Inc(sp); n:=n*ReadFact; End;
        '/': Begin Inc(sp); n:=n Div ReadFact; End;
        'M': Begin Inc(sp,3); n:=n Mod ReadFact; End;
      End;
    ReadTerm:=n;
  End;

Begin
  n:=ReadTerm;
  While s[sp] In ['+','-',')'] Do
    Case s[sp] Of
      '+': Begin Inc(sp); Inc(n,ReadTerm); End;
      '-': Begin Inc(sp); Dec(n,ReadTerm); End;
      ')': Begin CountValue:=n; Exit; End;
    End;
  CountValue:=n;
End;

Function CountBool(Var s:String):Boolean;
Var
  n,k:Boolean;

  Procedure Spaces;
  Begin
    While s[sp]=' ' Do Inc(sp);
  End;

  Function ReadFact:Boolean;
  Var
    Sign,n:Boolean;
  Begin
    Spaces;
    Sign:=False;
    While s[sp]='N' Do
    Begin
      Sign:=Not Sign;
      Inc(sp,3);
      Spaces;
    End;
    If s[sp]='(' Then
    Begin
      Inc(sp);
      n:=CountBool(s);
      Inc(sp);
    End
    Else
      Case s[sp] Of
        'T': Begin Inc(sp,4); n:=True; End;
        'F': Begin Inc(sp,5); n:=False; End;
      End;
    Spaces;
    If Sign Then n:= Not n;
    ReadFact:=n;
  End;

Begin
  n:=ReadFact;
  While s[sp] In ['O','A',')'] Do
    Case s[sp] Of
      'O': Begin Inc(sp,2); k:=ReadFact; n:=n Or k; End;
      'A': Begin Inc(sp,3); k:=ReadFact; n:=n And k; End;
      ')': Begin CountBool:=n; Exit; End;
    End;
  CountBool:=n;
End;

Procedure ReadSentence;
Var
  i:Byte;
  s:String;
  s1:String[8];
Begin
  Spaces;
  If Eof(f) Then Exit;
  If c<>';' Then Error('ﭮ '';'''); Read(f,c); Spaces;
  s:=UCase(ReadWord+' '+ReadWord);
  If s='DEFINE CONSTANT' Then
  Begin
    s:=ReadName(False); s1:=Copy(s,1,8);
    If s='' Then Begin GoToNext; Exit; End;
    For i:=1 To Consts Do
      If Copy(Con[i].Name,1,8)=s1 Then Begin Error(' 㦥 ᯮ짮'); GoToNext; Exit; End;
    For i:=1 To Types Do
      If Copy(Typ[i].Name,1,8)=s1 Then Begin Error(' 㦥 ᯮ짮'); GoToNext; Exit; End;
    If c<>'=' Then Begin Error('ﭮ ''='''); GoToNext; Exit; End;
    Read(f,c); Spaces;
    If c=';' Then Begin Error('祭 ⠭  '); GoToNext; Exit; End;
    Inc(Consts); Con[Consts].Name:=s;
    Con[Consts].Value:=ReadWord;
    If Not (Con[Consts].Value[1] In ['{',#34,#39]) Then
    Begin
      Con[Consts].Value:=Con[Consts].Value+' ';
      While Not (Eof(f) Or (c In [#13,';',','])) Do
      Begin
        Con[Consts].Value:=Con[Consts].Value+c;
        Read(f,c);
      End;
      Spaces;
    End;
    With Con[Consts] Do
    Begin
      v:=cFromTo;
      If Value[1]=#39 Then
        If Value[Byte(Value[0])]<>#39 Then
          Begin
            Error('⠭  ୮'); GoToNext; Exit;
          End
        Else
          Begin
            v:=cStr;
            Delete(Value,1,1); Dec(Value[0]);
            Repeat
              i:=Pos(#39'+'#39,  Value); If i<>0 Then Begin Delete(Value,i,3); Continue; End;
              i:=Pos(#39' + '#39,Value); If i<>0 Then Begin Delete(Value,i,5); Continue; End;
            Until i=0;
            i:=1;
            While i<Byte(Value[0]) Do
              If Value[i]+Value[i+1]=#39#39 Then Begin Delete(Value,i,1); Inc(i,2); End Else Inc(i);
        End
      Else If Value[1]=#34 Then
        If Value[Byte(Value[0])]<>#34 Then
          Begin
            Error('⠭  ୮'); GoToNext; Exit;
          End
        Else
          Begin
            v:=cStr;
            Delete(Value,1,1); Dec(Value[0]);
            Repeat
              i:=Pos(#34'+'#34,  Value); If i<>0 Then Begin Delete(Value,i,3); Continue; End;
              i:=Pos(#34' + '#34,Value); If i<>0 Then Begin Delete(Value,i,5); Continue; End;
            Until i=0;
            i:=1;
            While i<Byte(Value[0]) Do
              If Value[i]+Value[i+1]=#34#34 Then Begin Delete(Value,i,1); Inc(i,2); End Else Inc(i);
        End;
      If (Value[1] In ['(','0'..'9','+','-','T','t','F','f']) And (v=cFromTo) Then
      Begin
        sp:=1; s:=s+#0; Value:=UCase(Value);
        If (Pos('TRUE',Value)<>0) Or (Pos('FALSE',Value)<>0) Then
        Begin
          v:=cBool;
          If CountBool(Value) Then Value:='TRUE' Else Value:='FALSE';
        End
        Else
        Begin
          v:=cInt;
          x:=CountValue(Value);
        End;
      End;
    End;
  End Else
  If s='DEFINE TYPE' Then
  Begin
    s:=ReadName(False); s1:=Copy(s,1,8);
    If s='' Then Begin GoToNext; Exit; End;
    For i:=1 To Consts Do
      If Copy(Con[i].Name,1,8)=s1 Then Begin Error(' 㦥 ᯮ짮'); GoToNext; Exit; End;
    For i:=1 To Types Do
      If Copy(Typ[i].Name,1,8)=s1 Then Begin Error(' 㦥 ᯮ짮'); GoToNext; Exit; End;
    If c<>'=' Then Begin Error('ﭮ ''='''); GoToNext; Exit; End;
    Read(f,c); Spaces;
    If c=';' Then Begin Error('  '); GoToNext; Exit; End;
    Inc(Types); Typ[Types].Name:=s; Typ[Types].v:=FromTo; s:='';
    s:=UCase(ReadWord);
    If s='BOOLEAN' Then Typ[Types].v:=Bool;
    If (s='STRING') Or (s='CHAR') Then Typ[Types].v:=Str;
    If s='INTEGER' Then Typ[Types].v:=Int;
    GoToNext;
  End Else
  If s<>' ' Then
  Begin
    Error('⨬ ।');
    GoToNext;
  End
  Else GoToNext;
End;

Begin
  HaveErrors:=False;
  Assign(e,'Program.Err');
  Assign(g,'Program.Out');
  Assign(f,'Program.Ddl');
  Reset(f);
  If Eof(f) Then
  Begin
    Rewrite(g); Close(g); Close(f); Halt;
  End;
  c:=';'; Line:=1; Types:=0; Consts:=0; ClrScr;
  While Not Eof(f) Do
    ReadSentence;
  EndProgram;
End.
