program macro;

{$define xinfso}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}


uses
{$ifdef xinfo}
 crt,
{$endif}

 strings;

(****
reserved words:
multi,optional,define,sequence,type,constant,set,of
***************************************************
identifier,number,special symbol
****)

type tlex=(_opr,_num,_ident,_prident,_rword,_symbol,_open,_close,
     _openfig,_closefig,__string,_comma,_nul);
     rword=(_multi,_optional,_define,_sequence,_type,_constant,_set,_of);
     prid=(_integer,_char,_boolean,_string,_true,_false);
     opr=(_plus,_minus,_mul,_div,_mod,_ord,_chr,_or,_and,_not,_pred,_succ,
     _l,_g,_e,_le,_ge,_ne,_pp,__plus,__minus,__mul);

     str8=string[8];
     plineelem=^lineelem;
     lineelem=record
       next:plineelem;
       lex:tlex;
       case tlex of
       _opr:(opt:opr);
       _num:(value:integer);
       _ident:(id:str8);
       _prident:(pr:prid);
       _rword:(wn:rword);
       _symbol:(s:char);
       _string:(mys:^string);
       end;


{
type                              | id  | detection
----------------------------------+-----+----------
equal to id                       | eid | id only
equal to reserved                 | erv | reserved 0..3
limited type number .. number     | lnn | number
limited type boolean .. boolean   | lbb | boolean
limited type char..char           | lcc | string [1]
limited type id..id               | lid | id ..
enumerated type                   | enm | (
sequence                          | seq |
sequence of                       | seo |
set                               | set |
multiset                          | mse |
seqconcat                         | sec |
setadd                            | sea |
setsub                            | ses |
setint                            | sei |
}
     tttype=(_eid,_erv,_lnn,_lbb,_lcc,_lid,_enm,_seq,_seo,__set,_mse,_sea,_ses,_sei);
     ptype=^ttype;
     ttype=record
       next:ptype;
       xv:tttype;
       name:str8;{#7 for fake-types}
     end;

{constant types:
number -- num
list   -- lis
string -- str
}
     ttconst=(_nmu,_lis,_str);
     pconst=^tconst;
     tconst=record
       next:pconst;
       desc:ttconst;
       name:str8;
       case ttconst of
       _nmu:(n:integer);
       _str:(mys:^string);
     end;

{not evaluated (0) = _nev
 evaluating (1) = _eva
 evaluated (2) = _evd}

     tstate=(_nev,_eva,_evd);


const rr:array [rword] of str8=
('multi','optional','define','sequence','type','constant','set','of');
      pp:array [prid] of str8=
('integer','char','boolean','string','true','false');
      oo:array [opr] of str8=
('+','-','*','/','mod','ord','chr','or','and','not','pred','succ','<','>',
'=','<=','>=','<>','..','plus','minus','mul');
      mxsp=8;
      sps:array [1..mxsp] of char=('+','-','*','/','<','>','=','.');

      gpfdesc:pchar=
      'Extended general protection fault description:'#13#10+
      'General Protection Fault (GPF) is result of following situations:'#13#10+
      '1. Numeric reference to non-numeric constant'#13#10+
      '2. Unrecognized test error'#13#10;
      gpfdesc2:pchar=
      '3. Expression could not be evaluated'#13#10+
      '4. Any non-standard error'#13#10+
      '5. Reference constant --> type, ex: 2+integer'#13#10;

      unrecdsc:pchar=
      'Extended info about unrecognized error:'#13#10+
      'Unrecognized error is ... unrecognized error!!!!! ;)'#13#10;


var le:array [1..2000] of record
       le:lineelem;
       id:str8;
       state:tstate;
       __type:boolean;
    end;
    i,l:integer;
    lec:integer;
    o1,o2:text;
    a:string;
    cur:plineelem;
    s:longint;
    ftype:ttype;
    fconst:tconst;
    q:pconst;
    t:ptype;
    tt:boolean;





function lowcase (c:char):char;
begin
case c of
'A'..'Z',''..'':lowcase:=char (byte (c)+32);
''..'':lowcase:=char (byte (c)+80);
else lowcase:=c;
end;
end;


procedure next;{nextlex}
begin
new (cur^.next);
cur:=cur^.next;
cur^.next:=nil;
end;




procedure error (i:integer;err:string;xinfo:pchar);
begin
writeln ('Error ',i,': ',err,', position unknown');
write (xinfo);
writeln ('Original line unknown');
rewrite (o1);
writeln (o1,'Error ',i,': ',err,', position unknown');
write (o1,xinfo);
writeln (o1,'Original line unknown');
close (o1);
halt;
end;



procedure exitit;far;
begin
if erroraddr<>nil then
  begin
    inoutres:=0;
    erroraddr:=nil;
    error (17,'unrecognized error',unrecdsc);
  end;
end;




procedure gpf;
begin
error (13,'General protection fault ;)',strcat (gpfdesc,gpfdesc2));
end;


procedure evaluate (i:integer;var c:pconst;var t:ptype;var cnst:boolean);forward;


function evaluatenumericid (id:str8):integer;
var q:pconst;t:ptype;tt:boolean;
begin
q:=@fconst;
while q^.next<>nil do
  begin
    if q^.name=id then
      if q^.desc<>_nmu then gpf
      else begin evaluatenumericid:=q^.n;exit;end;
    q:=q^.next;
  end;
for i:=1 to lec do
  if le[i].id=id then
    begin
    if not le[i].__type then gpf;
    evaluate (i,q,t,tt);
    if q^.desc<>_nmu then gpf;
    evaluatenumericid:=q^.n;
    exit;
    end;
error (16,'Unknown identifier '+id,'');
end;

procedure _next (var cur:plineelem);
begin
cur:=cur^.next;
end;

function expression (var cur:plineelem):integer;forward;

function mnozitel (var cur:plineelem):integer;
begin
case cur^.lex of
_open:begin _next (cur);mnozitel:=expression (cur);if cur^.lex=_close
then _next (cur) else error (12,''')'' expected','');end;
_num:begin mnozitel:=cur^.value;_next (cur);end;
_ident:begin mnozitel:=evaluatenumericid (cur^.id);_next (cur);end;
else gpf;
end;
end;

function adder (var cur:plineelem):integer;
var r,qa:integer;
begin
  r:=mnozitel (cur);
  while (cur^.lex=_opr) and ((cur^.opt=_mul) or (cur^.opt=_div) or (cur^.opt=_mod)) do
    if cur^.opt=_mul then begin _next (cur);r:=r*mnozitel (cur);end
    else
    if cur^.opt=_div then begin _next (cur);qa:=mnozitel (cur);
    if qa=0 then error (15,'division by zero','');r:=r div qa;end
    else
    begin _next (cur);qa:=mnozitel (cur);
    if qa=0 then error (15,'division by zero','');r:=r mod qa;end;
  adder:=r;
end;


function expression;
var r:integer;
begin
  r:=adder (cur);
  while (cur^.lex=_opr) and ((cur^.opt=_plus) or (cur^.opt=_minus)) do
    if cur^.opt=_plus then begin _next (cur);r:=r+adder (cur);end
    else begin _next (cur);r:=r-adder (cur);end;
  expression:=r;
end;


function addconst:pconst;
var b:pconst;
begin
b:=@fconst;
while b^.next<>nil do b:=b^.next;
addconst:=b;
new (b^.next);
b^.next^.next:=nil;
end;



function addtype:ptype;
var b:ptype;
begin
b:=@ftype;
while b^.next<>nil do b:=b^.next;
addtype:=b;
new (b^.next);
b^.next^.next:=nil;
end;






function getconst (var cur:plineelem;name:str8):pconst;
var n,a:integer;
    s:pconst;
    g:plineelem;
begin
(*case cur^.lex of
_openfig:begin
      cur:=cur^.next;
      getconst:=getconst (cur,#7);
      while cur^.lex=_comma do getconst:=getconst (cur,#7);
      if cur^.lex<>_closefig then error (8,'''}'' expected','');
    end;
_num:begin
       n:=expression (cur);
       s:=addconst;
       s^.desc:=_nmu;
       s^.name:=name;
       s^.n:=n;
       getconst:=s;
       if cur^.lex<>_nul then error (14,'expression incorrectly terminated','');
     end;
    {n:=expression;}*)
if cur^.lex=_openfig then gpf;
g:=cur;
n:=expression (g);
if g^.lex=_nul then
  begin
    s:=addconst;
    s^.desc:=_nmu;
    s^.name:=name;
    s^.n:=n;
    getconst:=s;
    exit;
  end;
end;


function gettype (var cur:plineelem;name:str8):pconst;
begin
end;



procedure preevaluate (lec:integer);
var ncur:plineelem;
    id:str8;
begin
if (le[lec].le.next=nil) and (le[lec].le.lex=_nul) then exit;
if (le[lec].le.lex<>_rword) or (le[lec].le.wn<>_define) then error (3,'''define'' expected','');

cur:=le[lec].le.next;
if cur^.lex<>_rword then error (4,'''constant'' or ''type'' expected','');

if cur^.wn=_type then
{type}
  begin
    cur:=cur^.next;
    if cur^.lex<>_ident then error (6,'identifier expected','');
    id:=cur^.id;
    {$ifdef xinfo}
    writeln (' type definition = ',id);
    {$endif}
    le[lec].id:=id;
    cur:=cur^.next;
    if (cur^.lex<>_opr) or (cur^.opt<>_e) then error (7,'''='' expected','');
    cur:=cur^.next;
  end
else
if cur^.wn=_constant then
{const}
  begin
    cur:=cur^.next;
    if cur^.lex<>_ident then error (6,'identifier expected','');
    id:=cur^.id;
    {$ifdef xinfo}
    writeln (' constant definition = ',id);
    {$endif}
    le[lec].id:=id;
    cur:=cur^.next;
    if (cur^.lex<>_opr) or (cur^.opt<>_e) then error (7,'''='' expected','');
    cur:=cur^.next;
    le[lec].__type:=true;
  end
else error (4,'''constant'' or ''type'' expected','');

{dispose}
{cur:=le[lec].next;
while cur<>nil do
  begin
    if cur^.lex=__string then
      dispose (cur^.mys);
    ncur:=cur^.next;
    dispose (cur);
    cur:=ncur;
  end;
le[lec].next:=nil;
le[lec].lex:=_nul;
cur:=@le;}
end;



procedure evaluate (i:integer;var c:pconst;var t:ptype;var cnst:boolean);
begin
if le[i].state=_evd then exit;
if le[i].state=_eva then error (11,'recursive forward reference','');
{$ifdef xinfo}
writeln (' evaluating identifier ',le[i].id);
{$endif}
le[i].state:=_eva;
cnst:=le[i].__type;
if cnst then
  begin
    {$ifdef xinfo}
    writeln ('  detected constant type');
    {$endif}
    c:=getconst (le[i].le.next^.next^.next^.next,le[i].id);
  end;
le[i].state:=_evd;
end;



procedure prnext;
begin
cur^.lex:=_nul;
inc (lec);
le[lec].le.lex:=_nul;
cur:=@le[lec].le;
end;




procedure processline (a:string);
var k:integer;
    s:string;
    a1:rword;
    a2:prid;
    a3:opr;
    found:boolean;
begin
s:=a;
k:=pos ('//',s);
if k>0 then s[0]:=chr (k-1);
k:=1;
inc (s[0]);
s[byte (s[0])]:=#0;
while k<=length (s) do
  case lowcase (s[k]) of
    '0'..'9':begin
	     cur^.lex:=_num;
	     cur^.value:=0;
	     while s[k] in ['0'..'9'] do
	       begin
		 cur^.value:=cur^.value*10+(ord (s[k])-48);
		 inc (k);
	       end;
	     next;
	     end;
    ' ':inc (k);
    'a'..'z',''..'',''..'','.','_','$','?':
       begin
	 cur^.lex:=_ident;
	 cur^.id:='';
	 found:=false;
	 repeat
	 if length (cur^.id)<8 then cur^.id:=cur^.id+lowcase (s[k]);
	 inc (k);
	 until not (lowcase (s[k]) in ['0'..'9','a'..'z',''..'',''..'','_','$','?']);
	 for a1:=_multi to _of do
	   begin
	     if cur^.id=rr[a1] then
	       begin
		 found:=true;
		 cur^.lex:=_rword;
		 cur^.wn:=a1;
		 break;
	       end;
	   end;
	 if not found then
	   begin
	     for a2:=_integer to _false do
	       begin
		 if cur^.id=pp[a2] then
		   begin
		     found:=true;
		     cur^.lex:=_prident;
		     cur^.pr:=a2;
		     break;
		   end;
	       end;
	     if not found then
	       begin
		 for a3:=_plus to _ne do
		   begin
		     if cur^.id=oo[a3] then
		       begin
			 found:=true;
			 cur^.lex:=_opr;
			 cur^.opt:=a3;
			 break;
		       end;
		   end;
	       end;
	   end;
	 next;
       end;
    '+','-','*','/','<','>','=','.':begin
	 cur^.lex:=_ident;
	 cur^.id:='';
	 repeat
	 if length (cur^.id)<8 then cur^.id:=cur^.id+s[k];
	 inc (k);
	 until not (s[k] in ['+','-','*','/','<','>','=','.']);
	 found:=false;
	 for a3:=_plus to _ne do
	   begin
	     if cur^.id=oo[a3] then
	       begin
		 found:=true;
		 cur^.lex:=_opr;
		 cur^.opt:=a3;
		 break;
	       end;
	   end;
	 if not found then
	   begin
	     writeln ('Error 2: unexpected operation sequence "',cur^.id,'", position=',k,', line=',l);
	     writeln ('Original line was:"',a,'"');
	     rewrite (o1);
	     writeln (o1,'Error 2: unexpected operation sequence "',cur^.id,'", position=',k,', line=',l);
	     writeln (o1,'Original line was:"',a,'"');
	     close (o1);
	     halt;
	   end;
	 next;
      end;
    '(':begin cur^.lex:=_open;inc (k);next;end;
    ')':begin cur^.lex:=_close;inc (k);next;end;
    '{':begin cur^.lex:=_openfig;inc (k);next;end;
    '}':begin cur^.lex:=_closefig;inc (k);next;end;
    ',':begin cur^.lex:=_comma;inc (k);next;end;
    '"':begin
	  cur^.lex:=__string;
	  new (cur^.mys);
	  cur^.mys^:='';
	  inc (k);
	  while 2*2=4 do
	    begin
	    while s[k]<>'"' do
	      begin cur^.mys^:=cur^.mys^+s[k];inc (k);end;
	    inc (k);
	    if s[k]='"' then cur^.mys^:=cur^.mys^+'"' else break;
	    end;
	  next;
	end;
    '''':begin
	  cur^.lex:=__string;
	  new (cur^.mys);
	  cur^.mys^:='';
	  inc (k);
	  while 2*2=4 do
	    begin
	    while s[k]<>'''' do
	      begin cur^.mys^:=cur^.mys^+s[k];inc (k);end;
	    inc (k);
	    if s[k]='''' then cur^.mys^:=cur^.mys^+'''' else break;
	    end;
	  next;
	end;
    ';':begin prnext;inc (k);end;
    #0:exit;
    else
      begin
      writeln ('Error 1: unexpected symbol "',lowcase (s[k]),'", position=',k,', line=',l);
      writeln ('Original line was:"',a,'"');
      rewrite (o1);
      writeln (o1,'Error 1: unexpected symbol "',lowcase (s[k]),'", position=',k,', line=',l);
      writeln (o1,'Original line was:"',a,'"');
      close (o1);
      halt;
      end;
  end;
end;







procedure dispallconst;

type list=array [1..10000] of pconst;

var u:pconst;
    p:list;
    i,cp:integer;



procedure QuickSort(var A: List; Lo, Hi: integer);

procedure Sort(l, r: longint);
var
  i, j: integer;
  x,y:pconst;
begin
  i := l; j := r; x := a[(l+r) DIV 2];
  repeat
    while a[i]^.name < x^.name do i := i + 1;
    while x^.name < a[j]^.name do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

begin {QuickSort};
  Sort(Lo,Hi);
end;



procedure sortallconst;
var u:pconst;
begin
cp:=0;
u:=@fconst;
while u^.next<>nil do
  begin
    inc (cp);
    p[cp]:=u;
    u:=u^.next;
  end;
if cp=0 then halt;
QuickSort (p,1,cp);
end;



begin
sortallconst;
for i:=1 to cp do
  case p[i]^.desc of
  _nmu:begin
       writeln (o2,p[i]^.name,':integer=',p[i]^.n);
       end;
  end;
end;



begin
exitproc:=@exitit;
{$ifdef xinfo}
textmode (3);
writeln (' available ',memavail,' memory bytes');
{$endif}
assign (input,'program.ddl');
reset (input);
assign (o1,'program.err');
assign (o2,'program.out');
cur:=@le;
s:=memavail;
ftype.name:=#7;
lec:=1;
le[lec].le.lex:=_nul;
while not eof do
  begin
    readln (a);
    inc (l);
    processline (a);
  end;
if le[lec].le.lex<>_nul then {error (5,'unexpected end of file','');}prnext;
dec (lec);
if lec>1999 then error (10,'   믥ਢ, a?','');
for i:=1 to lec do
preevaluate (i);
for i:=1 to lec do
  case le[i].state of
    _nev:evaluate (i,q,t,tt);
    _eva:error (9,'unexpected internal error or bad test','');
  end;
{if s<>memavail then writeln ('। -: ',s,'=',memavail);}
rewrite (o2);
dispallconst;
close (o2);
{$ifdef xinfo}
writeln (' available ',memavail,' memory bytes');
{$endif}
end.