{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 64384,0,655360}
program _9_9_9_; { DDL }

type TLexema = ( _plus, _minus, _mul, _div, _open, _close, _comma, _dog,
                 _ident, _const, _end, _lt, _gt, _le, _ge, _ne, _eq,
                 _Fopen, _FClose, _pc, _pp, _tail, _unplus, _unminus,
                 _Mod, _Or, _pred, _succ, _and, _ord, _not, _chr,
                 _define, _set, _constant, _type, _optional, _of,
                 _sequence, _multi, _integer, _char, _boolean,
                 _Single, _SPlus, _SMinus, _SMul, _Enum,
                 _string, _str, _true, _false );
     TIdent = String [8];

const SkipSet = [' ',#13,#10];
      NumOf = 20;
      max = 70;
      EndChar = #26;
      MaxTypes = 1000;
      MaxConsts = 1000;
type
      TData = array [0..65000] of byte;
      PData = ^TData;
      PTypePiece = ^TTypePiece;
      TTypePiece = record
                  Multi : boolean;
                    typ : TLexema; { Seq, int, char, str, bool, set, multi }
                    nxt : PTypePiece;
                      v : PTypePiece;
                  lb,ub : integer;
                    opt : boolean;
                     vi : integer;
                   end;
      PConstPiece = ^TConstPiece;
      TConstPiece = record
                     typ : TLexema; { Seq, int, char, str, bool, set, multi }
                     nxt : PConstPiece;
                       v : PConstPiece;
                     vs : string;
                     vi : integer;
                    end;
      TType = record
              name : TIdent;
              p : PTypePiece;
             df : boolean;
             end;
    TConst = record
              name : TIdent;
              p : PConstPiece;
             end;
     PType = ^TType;
     PConst = ^TConst;
     TETypeList = array [1..100] of TIdent;
     TTypeList = array [1..MaxTypes] of PType;
     TConstList = array [1..MaxTypes] of PConst;
     TNum = record
             name : TIdent;
             typ : integer;
             val : integer;
            end;
     TNumList = array[1..100] of TNum;
var CurChar : char;
    CurTypeName : TIdent;
    NumList : TNumlist;
    ETypeList : TETypeList;
    ECol : array[1..100] of integer;
    Enum, ETypes:integer;
    Null:PConstPiece;
    Found : boolean;
    Updated : boolean;
    CurString : String;
    CurLex : TLexema;
    CurIdent : TIdent;
    CurConst : integer;
    lc : integer;
    LexFile : text;
    TempString : string;
    TypeList : TTypeList;
    ConstList : TConstList;
    Types : integer;
   Consts : integer;
   FirstPhase : boolean;

procedure ParseConstDef;forward;
procedure Error(s:string);
var ErrorFile:text;
    s1,h:string;
 begin
  Assign(ErrorFile, 'program.err');
  rewrite(ErrorFile);
  str(lc,h);
  s1 := 'Error in line '+h+':  '+s;
  writeln(ErrorFile,s1);
  writeln(s1);
  close(ErrorFile);
  halt;
 end;

function MUpCase(c:char):char;
 begin
  c := Upcase(c);
  if c = '' then MupCase:='' else
  if c in ['a'..'z',''..''] then MUpCase := char(byte(c)-32)
  else
  if c in [''..''] then MUpCase := char(byte(c)-80) else Mupcase:=c;
 end;

procedure DownCase(var c:char);
 begin
  if c = '' then c:='';
  if c in ['A'..'Z',''..''] then c := char(byte(c)+32);
  if c in [''..''] then c := char(byte(c)+80);
 end;

Function DownString(s:string):string;
var s1:string;
    i:integer;
 begin
  for i:=1 to length(s) do
   DownCase(s[i]);
   DownString := s;
 end;

function GetConstN(var id:TIdent) : integer;
var i:integer;
 begin
  GetConstN := 0;
  for i := 1 to Consts do
   if ConstList[i]^.name = id then GetConstN := i;
 end;

procedure NextChar;
 begin
  if CurChar = #13 then inc(LC);
  if eof(LexFile) then CurChar := EndChar else
  Read(LexFile,CurChar);
 end;

procedure Next;
var i:integer;
label 1,2;
 begin
  while CurChar in SkipSet do NextChar;
  case MUpCase(CurChar) of
  '''' : begin
          CurLex := _Str;
          CurString := '';
       1: nextChar;
          while CurChar<>'''' do
           begin
            if CurChar = #13 then Error('String constant exceeds line.');
            CurString := CurString + CurChar;
            NextChar;
           end;
          nextChar;
          if curchar = '''' then begin
                                  CurString := CurString + '''';
                                  goto 1;
                                 end;
         end;
   '"' : begin
          CurLex := _Str;
          CurString := '';
       2: nextChar;
          while CurChar<>'"' do
           begin
            if CurChar = #13 then Error('String constant exceeds line.');
            CurString := CurString + CurChar;
            NextChar;
           end;
          nextChar;
          if curchar = '"' then begin
                                  CurString := CurString + '"';
                                  goto 2;
                                 end;
         end;
   ';' : begin
          CurLex := _pc;
          nextchar;
         end;
   '(' : begin
          CurLex := _open;
          nextchar;
         end;
   ')' : begin
          CurLex := _close;
          nextchar;
         end;
   '{' : begin
          CurLex := _fopen;
          nextchar;
         end;
   '}' : begin
          CurLex := _fclose;
          nextchar;
         end;
   ',' : begin
          CurLex := _comma;
          nextchar;
         end;
   '@' : begin
          CurLex := _dog;
          nextchar;
         end;
   '+' : begin
          CurLex := _plus;
          nextchar;
         end;
   '-' : begin
          CurLex := _minus;
          nextchar;
         end;
   '*' : begin
          CurLex := _mul;
          nextchar;
         end;
   '/' : begin
          CurLex := _div;
          nextchar;
          if CurChar = '/' then { Comment }
           begin
            inc(lc);
            ReadLn(LexFile,TempString);
            NextChar;
            Next;
           end;
         end;
   '=' : begin
          CurLex := _eq;
          nextchar;
         end;
   '<' : begin
          NextChar;
          if CurChar = '>' then begin
                                 CurLex := _ne;
                                 NextChar;
                                end else
          if CurChar = '=' then begin
                                 CurLex := _le;
                                 NextChar;
                                end else CurLex := _lt;
         end;
   '>' : begin
          NextChar;
          if CurChar = '=' then begin
                                 CurLex := _ge;
                                 NextChar;
                                end else CurLex := _gt;
         end;
   '0'..'9': begin
              CurConst := 0;
              repeat
               CurConst := CurConst * 10 + ord(CurChar) - ord('0');
               NextChar;
              until not (CurChar in ['0'..'9']);
              CurLex := _Const;
             end;
''..'',''..'','A'..'Z','_','.','$','?': begin
               CurIdent := '';
               repeat
                if CurIdent[0] < #8 then
                    CurIdent := CurIdent + MUpCase(CurChar);
                NextChar;
               until not ((MUpCase(CurChar) in ['A'..'Z','0'..'9','_','$','?',
               ''..'',''..'']));
               CurLex := _Ident;
               if CurIdent = 'DEFINE' then CurLex := _define;
               if CurIdent = 'CONSTANT' then CurLex := _constant;
               if CurIdent = 'TYPE' then CurLex := _type;
               if CurIdent = 'OPTIONAL' then CurLex := _optional;
               if CurIdent = 'SEQUENCE' then CurLex := _sequence;
               if CurIdent = 'OF' then CurLex := _of;
               if CurIdent = 'SET' then CurLex := _set;
               if CurIdent = 'MULTI' then CurLex := _multi;
               if CurIdent = 'PRED' then CurLex := _pred;
               if CurIdent = 'MOD' then CurLex := _Mod;
               if CurIdent = 'ORD' then CurLex := _Ord;
               if CurIdent = 'PRED' then CurLex := _pred;
               if CurIdent = 'SUCC' then CurLex := _succ;
               if CurIdent = 'TRUE' then CurLex := _true;
               if CurIdent = 'FALSE' then CurLex := _false;
               if CurIdent = 'PLUS' then CurLex := _SPlus;
               if CurIdent = 'MINUS' then CurLex := _SMinus;
               if CurIdent = 'MUL' then CurLex := _SMul;
               if CurIdent = 'OR' then CurLex := _or;
               if CurIdent = 'AND' then CurLex := _and;
               if CurIdent = 'NOT' then CurLex := _not;
               if CurIdent = 'CHR' then CurLex := _chr;
               if CurIdent = 'INTEGER' then CurLex := _integer;
               if CurIdent = 'CHAR' then CurLex := _char;
               if CurIdent = 'BOOLEAN' then CurLex := _boolean;
               if CurIdent = 'STRING' then CurLex := _string;
               i := GetConstN(CurIdent);
               if i>0 then
                begin
                 if ConstList[i]^.p^.typ = _integer then
                      begin
                       CurLex := _const;
                       CurConst := ConstList[i]^.p^.vi;
                      end;
                 if ConstList[i]^.p^.typ = _boolean then
                      begin
                       if ConstList[i]^.p^.vi = 0 then CurLex := _false else
                                                       CurLex := _true;
                      end;
                 if ConstList[i]^.p^.typ in [_str,_string] then
                      begin
                       CurLex := _str;
                       CurString := ConstList[i]^.p^.vs;
                      end;
                end;
               if CurIdent = '.' then
                if CurChar = '.' then
                 begin
                  nextchar;
                  CurLex := _pp;
                 end;
              end;
   EndChar : CurLex := _End;
    else Error('Unknown symbol');
  end;
 end;

procedure Expected(l:TLexema;s:string);
 begin
  if CurLex <> l then Error(s+' expected') else next;
 end;

procedure LexInit;
 begin
  Assign(LexFile,'program.ddl');
  reset(LexFile);LC := 1;
  NextChar;
  Next;
 end;

procedure LexDone;
 begin
  close(LexFile);
 end;

{ ************************* Syn.Analys *************************** }

procedure NewConstPiece(var p:PConstPiece);
 begin
    new(p);
    with p^ do
     begin
      nxt := nil;
      v := nil;
      typ := _end;
     end;
 end;

procedure NewConst(var id:TIdent);
 begin
  inc(Consts);
  new(ConstList[consts]);
  with ConstList[consts]^ do
   begin
    name := id;
    NewConstPiece(p);
   end;
 end;

procedure NewTypePiece(var p:PTypePiece);
 begin
    new(p);
    with p^ do
     begin
      multi := true;
      lb := -32768;
      ub := 32767;
      nxt := nil;
      v := nil;
      typ := _end;
     end;
 end;

procedure NewType(var id:TIdent);
 begin
  inc(Types);
  new(TypeList[Types]);
  with TypeList[Types]^ do
   begin
    df := false;
    name := id;
    NewTypePiece(p);
   end;
 end;

function GetNumN(var id:TIdent) : integer;
var i:integer;
 begin
  GetNumN := 0;
  for i := 1 to Enum do
   if NumList[i].name = id then GetNumN := i;
 end;

function GetTypeN(var id:TIdent) : integer;
var i:integer;
 begin
  for i := 1 to Types do
   if TypeList[i]^.name = id then begin GetTypeN := i;exit;end;
  NewType(id);
  GetTypeN := Types;
 end;

procedure CopyType(var p1,p2:PTypePiece);
var h,h1:PTypePiece;
 begin
   h := p1;h1:=p2;
   h^ := h1^;
    while h1^.nxt<>nil do
     begin
      newTypePiece(h^.nxt);
      h := h^.nxt;
      h1 := h1^.nxt;
      h^ := h1^;
      newTypePiece(h^.v);
      CopyType(h^.v,h1^.v);
     end;
 end;

procedure ReadType(p:PTypePiece);
var i,i1,i2:integer;
    p1,h:PTypePiece;
    mult : boolean;
label 1,2;
 begin
  if CurLex = _Multi then begin Mult := true;next;end else Mult := false;
  with p^ do
  case CurLex of
   _const,_true,_false,_str:
      begin
         case curlex of
          _false : begin p^.typ := _boolean; p^.lb := 0;end;
           _true : begin p^.typ := _boolean; p^.lb := 1;end;
          _Const : begin p^.typ := _integer; p^.lb := CurConst;end;
            _str : begin p^.typ := _string; p^.lb := byte(Curstring[1]);
                    if CurString[0]<>#1 then Error('Must be Char, not string.');
                   end;
         end;
       next;
       if curlex<>_pp then Error('".." expected.');
       next;
         case curlex of
          _false : begin
                    if p^.typ<>_boolean then Error('Type mismatch');
                    p^.ub := 0;
                   end;
           _true : begin
                    if p^.typ<>_boolean then Error('Type mismatch');
                    p^.ub := 1;
                   end;
          _Const : begin
                    if p^.typ<>_integer then Error('Type mismatch');
                    p^.ub := CurConst;
                   end;
            _str : begin
                    if p^.typ<>_string then Error('Type mismatch');
                    p^.ub := byte(Curstring[1]);
                    if CurString[0]<>#1 then Error('Must be Char, not string.');
                   end;
         end;
       next;
      end;
   _open :
     begin { Enumerated }
      next;
      inc(ETypes);
      EtypeList[ETypes] := CurTypeName;
      inc(ENum);
      if GetNumN(CurIdent) >0 then Error('Duplicate identifier.');
      NumList[ENum].name := CurIdent;
      NumList[ENum].typ := ETypes;
      NumList[ENum].val := 0;
      next;
      i := 0;
      while CurLex = _comma do
       begin
        inc(i);
        next;
        inc(ENum);
        if GetNumN(CurIdent) >0 then Error('Duplicate identifier.');
        NumList[ENum].name := CurIdent;
        NumList[ENum].typ := ETypes;
        NumList[ENum].val := i;
        next;
       end;
      if CurLex<>_Close then Error('No matching ")" in Enumerated Type.');
      next;
      p^.typ := _Enum;
      p^.vi := ETypes;
      ECol[ETypes] := i;
     end;
   _Ident :
     if GetNumN(CurIdent)>0 then
      begin
       i1 := GetNumN(CurIdent);
       next;
       if Curlex<>_pp then error('".." expected.');
       next;
       if CurLex<>_Ident then error('Identifier expected.');
       i2 := GetNumN(CurIdent);
       if i2 = 0 then Error('Bad identifier.');
       if NumList[i1].typ <> NumList[i2].typ then Error('Type mismatch');
       p^.typ := _enum;
       p^.vi := NumList[i1].typ;
       p^.lb := NumList[i1].val;
       p^.ub := NumList[i2].val;
       next;
      end else
     begin
      typ := _single;
      i := GetTypeN(CurIdent);
      p^.v := TypeList[i]^.p;
      next;
     end;
   _Integer, _Char, _String, _Boolean :
     begin
      p^.typ := CurLex;
      next;
     end;
   _sequence :
    begin
     next;
     if CurLex = _of then
       begin
        next;
        p^.typ := _sequence;
        NewTypePiece(p^.v);p^.opt:=true;
        ReadType(p^.v);
        h:=p;
        for i:=1 to NumOf do
         begin
          newTypePiece(h^.nxt);
          h := h^.nxt;
          h^.typ := _tail;
          newTypePiece(h^.v);
          h^.v:=p^.v;h^.opt:=true;
         end;
       end else
     if CurLex = _open then
       begin
        next;
    1: p^.typ := _Sequence;
       if CurLex = _Optional then
           begin p^.opt := true;next;end
            else p^.opt := false;
        NewTypePiece(p^.v);
        ReadType(p^.v);
        if CurLex = _comma then
          begin
           next;
           NewTypePiece(p^.nxt);
           p := p^.nxt;
           goto 1;
          end;
        if CurLex <> _close then Error('No matching ")" in Sequence(...)');
        next;
       end else Error('"Of" or "(" expected.');
    end;

   _set :
    begin
     next;
     if CurLex = _of then
       begin
        p^.multi := mult;
        next;
        p^.typ := _set;
        NewTypePiece(p^.v);p^.opt:=true;
        ReadType(p^.v);
        h:=p;
        for i:=1 to NumOf do
         begin
          newTypePiece(h^.nxt);
          h := h^.nxt;
          h^.typ := _tail;
          newTypePiece(h^.v);
          h^.v:=p^.v;h^.opt:=true;
         end;
       end else
     if CurLex = _open then
       begin
        next;
    2: p^.typ := _Set;
       if CurLex = _Optional then
           begin p^.opt := true;next;end
            else p^.opt := false;
        NewTypePiece(p^.v);
        ReadType(p^.v);
        if CurLex = _comma then
          begin
           next;
           NewTypePiece(p^.nxt);
           p := p^.nxt;
           goto 2;
          end;
        if CurLex <> _close then Error('No matching ")" in Set(...)');
        next;
       end else Error('"Of" or "(" expected.');
    end;
   else Error(' ᠭ ⨯.');
  end;

  if CurLex in [_dog,_SMul,_SPlus,_SMinus] then
   begin
    h := p;
    while (h^.typ = _Single) do h := h^.v;

  if (CurLex = _dog) and (h^.typ = _Sequence) then
   begin
    NewTypePiece(p1);
    next;
    ReadType(p1);
    if p<>h then
    CopyType(p,h);
    h :=p;
    while (p1^.typ = _Single) do p1 := p1^.v;
    while h^.nxt <> nil do h := h^.nxt;
    h^.nxt := p1;
   end;

   end;
 end;

procedure ParseTypeDef;
var id : TIdent;
    i : integer;
 begin
  next;
  Expected(_Ident,'Identifier');
  if FirstPhase then
   begin
     i := GetTypeN (CurIdent);
     if typelist[i]^.df = true then Error('Duplicate identifier');
   end;
  CurTypeName := CurIdent;
  typelist[i]^.df := true;
  Expected(_eq,'"="');
  ReadType(TypeList[i]^.p);
  CurTypeName := 'integer'; { Just something }
 end;

procedure ParseSentence;
 begin
  if CurLex <> _Define then exit;
  next;
  if CurLex = _type then ParseTypeDef else
  if CurLex = _constant then ParseConstDef else
    Error(' ᠭ ⨯  ᠭ ⠭.');
 end;


procedure ParseProgram;
 begin
  ParseSentence;
  while curlex <> _End do
   begin
    if CurLex <> _pc then Error('";" expected.') else Next;
    ParseSentence;
   end;
 end;

procedure SynInit;
 begin
  Enum := 0;
  ETypes := 0;
  Types := 0;
  Consts := 0;
 end;

procedure CheckTypes;
var i:integer;
    s:string;
 begin
  for i := 1 to Types do
   if typelist[i]^.df = false then
    begin
     s:='Undefined type ('+typelist[i]^.name+').';
     Error(s);
    end;
 end;

procedure UpdatePiece(p:PTypePiece);
var h:PTypePiece;
 begin
  h := p;
  while h<>nil do
   begin
    if h^.v^.typ = _single then
     begin
      h^.v^ := h^.v^.v^;
      UpDated := true;
     end;
    h := h^.nxt;
   end;
 end;

procedure UpdateTypes;
var i:integer;
    s:string;
 begin
  Updated := false;
  for i := 1 to Types do
   UpDatePiece(Typelist[i]^.p)
 end;

procedure UpdateTypes2;
var i:integer;
    s:string;
 begin
  Updated := false;
  for i := 1 to Types do
   if Typelist[i]^.p^.typ = _single then
     begin
      typelist[i]^.p := typelist[i]^.p^.v;
      updated := true;
     end;
 end;

procedure ConstExpr(var p:PConstPiece);forward;

procedure ApplyOp(var p1,p2:PConstPiece;op:TLexema);
var h1,h2,h:PConstPiece;
 begin
  if (p1^.typ <> p2^.typ) and (p2<>Null) then error('Type mismatch');
  if p1^.typ = _sequence then
   case op of
   _dog :
       begin
        h := p1;
        while h^.nxt <> nil do h := h^.nxt;
        h^.nxt := p2^.nxt;
       end;
   else
         begin
          if p2<>Null then
           begin { Binary }
            h1 := p1^.nxt; h2:= p2^.nxt;
            while (h1 <> nil) and (h2<>nil) do
             begin
              ApplyOp(h1^.v,h2^.v,op);
              h1 := h1^.nxt;
              h2 := h2^.nxt;
             end;
            if (h1<>nil) or (h2<>nil) then Error('Length mismatch.');
           end else
           begin { Unary }
            h1 := p1^.nxt;
            while (h1 <> nil) do
             begin
              ApplyOp(h1^.v,Null,op);
              h1 := h1^.nxt;
             end;
           end;
         end;
   end else
  if p1^.typ in [_string,_str] then
   case op of
   _plus : p1^.vs := p1^.vs + p2^.vs;
    _Ord : if p1^.vs[0]<>#1 then Error('Must be char, not string.') else
           begin
            p1^.typ := _integer;
            p1^.vi := ord(p1^.vs[1]);
           end;
   else Error('Type mismatch');
   end else
  if p1^.typ = _boolean then
   case op of
    _or : p1^.vi := byte( boolean(p1^.vi) or boolean(p2^.vi));
   _and : p1^.vi := byte( boolean(p1^.vi) and boolean(p2^.vi));
   _not : p1^.vi := 1-p1^.vi;
      _eq : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi=p2^.vi);
            end;
      _ne : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<>p2^.vi);
            end;
      _lt : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<p2^.vi);
            end;
      _gt : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi>p2^.vi);
            end;
      _le : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<=p2^.vi);
            end;
      _ge : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi>=p2^.vi);
            end;
   else Error('Type mismatch');
   end else
  if p1^.typ = _enum then
   case op of
     _ord : begin
             p1^.typ := _integer;
             p1^.vi := p1^.vi mod 100;
            end;
    _pred : begin
             if p1^.vi mod 100 = 0 then inc(p1^.vi,ecol[p1^.vi div 100])
              else dec(p1^.vi);
            end;
    _succ : begin
             if p1^.vi mod 100 = ecol[p1^.vi div 100] then
               dec(p1^.vi,ecol[p1^.vi div 100])
                else inc(p1^.vi);
            end;
   else Error('Type mismatch');
   end else
  if p1^.typ = _integer then
   case op of
     _chr: begin
            p1^.typ := _str;
            p1^.vs[0]:=#1;
            p1^.vs[1]:=char(p1^.vi mod 256);
           end;
      _eq : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi=p2^.vi);
            end;
      _ne : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<>p2^.vi);
            end;
      _lt : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<p2^.vi);
            end;
      _gt : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi>p2^.vi);
            end;
      _le : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi<=p2^.vi);
            end;
      _ge : begin
             p1^.typ := _boolean;
             p1^.vi := byte(p1^.vi>=p2^.vi);
            end;
    _plus : p1^.vi := p1^.vi + p2^.vi;
   _minus : p1^.vi := p1^.vi - p2^.vi;
     _div : p1^.vi := p1^.vi div p2^.vi;
     _Mod : p1^.vi := p1^.vi mod p2^.vi;
     _Mul : p1^.vi := p1^.vi*p2^.vi;
  _UnPlus : p1^.vi := +p1^.vi;
 _UnMinus : p1^.vi := -p1^.vi;
   else Error('Type mismatch');
   end;
 end;

procedure CopyConst(var p1,p2:PConstPiece);
var h,h1:PConstPiece;
 begin
   h := p1;h1:=p2;
   h^ := h1^;
    while h1^.nxt<>nil do
     begin
      newConstPiece(h^.nxt);
      h := h^.nxt;
      h1 := h1^.nxt;
      h^ := h1^;
      newConstPiece(h^.v);
      CopyConst(h^.v,h1^.v);
     end;
 end;


procedure ConstFactor(var p:PConstPiece);
var h,h1:PConstPiece;
    SaveLex:TLexema;
    i:integer;
 begin
  case CurLex of
 _Chr, _Ord, _pred, _succ
      : begin
         SaveLex := CurLex;
        next;
        if CurLex<>_open then error('"(" expected.');
        next;
        ConstFactor(p);
        ApplyOp(p,Null,SaveLex);
        if CurLex<>_close then error('")" expected.');
        next;
       end;
 _Ident: begin
          i := GetConstN(CurIdent);
          if i = 0 then
              begin
               i := GetNumN(CurIdent);
               if i = 0 then
                   Error('Sorry, I''m so stupid that I can''t parse this file.');
               p^.typ := _Enum;
               p^.vi := NumList[i].typ*100+NumList[i].val;
               next;
              end else
              begin
               h := p;
               h1 := ConstList[i]^.p;
               CopyConst(h,h1);
               next;
              end;
         end;
 _Fopen: begin { Sequence  }
          p^.typ := _Sequence;
          h := p;
          while CurLex <> _FClose do
           begin
            if (CurLex<>_FOpen) and (CurLex<>_Comma)
             then Error('No matching "}" in sequence/set.');
            next;
            if CurLex<>_FClose then begin
                                     newConstPiece(h^.nxt);
                                     h := h^.nxt;
                                     h^.typ := _tail;
                                     NewConstPiece(h^.v);
                                     ConstExpr(h^.v);
                                    end;
           end;
          next;
         end;
 _open: begin
         next;
         ConstExpr(p);
         if CurLex <> _close then Error('No matching ")" in expression.');
         next;
        end;
   _str : begin
           p^.typ := CurLex;
           next;
           p^.vs := CurString;
          end;
 _const : begin
           p^.typ := _integer;
           next;
           p^.vi := CurConst;
          end;
 _true : begin
           p^.typ := _boolean;
           next;
           p^.vi := byte(true);
          end;
 _false : begin
           p^.typ := _boolean;
           next;
           p^.vi := byte(false);
          end;
 _minus : begin
           next;
           ConstFactor(p);
           ApplyOp(p,Null,_UnMinus);
          end;
 _plus : begin
           next;
           ConstFactor(p);
           ConstFactor(p);
           ApplyOp(p,Null,_UnPlus);
          end;
 _not : begin
         next;
         ConstFactor(p);
         ApplyOp(p,Null,_Not);
        end;
   else Error('Unexpected lexema in ConstFactor');
  end;
 end;

procedure ConstTerm(var p:PConstPiece);
var p1,p2:PConstPiece;
    op:TLexema;
 begin
  newConstPiece(p1);
  newConstPiece(p2);
  ConstFactor(p1);
  while CurLex in [_mul,_div,_mod,_And,_SMul] do
   begin
    op := CurLex;next;
    ConstFactor(p2);
    ApplyOp(p1,p2,op);
   end;
  p^ := p1^;
  dispose(p1);
  dispose(p2);
 end;


procedure ConstExpr2(var p:PConstPiece);
var h,p1,p2:PConstPiece;
    op:TLexema;
 begin
  newConstPiece(p1);
  newConstPiece(p2);
  ConstTerm(p1);
  while CurLex in [_plus,_minus,_or,_dog,_Splus,_Sminus] do
   begin
    op := CurLex;next;
    ConstTerm(p2);
    ApplyOp(p1,p2,op);
   end;
  p^ := p1^;
  dispose(p1);
  dispose(p2);
 end;

procedure ConstExpr(var p:PConstPiece);
var h,p1,p2:PConstPiece;
    op:TLexema;
 begin
  newConstPiece(p1);
  newConstPiece(p2);
  ConstExpr2(p1);
  while CurLex in [_eq,_ne,_lt,_le,_gt,_ge] do
   begin
    op := CurLex;next;
    ConstExpr2(p2);
    ApplyOp(p1,p2,op);
   end;
  p^ := p1^;
  dispose(p1);
  dispose(p2);
 end;

procedure ParseConstDef;
 begin
  next;
  Expected(_Ident,'Ident');
  if FirstPhase then
  if (GetConstN(CurIdent) <> 0) then
     Error('Duplicate identifier');
  NewConst(CurIdent);
  Expected(_eq,'"="');
  ConstExpr(ConstList[Consts]^.p);
 end;

procedure ChangeToLower;
var i,t:integer;
 begin
  for i:=1 to consts do
   with ConstList[i]^ do
   begin
    for t:= 1 to length(name) do
     DownCase(name[t]);
   end;
 end;

procedure SortConstants;
var i,t:integer;
 begin
  for i:=1 to Consts-1 do
   for t:=i+1 to Consts do
    if ConstList[i]^.name > ConstList[t]^.name then
      begin
       ConstList[MaxConsts] := ConstList[i];
       ConstList[i] := ConstList[t];
       ConstList[t] := ConstList[MaxConsts];
      end;
 end;

procedure WriteString(var s:string);
var i:integer;
 begin
  for i:=1 to length(s) do
    if s[i] = '''' then write('''''') else write(s[i]);
 end;

procedure WriteCPiece(p:PConstPiece);
var b:boolean;
    i:integer;
 begin
  with p^ do
  case typ of
      _enum : begin
               for i:=1 to ENum do
                if (NumList[i].typ = (p^.vi div 100)) and
                   (NumList[i].val = (p^.vi mod 100)) then
                write(DownString(NumList[i].name));
              end;
   _integer : write(vi);
       _str : begin
               write('''');
               writestring(vs);
               write('''');
              end;
   _boolean : if vi=0 then write('false') else write('true');
   _sequence : begin
                write('{');
                p:=p^.nxt;b:=false;
                while p<>nil do
                 begin
                  if b then write(',');
                  WriteCPiece(p^.v);
                  p := p^.nxt;
                  b:=true;
                 end;
                write('}');
               end;
  end;
 end;

procedure WriteCPieceT(p:PConstPiece);
var b:boolean;
    i:integer;
 begin
  with p^ do
  case typ of
      _enum : write(DownString(ETypeList[(p^.vi div 100)]));
   _integer : write('integer');
       _str : write('string');
   _boolean : write('boolean');
   _sequence,_set : begin
                if typ = _set then write('set (') else
                write('sequence (');
                p:=p^.nxt;b:=false;
                if p = nil then
                 write('optional char');
                while p<>nil do
                 begin
                  if b then write(',');
                  WriteCPieceT(p^.v);
                  p := p^.nxt;
                  b:=true;
                 end;
                write(')');
               end;
  end;
 end;

function Suitable(c:PConstPiece;t:PTypePiece) : boolean; forward;

function SuitSet(c:PConstPiece;t:PTypePiece) : boolean;
var cc:array[0..max] of PConstPiece;
    tt:array[0..max] of PTypePiece;
    G:array[0..max,0..max] of boolean;
    i,j,c1,t1:integer;
    ch:PConstPiece;
    th:PTypePiece;
    MarkW :array[0..max] of boolean;
    MyM : array[0..max] of byte;
        function GoWoman(u:integer):boolean;forward;
        function GoMan(m:integer):boolean;
         var i,t:integer;
         begin
          for i:=1 to t1 do
           if g[m,i] and (not MarkW[i]) then
             if GoWoman(i) then
            begin
             GoMan := true;
             MyM[i] := m;
             exit;
            end;
          GoMan := false;
         end;
        function GoWoman(u:integer):boolean;
         begin
          MarkW[u] := true;
          if MyM[u] = 0 then
           GoWoman := true else GoWoman := GoMan(MyM[u]);
         end;

 begin
{  if}
  if (c^.typ <> _set) and (c^.typ<>_sequence) then
      begin SuitSet:=false;exit;end;
  c1:=0;
  t1:=0;
  ch := c^.nxt;
  while ch <> nil do
   begin
    inc(c1);
    cc[c1]:=ch;
    ch := ch^.nxt;
   end;
  th := t;
  while th <> nil do
   begin
    inc(t1);
    tt[t1]:=th;
    th := th^.nxt;
   end;
  for i:=1 to c1 do
  for j:=1 to t1 do
   g[i,j] := Suitable(cc[i]^.v,tt[j]^.v);
  for i:=1 to t1 do
   Mym[i] := 0;
  SuitSet := false;
  for i:=1 to c1 do
   begin
    fillchar(MarkW,sizeof(markW),byte(false));
    if not GoMan(i) then exit;
   end;
  SuitSet := true;
 end;

function SuitSequence(c:PConstPiece;t:PTypePiece) : boolean;
var cc:array[0..max] of PConstPiece;
    tt:array[0..max] of PTypePiece;
    m:array[0..max,0..max] of boolean;
    i,j,c1,t1:integer;
    ch:PConstPiece;
    th:PTypePiece;
 begin
  if (c^.typ <> _set) and (c^.typ<>_sequence) then
       begin SuitSequence:=false;exit;end;
  c1:=0;
  t1:=0;
  ch := c^.nxt;
  while ch <> nil do
   begin
    inc(c1);
    cc[c1]:=ch;
    ch := ch^.nxt;
   end;
  th := t;
  while th <> nil do
   begin
    inc(t1);
    tt[t1]:=th;
    th := th^.nxt;
   end;
  for i:=0 to c1 do m[i,0]:=false;
  for i:=0 to t1 do m[0,i]:=false;
  m[0,0]:=true;
  for i:=0 to c1 do
   for j:=1 to t1 do
    m[i,j] := (m[i,j-1] and (tt[j]^.opt)) or
              (m[i-1,j-1] and Suitable(cc[i]^.v,tt[j]^.v));
  SuitSequence := false;
  SuitSequence := m[c1,t1];
 end;

function Suitable(c:PConstPiece;t:PTypePiece) : boolean;
 begin
  if (c = nil) and (t<>nil) then begin Suitable:=false;exit;end;
  if (t = nil) and (c<>nil) then begin Suitable:=false;exit;end;
  if t^.typ = _enum then begin
                          if (t^.vi = (c^.vi div 100))
                            and (c^.vi mod 100>=t^.lb)
                            and (c^.vi mod 100<=t^.ub)
                           then
                           Suitable := true
                           else Suitable := false;
                           exit;
                         end else
  if t^.typ = _set then begin Suitable := SuitSet(c,t);exit;end;
  if (c^.typ<>t^.typ) and
  (not ((c^.typ=_str) and (t^.typ =_String))) and
  (not ((c^.typ=_str) and (c^.vs[0]=#1) and (t^.typ =_char)))
  then begin Suitable := false;exit;end;
  if c^.typ <> _Sequence then
     begin
      Suitable := false;
      case c^.typ of
       _boolean:
         if (byte(c^.vi) <t^.lb) or (byte(c^.vi) >t^.ub) then exit;
       _integer:
         if (c^.vi <t^.lb) or (c^.vi >t^.ub) then exit;
       _str,_string:
         begin
         if (c^.vs[1] <char(t^.lb)) or (c^.vs[1] >char(t^.ub)) then exit;
         {if c^.vs[0]<>#1 then exit;}
         end;
      end;
      Suitable := true;
      exit;
     end;
  Suitable := SuitSequence(c,t);
 end;

procedure PrintConstants;
var i,t,c : integer;
 begin
  for i:=1 to consts do
   with ConstList[i]^ do
   begin
    write(name,':');
    Found := false; c := 0;
    for t := 1 to Types do
     if Suitable(ConstList[i]^.p,TypeList[t]^.p) then
      begin
       found := true;
       if c>0 then write(', ') else inc(c);
       write(DownString(TypeList[t]^.name));
      end;
    if not Found then writeCPieceT(p);
    write(' = ');
    writeCPiece(p);
    writeln;
   end;
 end;

procedure Answer;
 begin
  ChangeToLower;
  SortConstants;
  PrintConstants;
 end;

begin
 FirstPhase := true;
  repeat
   LexInit;
   SynInit;
   ParseProgram;
   LexDone;
   FirstPhase := false;
  until true;
 CheckTypes;
 repeat UpdateTypes;until not Updated;
 repeat UpdateTypes2;until not Updated;
 Assign(output,'program.out');rewrite(output);
 Answer;
 close(output);
end.