Unit Types;
Interface

Type     PConst=^TConst;

         TTypeDesc=(tdInteger,tdString,tdChar,tdBoolean,tdSequence_Of,tdNone,
                    tdSequence,tdSet_Of,tdMulti_Set,tdSet,tdLimited,tdPere);

         PType=^TType;
         POfType=^TOfType;
         TOfType=Record
                  Optional:Boolean; { Used only in <Sequence> }
                  Desced:Boolean; { If already descripted }
                  OfType:PType;
                  Next:POfType;
                 End;
         TType=Record
                Name:String[8];
                Desc:TTypeDesc;
                OfTypeList:POfType;
                F,T:PConst;
                Next:PType;
               End;

{ Const types }

         PValue=^TValue;
         TValue=Record
                 BT:TTypeDesc;
                 Value:Pointer;
                 Next:PValue;
                End;

         TConst=Record
                 Name:String[8];
                 Save:PValue;
                 Next:PConst;
                End;

{ End const types }

Var      FirstType:PType;
         LastType:PType;
         Found:PType;
         FirstC:PConst;
         LastC:PConst;

         NeedForDesc:Array [1..1000] Of Record
                                         Name:String[8];
                                         OfType:POfType;
                                         Typ:PType;
                                        End;
         NFD:Word;

{ Procedures & Functiones }

Function ExistType(N:String):Boolean;
Function AddType(N:String;D:TTypeDesc;OT:POfType):Byte;
Procedure CopyType(Old,New:String);
Procedure AddInOfTypeList(Var OT:POfType;Name:String;Opt:Boolean);
Procedure Descript(P:PType);

Implementation

Function ExistType;
Var      C:PType;
Begin
 C:=FirstType;
 While C<>Nil Do With C^ Do
 Begin
  If Name=N Then Begin Found:=C; ExistType:=True; Exit; End;
  C:=Next;
 End;
 ExistType:=False; Found:=Nil;
End;

Function AddType;
{ 0 - OK }
{ 1 - EXIST }

Begin
 If ExistType(N) Then Begin AddType:=1; Exit; End;
 If FirstType=Nil Then Begin New(FirstType); LastType:=FirstType; End Else
                       Begin New(LastType^.Next); LastType:=LastType^.Next; End;
 With LastType^ Do
 Begin
  Name:=N;
  Desc:=D;
  OfTypeList:=OT;
  Next:=Nil;
  F:=Nil;
  T:=Nil;
 End;
 Descript(LastType);
End;

Procedure AddInOfTypeList;
Begin
 If OT=Nil Then New(OT) Else Begin New(OT^.Next); OT:=OT^.Next; End;
 With OT^ Do
 Begin
  If Not ExistType(Name) Then
  Begin
   Inc(NFD);
   NeedForDesc[NFD].Name:=Name;
   NeedForDesc[NFD].OfType:=OT;
   NeedForDesc[NFD].Typ:=Nil;
   Desced:=False;
  End Else Desced:=True;
  Optional:=Opt;
  OfType:=Found;
  Next:=Nil;
 End;
End;

Procedure Descript;
Var       I:Word;
Begin
 For I:=1 To NFD Do If NeedForDesc[I].Name=P^.Name Then
 Begin
  If NeedForDesc[I].OfType<>Nil Then
  Begin
   NeedForDesc[I].OfType^.OfType:=P;
   NeedForDesc[I].OfType:=Nil;
  End;
  If NeedForDesc[I].Typ<>Nil Then
  Begin
   NeedForDesc[I].Typ^.OfTypeList:=P^.OfTypeList;
   NeedForDesc[I].Typ^.Desc:=P^.Desc;
   NeedForDesc[I].Typ:=Nil;
  End;
 End;
End;

Procedure CopyType;
Begin
 If ExistType(Old) Then
  AddType(New,Found^.Desc,Found^.OfTypeList) Else
  Begin
   AddType(New,tdNone,Nil);
   Inc(NFD);
   NeedForDesc[NFD].Name:=Old;
   NeedForDesc[NFD].OfType:=Nil;
   NeedForDesc[NFD].Typ:=LastType;
  End;
End;

Begin
 NFD:=0;
End.