{$N+}
Program Rubic_s_Cube;

Type Cubic = Record
               Num : Integer;
               dx,dy,dz : Integer;
             End;
     Cube = Array [-1..+1,-1..+1,-1..+1] Of Cubic;

Var Buf : Array [1..60*1024] Of Byte;
    InitCube,C,C1 : Cube;
    Time : LongInt Absolute $0:$046c;
    t : LongInt;

Procedure Init;
Var x,y,z,k,t : Integer;
Begin
  Assign(Input,'Input.Txt');
  SetTextBuf(Input,Buf);

  t:=0;
  For x:=-1 To +1 Do
    For y:=-1 To +1 Do
      For z:=-1 To +1 Do
        With InitCube[x,y,z] Do
        Begin
          Inc(t); Num:=t;
          dx:=0; dy:=0; dz:=1;
        End;
End;

Function Correct : Boolean;
Var Ch : Char;
Begin
  Correct:=False;
  Reset(Input);

  While Not Eof Do
  Begin
    Read(Ch);
    If Not (Ch In [#10,#13,' ','U','R','F','B','L','D']) Then Exit;
  End;

  Correct:=True;
End;

Function Equal(Var A,B : Cube) : Boolean;
Var AA : Array [1..SizeOf(Cube)] Of Byte Absolute A;
    BB : Array [1..SizeOf(Cube)] Of Byte Absolute B;
    i : Integer;
Begin
  Equal:=False;
  For i:=1 To SizeOf(Cube) Do
    If AA[i]<>BB[i] Then Exit;

  Equal:=True;
End;

Type RotProc = Procedure(x,y,z : Integer; Var x1,y1,z1 : Integer);

Procedure Up(x,y,z : Integer; Var x1,y1,z1 : Integer); Far;
Begin
  x1:=y;
  y1:=-x;
  z1:=z;
End;

Procedure Down(x,y,z : Integer; Var x1,y1,z1 : Integer); Far;
Begin
  x1:=-y;
  y1:=x;
  z1:=z;
End;

Procedure Right(x,y,z : Integer; Var x1,y1,z1 : Integer); Far;
Begin
  x1:=x;
  y1:=z;
  z1:=-y;
End;

Procedure Left(x,y,z : Integer; Var x1,y1,z1 : Integer); Far;
Begin
  x1:=x;
  y1:=-z;
  z1:=y;
End;

Procedure Forward(x,y,z : Integer; Var x1,y1,z1 : Integer); Far;
Begin
  x1:=z;
  y1:=y;
  z1:=-x;
End;

Procedure Backward(x,y,z : Integer; Var x1,y1,z1 : Integer); Far;
Begin
  x1:=-z;
  y1:=y;
  z1:=x;
End;

Procedure Rotate(xn,xk,yn,yk,zn,zk : Integer; Rot : RotProc);
Var x,y,z,x1,y1,z1 : Integer;
Begin
  C1:=C;
  For x:=xn To xk Do
    For y:=yn To yk Do
      For z:=zn To zk Do
        If Abs(x)+Abs(y)+Abs(z)>1 Then
        Begin
          Rot(x,y,z,x1,y1,z1);
          C[x1,y1,z1]:=C1[x,y,z];
          With C[x1,y1,z1] Do
            Rot(dx,dy,dz,dx,dy,dz);
        End;
End;

Function TrueLength : LongInt;
Var Ch : Char;
    Cnt,Last : LongInt;
Begin
  C:=InitCube; Cnt:=0; Last:=0;
  Reset(Input);
  While Not Eof Do
  Begin
    Read(Ch);
    If Ch In ['U','R','F','B','L','D'] Then Inc(Cnt);
    Case Ch Of
      'U' : Rotate(-1,+1,-1,+1,+1,+1,Up);
      'R' : Rotate(+1,+1,-1,+1,-1,+1,Right);
      'F' : Rotate(-1,+1,-1,-1,-1,+1,Forward);
      'B' : Rotate(-1,+1,+1,+1,-1,+1,Backward);
      'L' : Rotate(-1,-1,-1,+1,-1,+1,Left);
      'D' : Rotate(-1,+1,-1,+1,-1,-1,Down);
    End;
    If Equal(C,InitCube) Then Last:=Cnt;
  End;
  TrueLength:=Cnt-Last;
End;

Procedure Make;
Var Ch : Char;
Begin
  Reset(Input);
  While Not Eof Do
  Begin
    Read(Ch);
    Case Ch Of
      'U' : Rotate(-1,+1,-1,+1,+1,+1,Up);
      'R' : Rotate(+1,+1,-1,+1,-1,+1,Right);
      'F' : Rotate(-1,+1,-1,-1,-1,+1,Forward);
      'B' : Rotate(-1,+1,+1,+1,-1,+1,Backward);
      'L' : Rotate(-1,-1,-1,+1,-1,+1,Left);
      'D' : Rotate(-1,+1,-1,+1,-1,-1,Down);
    End;
  End;
End;

Procedure Method1;
Var Cnt : LongInt;
Begin
  C:=InitCube; Cnt:=0;
  Repeat
    Inc(Cnt); Make;
  Until Equal(C,InitCube);

  Write('Method 1: ',Cnt);
End;

Function Nod(x,y : Integer) : Integer;
Begin
  While (x<>0) And (y<>0) Do
    If x>y Then x:=x Mod y
           Else y:=y Mod x;

  Nod:=x+y;
End;

Function RightCubic(x,y,z : Integer) : Boolean;
Begin
  RightCubic:= Comp(C[x,y,z])=Comp(InitCube[x,y,z]);
End;

Procedure Method2;
Var i : Integer; Nok : LongInt;
    x,y,z : Integer;
Begin
  Nok:=1;
  For x:=-1 To +1 Do
    For y:=-1 To +1 Do
      For z:=-1 To +1 Do
        If Abs(x)+Abs(y)+Abs(z)>1 Then
        Begin
          C:=InitCube; i:=0;
          Repeat
            Inc(i); Make;
          Until RightCubic(x,y,z);
          Nok:=i Div Nod(Nok Mod i,i) * Nok;
        End;

  Write('Method 2: ',Nok);
End;

Var A : Array [1..27] Of Integer;
    How : Array [1..3,1..27] Of -3..+3;

Function Count(k : Integer) : Integer;
Var j,w,Cnt : Integer;
Begin
  j:=k; w:=1; Cnt:=0;
  Repeat
    Inc(Cnt);
    If w>0 Then w:=How[w,j] Else w:=-How[-w,j];
    j:=A[j];
  Until (j=k) And (w=1);
  Count:=Cnt;
End;

Procedure Method3;
Var i,x,y,z : Integer;
    Nok : LongInt;
Begin
  For i:=1 To 3 Do
  Begin
    C:=InitCube;
    For x:=-1 To +1 Do
      For y:=-1 To +1 Do
        For z:=-1 To +1 Do
          With C[x,y,z] Do
            Case i Of
              1 : Begin dx:=1; dy:=0; dz:=0 End;
              2 : Begin dx:=0; dy:=1; dz:=0 End;
              3 : Begin dx:=0; dy:=0; dz:=1 End;
            End;

    Make;

    For x:=-1 To +1 Do
      For y:=-1 To +1 Do
        For z:=-1 To +1 Do
          With C[x,y,z] Do
          Begin
            A[Num]:=InitCube[x,y,z].Num;
            If dx<>0 Then      How[i,Num]:=dx
            Else If dy<>0 Then How[i,Num]:=dy+dy
            Else {dz<>0}       How[i,Num]:=dz+dz+dz;
          End;
  End;

  Nok:=1;
  For x:=-1 To +1 Do
    For y:=-1 To +1 Do
      For z:=-1 To +1 Do
        If Abs(x)+Abs(y)+Abs(z)>1 Then
        Begin
          i:=Count(InitCube[x,y,z].Num);
          Nok:=i Div Nod(Nok Mod i,i) * Nok;
        End;

  Write('Method 3: ',Nok);
End;

Begin
  Init;

  t:=Time+1; While Time<t Do;
  WriteLn('Correctness: ',Correct);
  WriteLn('Time of reading: ',(Time-t)*55/1000:0:2);

  WriteLn('True Length: ',TrueLength);

  {t:=Time+1; While Time<t Do;
  Method1;
  WriteLn('  Time 1: ',(Time-t)*55/1000:0:2);

  t:=Time+1; While Time<t Do;
  Method2;
  WriteLn('  Time 2: ',(Time-t)*55/1000:0:2);}

  t:=Time+1; While Time<t Do;
  Method3;
  WriteLn('  Time 3: ',(Time-t)*55/1000:0:2);
End.