{ 1995-1996 ACM International Collegiate Programming Contest }
{                  Western European Regional                 }

Program Donkey1; { Dynamic programming }

Const MaxM = 50; MaxN = 4;
      C = MaxM Div MaxN+1;

Type Arr = Array [0..C*C*C] Of Real;

Var A : Array [0..MaxM] Of ^Arr;
    P : Array [1..MaxN] Of Integer;
    M,N,First : Integer;

Procedure Init;
Begin
  Assign(Input,'Input.Txt');
  Reset(Input);
  Assign(Output,'Output.Txt');
  Rewrite(Output);
End;

Procedure ReadData;
Var i : Integer;
Begin
  Read(M,N);
  For i:=1 To N Do Read(P[i]);
  Read(First);
End;

Function NumPos : Integer;
Var i,Cnt : Integer;
Begin
  Cnt:=P[N];
  For i:=N-1 DownTo 2 Do
    Cnt:=Cnt*(M+1)+P[i];

  NumPos:=Cnt;
End;

Function Rec(Who : Integer) : Real;
Var i,j,k,t,Old : Integer;
    S : Real;
Begin
  If Who>N Then Who:=1;
  If Who=1 Then
  Begin
    t:=NumPos; S:=A[P[1]]^[t];
    If S<>-1 Then Begin Rec:=S; Exit End;
  End;

  Old:=P[Who]; S:=0;
  For i:=1 To 6 Do
  Begin
    k:=Old+i-1;
    Repeat
      Inc(k); j:=1;
      While (j<=N) And (P[j]<>k) Do Inc(j);
    Until j>N;

    If k>M Then S:=S+Ord(Who=1)
    Else Begin
      P[Who]:=k;
      S:=S+Rec(Who+1);
      P[Who]:=Old;
    End;
  End;
  If Who=1 Then A[P[1]]^[t]:=S/6;
  Rec:=S/6;
End;

Procedure Calculate(g : Integer);
Var i,j,Size : Integer;
    Pr : Real;
Begin
  Size:=1;
  For i:=1 To N-1 Do Size:=Size*(M+1);

  For i:=P[1] To M Do
  Begin
    GetMem(A[i],Size*SizeOf(Real));
    For j:=0 To Size-1 Do A[i]^[j]:=-1;
  End;

  If N=1 Then Pr:=1 Else Pr:=Rec(First);
  {WriteLn('Game ',g,':the probability that player 1 wins = ',Pr:5:3);}
  WriteLn(Pr:5:3);
End;

Procedure Solve;
Var K,i : Integer;
Begin
  {ReadLn(K);} K:=1;
  For i:=1 To K Do
  Begin
    ReadData;
    Calculate(i);
  End;
End;

Procedure Done;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  Init;
  Solve;
  Done;
End.