{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+}
{$M 16384,0,655360}

program P0604_2;

const
  maxn                  = 1000;
  maxp                  = 5000;

type
  Stat                  = (left,right,up,down);
  AStat                 = set of Stat;

  Vert                  = record
    x,y1,y2             : integer;
  end;

  Hor                   = record
    x1,x2,y             : integer;
  end;

  Point                 = record
    x,y                 : integer;
    s                   : AStat;
    f                   : boolean;
  end;

var
  n,nbp                 : integer;
  xmax,ymax             : integer;
  nh,nv                 : integer;
  h                     : array[1..maxn] of Hor;
  v                     : array[1..maxn] of Vert;
  bp                    : array[1..maxp] of Point;

function min( a,b : integer ) : integer;
begin if a < b then min := a else min := b; end;

function max( a,b : integer ) : integer;
begin if a > b then max := a else max := b; end;

procedure Sort;
var
  i,j                   : integer;
  t1                    : Hor;
  t2                    : Vert;
begin
  for i:=1 to nh-1 do for j:=i+1 to nh do
    if h[i].y > h[j].y then begin
      t1 := h[i];
      h[i] := h[j];
      h[j] := t1;
    end;
  for i:=1 to nv-1 do for j:=i+1 to nv do
    if v[i].x > v[j].x then begin
      t2 := v[i];
      v[i] := v[j];
      v[j] := t2;
    end;

end;

procedure SortBP;
var
  i,j                   : integer;
  t                     : Point;
begin
  for i:=1 to nbp-1 do for j:=i+1 to nbp do
    if bp[i].x > bp[j].x then begin
      t := bp[i];
      bp[i] := bp[j];
      bp[j] := t;
    end;
end;

procedure AddBP( x,y : integer; s:AStat );
var
  i                     : integer;
begin
  for i:=1 to nbp do if (bp[i].x=x) and (bp[i].y=y) then begin
    bp[i].s := bp[i].s + s;
    exit;
  end;
  inc( nbp );
  bp[nbp].x := x;
  bp[nbp].y := y;
  bp[nbp].s := s;
  bp[nbp].f := true;
end;

procedure InitBP;
label a,b,c,d;
var
  i,j                      : integer;
begin
  for i:=1 to nh do begin

    for j:=nv downto 1 do
      if (v[j].x<=h[i].x1)
         and (h[i].y>=v[j].y1) and (h[i].y<=v[j].y2) then begin
        AddBP( v[j].x, h[i].y, [right] );
        goto a;
      end;

    a:
    for j:=1 to nv do
      if (v[j].x>=h[i].x2)
         and (h[i].y>=v[j].y1) and (h[i].y<=v[j].y2) then begin
        AddBP( v[j].x, h[i].y, [left] );
        goto b;
      end;
    b:
  end;
  for i:=1 to nv do begin
    for j:=nh downto 1 do
      if (h[j].y<=v[i].y2)
         and (h[j].x1<=v[i].x) and (h[j].x2>=v[i].x) then begin
        AddBP( v[i].x, h[j].y, [up] );
        goto c;
      end;
    c:

    for j:=1 to nh do
      if (h[j].y>=v[i].y1)
         and (h[j].x1<=v[i].x) and (h[j].x2>=v[i].x) then begin
        AddBP( v[i].x, h[j].y, [down] );
        goto d;
      end;

    d:
  end;
end;

procedure Solve;
var
  i,j,k,l               : integer;
  x,y                   : integer;
begin
  Sort;
  InitBP;
  SortBP;
  for i:=1 to nbp do begin
    for j:=1 to nh do begin
      if (h[j].x2 = bp[i].x) and (h[j].y=bp[i].y) then
        include( bp[i].s, left );
      if (h[j].x1 = bp[i].x) and (h[j].y=bp[i].y) then
        include( bp[i].s, right );
    end;
    for j:=1 to nv do begin
      if (v[j].y2 = bp[i].y) and (v[j].x=bp[i].x) then
        include( bp[i].s, down );
      if (v[j].y1 = bp[i].y) and (v[j].x=bp[i].x) then
        include( bp[i].s, up );
    end;
  end;

  writeln( n + 1 );
  for i:=1 to nbp do begin
    if bp[i].x = xmax then bp[i].s := bp[i].s + [up,down];
    if bp[i].x = 0 then bp[i].s := bp[i].s + [up,down];
    if bp[i].y = 0 then bp[i].s := bp[i].s + [left,right];
    if bp[i].y = ymax then bp[i].s := bp[i].s + [left,right];
  end;
  for i:=1 to nbp do if bp[i].f then begin
    x := maxint;
    for j:=1 to nbp do
      if (i<>j) and (bp[j].y = bp[i].y) and (bp[j].x > bp[i].x) and
         (up in bp[j].s) and (bp[j].x < x) then begin
        x := bp[j].x;
        k := j;
      end;
    if x = maxint then continue;
    y := maxint;
    for j:=1 to nbp do
      if (i<>j) and (j<>k) and (bp[j].x = bp[k].x ) and (bp[j].y>bp[i].y) and
        (left in bp[j].s) and (bp[j].y < y) then begin
        y := bp[j].y;
        l := j;
      end;
    if y = maxint then continue;

    for j:=1 to nbp do
      if (bp[i].y=bp[j].y) and (bp[j].x>=bp[i].x) and
         (bp[j].x < x) then bp[j].f := false;

    writeln( bp[i].x:6, bp[i].y:6, x:6,y:6 );
  end;
end;

procedure ReadData;
var
  i                     : integer;
  x1,y1,x2,y2           : integer;
begin
  readln( xmax, ymax );
  readln( n );
  nh := 2;
  nv := 2;
  h[1].x1 := 0;
  h[1].x2 := xmax;
  h[1].y := 0;
  h[2].x1 := 0;
  h[2].x2 := xmax;
  h[2].y := ymax;
  v[1].y1 := 0;
  v[1].y2 := ymax;
  v[1].x := 0;
  v[2].y1 := 0;
  v[2].y2 := ymax;
  v[2].x := xmax;
  for i:=1 to n do begin
    readln( x1,y1,x2,y2 );
    if x1 = x2 then begin
      inc( nv );
      v[nv].x := x1;
      v[nv].y1 := min( y1,y2 );
      v[nv].y2 := max( y1,y2 );
    end else begin
      inc( nh );
      h[nh].y := y1;
      h[nh].x1 := min( x1,x2 );
      h[nh].x2 := max( x1,x2 );
    end;
  end;
end;

procedure Reassign;
begin
  assign( input, 'divide.in' );
  reset( input );

  assign( output, 'divide.out' );
  rewrite( output );

end;

begin
  Reassign;
  ReadData;
  Solve;
end.