{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+}
{$M 16384,0,655360}

program p0604_5;

const
  maxn                  = 1000;
  eps                   = 1e-7;

type
  float                 = real;
  int                   = longint;

  AState                = (go,idle,stop);
  Train                 = object
    state               : AState;
    shed                : float;
    x                   : float;
    start               : float;
    i                   : integer;
    curv                : float;
    begtime             : float;
    endtime             : float;
    constructor init( st : float );
    procedure process;
  end;

var
  t,v                   : array[1..maxn] of int;
  delta                 : float;
  l,n                   : int;
  time                  : float;

constructor Train.init( st : float );
begin
  start := st;
  state := idle;
  x := 0;
  begtime := 0;
  endtime := 0;
  curv := 0;
  shed := start;
  i := 1;
end;

procedure Train.process;
begin
  if state = idle then begin
    if abs( time - start ) < eps then begin
      i := 1;
      state := go;
      curv := v[1];
      x := 0;
      begtime := time;
      endtime := time + t[1];
      shed := endtime;
    end else begin
      shed := start;
    end;
  end else begin
    x := x + (time-begtime)*curv;
    begtime := time;
    if abs( time - endtime ) < eps then begin
      if i = n then begin
        state := stop;
      end else begin
        inc( i );
        begtime := time;
        endtime := time + t[i];
        curv := v[i];
        shed := endtime;
      end;
    end;
  end;
end;

function min( a,b : float ) : float;
begin if a < b then min := a else min := b; end;

function Check( delta : float ) : boolean;
var
  t1,t2                 : Train;
begin
  t1.init( 0 );
  t2.init( delta );
  time := 0;
  Check := false;
  repeat
    time := min( t1.shed, t2.shed );
    t1.process;
    t2.process;

    if (t1.state = go) and (t2.state = go) then begin
      if t1.x - t2.x < l then exit;
    end;

  until (t1.state = stop ) or ( t2.state = stop );
  Check := true;
end;

procedure Solve;
var
  l,r,m                 : float;
  i                     : integer;
begin
  l := 0;
  r := 0;
  for i:=1 to n do r := r + t[i];
  while abs( l - r ) > eps do begin
    m := (l+r)/2;
    if Check( m ) then
      r := m
    else
      l := m;
  end;
  delta := r;
end;

procedure ReadData;
var
  i                     : integer;
begin
  read( l, n );
  for i:=1 to n do read( t[i], v[i] );
end;

procedure WriteData;
begin
  writeln( delta:6:5 );
end;

procedure Reassign;
begin
  assign( input, 'train.in' );
  reset( input );
  assign( output, 'train.out' );
  rewrite( output );
end;

begin
  Reassign;
  ReadData;
  Solve;
  WriteData;
end.