{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
program macro;

const MaxN  = 5000;

var
  N, QR, QW, ZZ : integer;
  U     : array [1..MaxN] of integer;
  r     : array [1..MaxN, 1..3] of integer;
  Queue : array [1..MaxN] of integer;
  Mark  : array [1..MaxN] of integer;

procedure makeinput;
var i, j, a, k  : integer;
    F           : boolean;
begin
  read (N);
  if (N = 0) then halt;
  if (N < 0) or (N > MaxN) then runerror (239);
  for i := 1 to N do
    begin
      read (r[i,1], r[i,2], r[i,3]);
      if (r[i,1] = r[i,2]) or (r[i,2] = r[i,3]) or (r[i,3] = r[i,1]) then
        runerror (239);
      for j := 1 to 3 do
        if (r[i,j] <= 0) or (r[i,j] > N) or (r[i,j] = i) then runerror (239);
    end;
  for i := 1 to N do
    for j := 1 to 3 do
      begin
        F := true;
        a := r[i,j];
        for k := 1 to 3 do
          if r[a,k] = i then F := false;
        if F then runerror (239)
      end;
  if odd(N) then runerror (239);
end;

procedure forkwith (X : integer);
var
  Y, Z, k        : integer;
begin
  ZZ := 0;
  QW := 1;
  QR := 0;
  fillchar (Mark, N shl 1, 0);
  Queue[1] := X;
  Mark[X] := -X;
  while QR < QW do
    begin
      inc (QR);
      Y := Queue [QR];
      if Mark[Y] < 0 then
        begin
          Mark[Y] := -Mark[Y];
          for k := 1 to 3 do
            begin
              Z := r [Y, k];
              if Mark[Z] = 0 then
                begin
                  Mark[Z] := Y;
                  if U[Z] = 0 then begin ZZ := Z; exit end;
                  Mark[U[Z]] := -Z;
                  inc (QW);
                  Queue [QW] := U[Z]
                end
            end
        end
    end;
  writeln ('NO SOLUTION');
  halt
end;

procedure workwith (X : integer);
var Y, Z  : integer;
begin
  forkwith (X);
  Y := ZZ;
  repeat
    Z := Mark[Y];
    U[Z] := Y;
    U[Y] := Z;
    Y := Mark[Z]
  until Z = X;
end;


procedure work;
var i   : integer;
begin
  for i := 1 to N do
    if U[i] = 0 then
      workwith (i)
end;

var i : integer;
begin
  assign (input, 'rail.in');
  reset (input);
  assign (output, 'rail.out');
  rewrite (output);
  makeinput;
  work;
  for i := 1 to N do if U[i] > i then writeln (i, ' ', U[i]);
end.