{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 16384,0,655360}
program macro;

const
  MaxN = 1000;
var
  L, N          : longint;
  T, V          : array [1..MaxN] of integer;
  X, TT         : array [0..MaxN] of longint;
  MinT, CurT    : extended;

{ returns i: X[i] <= Z < X[i+1] or -1 }
function binsearch (Z : longint) : integer;
var i, j, k  : integer;
begin
  if (Z < 0) or (Z > X[N]) then begin binsearch := -1; exit end;
  i := 0;
  j := N;
  if Z = X[N] then begin binsearch := N-1; exit end;
  while j - i > 1 do  { X[i] <= Z < X[j] }
    begin
      k := (i + j) shr 1;
      if Z < X[k] then j := k else i := k
    end;
  binsearch := i
end;

function XtoT (Z : longint; F : boolean) : extended;
var i : integer;
begin
  i := binsearch (Z);
  if X[i] = Z then
    begin
      if F then while (i > 0) and (X[i-1] = Z) do dec (i);
      if (not F) and (Z = X[N]) then i := N;
      XtoT := TT[i];
      exit
    end;
  XtoT := TT[i] + (Z - X[i]) / V[i+1];
end;

procedure testpoint (Z : longint);
var T1, T2   : extended;
begin
  if (Z < 0) or (Z > X[N] - L) then exit;
  T1 := XtoT (Z, true);
  T2 := XtoT (Z + L, false);
  if T2 - T1 > MinT then MinT := T2 - T1;
{  writeln ('Z=',Z,' T1=',T1:8:8,' T2=', T2:8:8, ' T2-T1=', T2-T1:8:8,
   ' MinT=', MinT:8:8);}
end;

var i : integer;
begin
  assign (input, 'train.in');
  assign (output, 'train.out');
  reset (input);
  rewrite (output);
  read (L, N);
  if (L < 100) or (L > 10000) or (N < 1) or (N > MaxN) then runerror (239);
  for i := 1 to N do read (T[i], V[i]);
  X[0] := 0;
  TT[0] := 0;
  for i := 1 to N do TT[i] := TT[i-1] + longint (T[i]);
  for i := 1 to N do
    X[i] := X[i-1] + longint(T[i]) * longint (V[i]);
  MinT := 0;
  if X[N] <= L then MinT := TT[N] else
    for i := 0 to N do
      begin testpoint (X[i] - L);  testpoint (X[i]) end;
  writeln (MinT:8:8)
end.