{$A+,B-,D-,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,0}
Type
  TLine=Record
    x1,y1,x2,y2,Index:Integer;
    Hor:Boolean;
  End;
  TLineArray=Array[1..1000] Of TLine;
Var
  HaveHor,HaveVer:Boolean;
  zx1,zy1,zx2,zy2:TLineArray;
  xMax,yMax,xMin,yMin,n,i:Integer;
  Used:Array[1..1000] Of Boolean;

Procedure ZSwap(Var z1,z2:TLine);
Var
  zTemp:TLine;
Begin
  zTemp:=z1; z1:=z2; z2:=zTemp;
End;

Procedure ISwap(Var i1,i2:Integer);
Var
  iTemp:Integer;
Begin
  iTemp:=i1; i1:=i2; i2:=iTemp;
End;

procedure X1Sort(l, r: Integer);
var
  i, j, x: integer;
begin
  i := l; j := r; x := zx1[(l+r) DIV 2].x1;
  repeat
    while zx1[i].x1 < x do i := i + 1;
    while x < zx1[j].x1 do j := j - 1;
    if i <= j then
    begin
      ZSwap(zx1[i],zx1[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then X1Sort(l, j);
  if i < r then X1Sort(i, r);
end;

procedure Y1Sort(l, r: Integer);
var
  i, j, y: integer;
begin
  i := l; j := r; y := zy1[(l+r) DIV 2].y1;
  repeat
    while zy1[i].y1 < y do i := i + 1;
    while y < zy1[j].y1 do j := j - 1;
    if i <= j then
    begin
      ZSwap(zy1[i],zy1[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Y1Sort(l, j);
  if i < r then Y1Sort(i, r);
end;

procedure X2Sort(l, r: Integer);
var
  i, j, x: integer;
begin
  i := l; j := r; x := zx2[(l+r) DIV 2].x2;
  repeat
    while zx2[i].x2 < x do i := i + 1;
    while x < zx2[j].x2 do j := j - 1;
    if i <= j then
    begin
      ZSwap(zx2[i],zx2[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then X2Sort(l, j);
  if i < r then X2Sort(i, r);
end;

procedure Y2Sort(l, r: Integer);
var
  i, j, y: integer;
begin
  i := l; j := r; y := zy2[(l+r) DIV 2].y2;
  repeat
    while zy2[i].y2 < y do i := i + 1;
    while y < zy2[j].y2 do j := j - 1;
    if i <= j then
    begin
      ZSwap(zy2[i],zy2[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Y2Sort(l, j);
  if i < r then Y2Sort(i, r);
end;

Procedure ReadData;
Var
  i:Integer;
Begin
  FillChar(Used,SizeOf(Used),True);
  Assign(Input,'divide.in');
  Reset(Input);
  ReadLn(xMax,yMax);
  ReadLn(n);
  HaveHor:=False; HaveVer:=False;
  For i:=1 To n Do
    With zx1[i] Do
    Begin
      ReadLn(x1,y1,x2,y2);
      Hor:=(y1=y2);
      If Hor Then HaveHor:=True Else HaveVer:=True;
      If y1>y2 Then ISwap(y1,y2);
      If x1>x2 Then ISwap(x1,x2);
      Index:=i;
    End;
            X1Sort(1,n);
  zy1:=zx1; Y1Sort(1,n);
  zx2:=zx1; X2Sort(1,n);
  zy2:=zx2; Y2Sort(1,n);
  Close(Input);
  Assign(Output,'divide.out');
  Rewrite(Output);
End;

Procedure Solve;
Label
  Try1,Try2,Try3,Try4;
Var
  i:Integer;
  CanExit:Byte;
Begin
  xMin:=0; yMin:=0; CanExit:=4;
  WriteLn(n+1);
Try1:
  If CanExit=0 Then Exit;
  For i:=1 To n Do
    If Used[zy1[i].Index] Then
      If zy1[i].Hor Then
      Begin
        Used[zy1[i].Index]:=False;
        WriteLn(xMin,' ',yMin,' ',xMax,' ',zy1[i].y1);
        yMin:=zy1[i].y1; If yMin=yMax Then Exit;
        CanExit:=4;
      End
    Else Begin Dec(CanExit); GoTo Try2; End;
Try2:
  If CanExit=0 Then Exit;
  For i:=1 To n Do
    If Used[zx1[i].Index] Then
      If Not zx1[i].Hor Then
      Begin
        Used[zx1[i].Index]:=False;
        WriteLn(xMin,' ',yMin,' ',zx1[i].x1,' ',yMax);
        xMin:=zx1[i].x1; If xMin=xMax Then Exit;
        CanExit:=4;
      End
    Else Begin Dec(CanExit); GoTo Try3; End;
Try3:
  If CanExit=0 Then Exit;
  For i:=n DownTo 1 Do
    If Used[zy2[i].Index] Then
      If zy2[i].Hor Then
      Begin
        Used[zy2[i].Index]:=False;
        WriteLn(xMin,' ',zy2[i].y1,' ',xMax,' ',yMax);
        yMax:=zy2[i].y1; If yMin=yMax Then Exit;
        CanExit:=4;
      End
    Else Begin Dec(CanExit); GoTo Try4; End;
Try4:
  If CanExit=0 Then Exit;
  For i:=n DownTo 1 Do
    If Used[zx2[i].Index] Then
      If Not zx2[i].Hor Then
      Begin
        Used[zx2[i].Index]:=False;
        WriteLn(zx2[i].x1,' ',yMin,' ',xMax,' ',yMax);
        xMax:=zx2[i].x1; If xMin=xMax Then Exit;
        CanExit:=4;
      End
    Else Begin Dec(CanExit); GoTo Try1; End;
End;

Begin
  ReadData;
  If n=0 Then
  Begin
    WriteLn(1);
    WriteLn(0,' ',0,' ',xMax,' ',yMax);
  End
  Else
    If Not HaveVer Then
    Begin
      WriteLn(n+1);
      WriteLn(0,' ',0,' ',xMax,' ',zy1[1].y1);
      For i:=1 To n-1 Do
        WriteLn(0,' ',zy1[i].y1,' ',xMax,' ',zy1[i+1].y1);
      WriteLn(0,' ',zy1[n].y1,' ',xMax,' ',yMax);
    End
    Else
      If Not HaveHor Then
      Begin
        WriteLn(n+1);
        WriteLn(0,' ',0,' ',zx1[1].x1,' ',yMax);
        For i:=1 To n-1 Do
          WriteLn(zx1[i].x1,' ',0,' ',zx1[i+1].x1,' ',yMax);
        WriteLn(zx1[n].x1,' ',0,' ',xMax,' ',yMax);
      End
      Else
      Begin
        Solve;
        WriteLn(xMin,' ',yMin,' ',xMax,' ',yMax);
      End;
  Close(Output);
End.
