program P0707_2;

type TLine = record
  x1, y1, x2, y2: integer;
  v: boolean;
end;
TRect = record
  x1, y1, x2, y2: integer;
end;
TPoint = record
  x, y: integer
end;

var CX, CY: Integer;
    Num: Integer;
    Marks, Lines: array [1..1000] of TLine;
    HLines, VLines: array [1..1000] of TLine;
    HMarks, VMarks: array [1..1000] of TLine;
    vlnum, hlnum: integer;

function isv(l: TLine): boolean;
begin
  isv := l.x1 = l.x2;
end;

function ish(l: TLine): boolean;
begin
  ish := l.y1 = l.y2;
end;

procedure norm(var l: TLine);
var t: integer;
begin
  if l.x1 > l.x2 then begin
    t := l.x1;
    l.x1 := l.x2;
    l.x2 := t;
  end;
  if l.y1 > l.y2 then begin
    t := l.y1;
    l.y1 := l.y2;
    l.y2 := t;
  end;
  l.v := isv(l);
end;

procedure contline(l: TLine; var ll: TLine);
begin
  norm(l);
  ll := l;
  if l.v then begin
    ll.y1 := 0;
    ll.y2 := cy;
  end
  else begin
    ll.x1 := 0;
    ll.x2 := cy;
  end;
end;

function cross(l1, l2: TLine; var p: TPoint): boolean;
var h, v: TLine;
    res: boolean;
begin
  norm(l1);
  norm(l2);
  res := true;
  if l1.v = l2.v then res := false
  else if l2.v then begin h := l1; v := l2 end
  else begin v := l1; h := l2 end;
  if res then begin
    p.x := v.x1; p.y := h.y1;
    if (p.x <= h.x1) or (p.x >= h.x2) or (p.y <= v.y1) or (p.y >= v.y2) then
      res := false;
  end;
  cross := res;
end;

function pinl(p: TPoint; l: TLine): boolean;
begin
  norm(l);
  if l.v then pinl := (p.y > l.y1) and (p.y < l.y2)
  else pinl := (p.x > l.x1) and (p.x < l.x2)
end;

procedure rnorm(r: TRect);
var t: integer;
begin
  if r.x1 > r.x2 then begin
    t := r.x1;
    r.x1 := r.x2;
    r.x2 := t;
  end;
  if r.y1 > r.y2 then begin
    t := r.y1;
    r.y1 := r.y2;
    r.y2 := t;
  end;
end;

procedure recdiv(zone: TRect; spl: integer);
var zx1, zx2, zy1, zy2, i, k: integer;
    found, brk: boolean;
    r1, r2: TRect;
    cp: TPoint;
begin
  rnorm(zone);
  found := false;
  for i := 1 to num do begin
    if (Marks[i].x1 < zone.x1) or (Marks[i].x2 > zone.x2) or
    (Marks[i].y1 < zone.y1) or (Marks[i].y2 > zone.y2) then continue;
    if (Marks[i].v) and ((Marks[i].x1 = zone.x1) or (Marks[i].x2 = zone.x2)) then continue;
    if (not Marks[i].v) and ((Marks[i].y1 = zone.y1) or (Marks[i].y2 = zone.y2)) then continue;
    found := true;
    brk := false;
    if Lines[i].v then begin
      for k := 1 to hlNum do begin
        if (HMarks[k].x1 < zone.x1) or (HMarks[k].x2 > zone.x2) or
        (HMarks[k].y1 < zone.y1) or (HMarks[k].y2 > zone.y2) then continue;
        if cross(Lines[i], HMarks[k], cp) then begin
          break;
        end;
        r1 := zone; r1.x2 := Lines[i].x1;
        r2 := zone; r2.x1 := Lines[i].x1;
        recdiv(r1, i);
        recdiv(r2, i);
        brk := True;
        break;
      end;
    end
    else begin
      for k := 1 to vlNum do begin
        if (VMarks[k].x1 < zone.x1) or (VMarks[k].x2 > zone.x2) or
        (VMarks[k].y1 < zone.y1) or (VMarks[k].y2 > zone.y2) then continue;
        if cross(Lines[i], VMarks[k], cp) then begin
          break;
        end;
        r1 := zone; r1.y2 := Lines[i].y1;
        r2 := zone; r2.y1 := Lines[i].y1;
        recdiv(r1, i);
        recdiv(r2, i);
        brk := True;
        break;
      end;
    end;
    if brk then break;
  end;
  if not found then begin
    zx1 := zone.x1; zx2 := zone.x2; zy1 := zone.y1; zy2 := zone.y2;
    if zx1 < 0 then zx1 := 0; if zx2 < 0 then zx2 := 0;
    if zy1 < 0 then zy1 := 0; if zy2 < 0 then zy2 := 0;
    if zx1 > cx then zx1 := cx; if zx2 > cx then zx2 := cx;
    if zy1 > cy then zy1 := cy; if zy2 > cy then zy2 := cy;
    Writeln(zx1, ' ', zy1, ' ', zx2, ' ', zy2);
  end;
end;

var j, i, k, vlx, hly, pvlx, phly, zx1, zx2, zy1, zy2: integer;
    cp: TPoint;
    z: TRect;

begin
  Assign(Input, 'divide.in'); Reset(Input);
  Assign(Output, 'divide.out'); Rewrite(Output);
  Read(cx, cy, num);
  for i := 1 to num do begin
    Read(Marks[i].x1, Marks[i].y1, Marks[i].x2, Marks[i].y2);
    norm(Marks[i]);
  end;

  vlnum := 0; hlnum := 0;
  for i := 1 to num do begin
    contline(Marks[i], Lines[i]);
    if isv(Marks[i]) then begin
      Marks[i].v := True;
      inc(vlNum); VMarks[vlNum] := Marks[i];
    end
    else begin
      Marks[i].v := False;
      inc(hlNum); HMarks[hlNum] := Marks[i];
    end;
  end;

  for i := 1 to hlNum do
    contline(hMarks[i], hLines[i]);
  for i := 1 to vlNum do
    contline(vMarks[i], vLines[i]);

  {for i := 1 to hlnum+1 do begin
    for j := 1 to vlnum+1 do begin
      if cross(hLines[i], vLines[j], cp) then begin
        if i = hlnum+1 then hly := cy else hly := hLines[i].y1;
        if j = vlnum+1 then vlx := cx else vlx := vLines[j].x1;
        if i = 1 then phly := 0 else phly := hLines[i-1].y1;
        if j = 1 then pvlx := 0 else pvlx := vLines[j-1].x1;
      end
    end
  end;}

  z.x1 := 0; z.y1 := 0; z.x2 := cx; z.y2 := cy;
  recdiv(z, -1);
end.