{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}
program Divide2;

type
  TSec=record
    X1,Y1,X2,Y2:Integer;
  end;

var
  D:array [1..1000] of TSec;
  N:Integer;

  Sol:array [1..2000] of TSec;
  Mn:array [1..1000] of Integer;
  Hor:array [1..1000] of Boolean;
  M:Integer;

  XR,YR:Integer;

  XLM,XRM,YUM,YDM:Integer;

procedure LoadData;
var
  I:Integer;
begin
  AsSign(Input,'DIVIDE.IN');
  ReSet(Input);

  ReadLn(XR,YR);
  ReadLn(N);
  for I:=1 to N do
    Read(D[I].X1,D[I].Y1,D[I].X2,D[I].Y2);

  Close(Input);
end;

function Min(A,B:LongInt):LongInt;
begin
  if A>B then Min:=B
         else Min:=A
end;

function Max(A,B:Integer):Integer;
begin
  if A>B then Max:=A
         else Max:=B
end;

procedure Better(var A,B:Integer);
var
  T:Integer;
begin
  if A>B then
    begin
      T:=A;
      A:=B;
      B:=T;
    end
end;

procedure MakeMins;
var
  I:Integer;
begin
  for I:=1 to N do
    if Hor[I] then
      Mn[I]:=Min(YR-D[I].Y2,D[I].Y1)
    else
      Mn[I]:=Min(XR-D[I].X2,D[I].X1)
end;

procedure Sort(L,R:Integer);
var
  I,J,X,Y:Integer;
  T:TSec;
begin
  i := l; j := r; x := Mn[(l+r) DIV 2];
  repeat
    while Mn[i] < x do i := i + 1;
    while x < Mn[j] do j := j - 1;
    if i <= j then
    begin
      Y:=Mn[I];
      Mn[I]:=Mn[J];
      Mn[J]:=Y;
      T:=D[I];
      D[I]:=D[J];
      D[J]:=T;
      Inc(I);
      Dec(J);
    end;
  until I>J;
  if L<J then Sort(L,J);
  if I<R then Sort(I,R);
end;

procedure MakeHors;
var
  I:Integer;
begin
  for I:=1 to N do
    begin
      Hor[I]:=(D[I].Y1=D[I].Y2);
      Better(D[I].X1,D[I].X2);
      Better(D[I].Y1,D[I].Y2);
    end;
end;

function Belong(A,B,C:Integer):Boolean;
begin
  Belong:=((A-B)*(A-C)<0);
end;

function FirstCrLeft(Z:Integer):Integer;
var
  ML:Integer;
  I:Integer;
begin
  ML:=MaxInt;
  for I:=1 to N do
    if not Hor[I] then
      if Belong(D[Z].Y1,D[I].Y1,D[I].Y2) then
        if D[Z].X1>=D[I].X1 then
          if D[Z].X1-D[I].X1<ML then
            ML:=D[Z].X1-D[I].X1;
  if ML=MaxInt then FirstCrLeft:=0
               else FirstCrLeft:=D[Z].X1-ML;
end;

function FirstCrRight(Z:Integer):Integer;
var
  I:Integer;
  ML:Integer;
begin
  ML:=MaxInt;
  for I:=1 to N do
    if not Hor[I] then
      if Belong(D[Z].Y1,D[I].Y1,D[I].Y2) then
        if D[Z].X2<=D[I].X1 then
          if D[I].X1-D[Z].X2<ML then
            ML:=D[I].X1-D[Z].X2;
  if ML=MaxInt then FirstCrRight:=XR
               else FirstCrRight:=D[Z].X2+ML;
end;

function FirstCrUp(Z:Integer):Integer;
var
  I:Integer;
  ML:Integer;
begin
  ML:=MaxInt;
  for I:=1 to N do
    if Hor[I] then
      if Belong(D[Z].X1,D[I].X1,D[I].X2) then
        if D[Z].Y2<=D[I].Y1 then
          if D[I].Y1-D[Z].Y2<ML then
            ML:=D[I].Y1-D[Z].Y2;
  if ML=MaxInt then FirstCrUp:=YR
               else FirstCrUp:=D[Z].Y2+ML;
end;

function FirstCrDown(Z:Integer):Integer;
var
  I:Integer;
  ML:Integer;
begin
  ML:=MaxInt;
  for I:=1 to N do
    if Hor[I] then
      if Belong(D[Z].X1,D[I].X1,D[I].X2) then
        if D[Z].Y1>=D[I].Y1 then
          if D[Z].Y1-D[I].Y1<ML then
            ML:=D[Z].Y1-D[I].Y1;
  if ML=MaxInt then FirstCrDown:=0
               else FirstCrDown:=D[Z].Y1-ML;
end;

procedure Run;
var
  I:Integer;
  X1,Y1,X2,Y2:Integer;
begin
  XRM:=XR;
  XLM:=0;
  YUM:=YR;
  YDM:=0;
  for I:=1 to N do
    if Hor[I] then
      begin
        X1:=FirstCrLeft(I);
        X2:=FirstCrRight(I);
        if (YR-D[I].Y1)<D[I].Y1 then
          begin
            Y1:=D[I].Y1;
            Y2:=YUM;
            YUM:=Y1;
          end
        else
          begin
            Y1:=YDM;
            Y2:=D[I].Y1;
            YDM:=Y2;
          end;
        Sol[I].X1:=X1;
        Sol[I].X2:=X2;
        Sol[I].Y1:=Y1;
        Sol[I].Y2:=Y2;
        D[I].X1:=Sol[I].X1;
        D[I].X2:=Sol[I].X2;
      end
    else
      begin
        Y1:=FirstCrDown(I);
        Y2:=FirstCrUp(I);
        if (XR-D[I].X1)<D[I].X1 then
          begin
            X1:=D[I].X1;
            X2:=XRM;
            XRM:=X1;
          end
        else
          begin
            X1:=XLM;
            X2:=D[I].X1;
            XLM:=X2;
          end;
        Sol[I].X1:=X1;
        Sol[I].X2:=X2;
        Sol[I].Y1:=Y1;
        Sol[I].Y2:=Y2;
        D[I].Y1:=Sol[I].Y1;
        D[I].Y2:=Sol[I].Y2;
      end;
  Sol[I+1].X1:=XLM;
  Sol[I+1].X2:=XRM;
  Sol[I+1].Y1:=YDM;
  Sol[I+1].Y2:=YUM;
end;

procedure WriteAnswer;
var
  I:Integer;
begin
  AsSign(Output,'DIVIDE.OUT');
  ReWrite(Output);
  WriteLn(N+1);
  for I:=1 to N+1 do
    with Sol[I] do
      WriteLn(X1,' ',Y1,' ',X2,' ',Y2);
  Close(Output);
end;

begin
  LoadData;
  MakeHors;
  MakeMins;
  Sort(1,N);
  MakeHors;
  Run;
  WriteAnswer;
end.