program Train2;

var
  T:array [1..1001] of Real;
  V:array [1..1001] of Real;
  L,N:Integer;

  Dist:array [0..1001] of Real;
  Time:array [0..1001] of Real;

  SumT:Real;

  BestI:Real;

procedure LoadData;
var
  I:Integer;
begin
  AsSign(Input,'TRAIN.IN');
  ReSet(Input);
  ReadLn(L);
  ReadLn(N);
  for I:=1 to N do
    ReadLn(T[I],V[I]);
end;

procedure CalcSumT;
var
  I:Integer;
begin
  SumT:=0;
  for I:=1 to N do
    SumT:=SumT+T[I];
end;

procedure InitDistAndTime;
var
  I:Integer;
  D,Tm:Real;
begin
  D:=0;
  Tm:=0;
  Dist[0]:=0;
  Time[0]:=0;
  for I:=1 to N do
    begin
      D:=D+T[I]*V[I];
      Tm:=Tm+T[I];
      Dist[I]:=D;
      Time[I]:=Tm;
    end;
end;

{ Returns position of the 1 train after X minutes }

function Pos1(X:Real):Real;
var
  D,T1:Real;
  I:Integer;
begin
  I:=1;
  while (I<=N) and (Time[I]<=X) do Inc(I);

  D:=Dist[I-1];
  D:=D+(X-Time[I-1])*V[I];

  Pos1:=D;
end;

{ Returns position of the 2 train after X minutes, when started after Y }

function Pos2(X:Real;Y:Real):Real;
var
  D,T2:Real;
  I:Integer;
begin
  I:=1;
  while (I<=N) and (Time[I]<=X-Y) do Inc(I);

  D:=Dist[I-1];
  D:=D+(X-Y-Time[I-1])*V[I];

  Pos2:=D;
end;

function GetMinInt(Cur:Real):Real;
var
  I,J:Integer;
  D1,D2:Real;
  T1,T2:Real;
  CurT,LastT:Real;

  TSav:Real;

  Min:Real;
begin
  CurT:=0;

  J:=1;

  I:=1;
  T1:=0;
  while T1<=Cur do
    begin
      T1:=T1+T[I];
      Inc(I);
    end;

  Dec(I);
  T1:=T1-T[I];

  Min:=Pos1(Cur);

  D1:=Min;
  D2:=0;

  T2:=Cur;

  LastT:=Cur;

  while T1<SumT do
    begin
      if T1+T[I]<T2+T[J] then
        begin
          CurT:=T1+T[I];
          D1:=D1+(CurT-LastT)*V[I];
          D2:=D2+(CurT-LastT)*V[J];
          T1:=CurT;
          Inc(I);
        end
      else
        begin
          CurT:=T2+T[J];
          D1:=D1+(CurT-LastT)*V[I];
          D2:=D2+(CurT-LastT)*V[J];
          T2:=CurT;
          Inc(J);
        end;

      LastT:=CurT;
      if D1-D2<Min then Min:=D1-D2;
    end;

  GetMinInt:=Min;
end;

function Dihotomia:Real;
var
  LS,RS,M:Real;
  D:Real;
  K:Real;
begin
  LS:=0;
  RS:=SumT;
  K:=0;

  while Abs(K-L)>5.0E-4 do
    begin
      M:=(RS+LS)/2;
      K:=GetMinInt(M);
      if K>L then RS:=M
             else LS:=M;
    end;

  Dihotomia:=M;
end;

procedure Solve;
begin
  if Pos1(SumT)<L then BestI:=SumT
                  else BestI:=Dihotomia;
end;

procedure WriteAnswer;
begin
  AsSign(Output,'TRAIN.OUT');
  ReWrite(Output);
  WriteLn(BestI:0:4);
  Close(Output);
end;

begin
  LoadData;
  CalcSumT;
  InitDistAndTime;
  Solve;
  WriteAnswer;
end.
