// ஢   Large.
#include <stdio.h>

#define INPUT "rail.in"
#define OUTPUT "rail.out"

#define MAXWAYS 7500

FILE *in, *out;

struct railway
{
        int from, to;
        int belongs;

        railway (int orig, int dest, int who = 0);
};

int N, ways;
int alldone = 0;
int **wayidx;
railway *way[MAXWAYS];


railway :: railway (int orig, int dest, int who)
{
        from = orig;
        to = dest;
        belongs = who;
}

int check_city (int num)
{
        int
           i,
           owners[3];

        owners[0] = owners[1] = owners[2] = 0;

        for (i = 0; i < 3; i ++)
        {
                if (wayidx[num][i] >= 0)
                   owners[way[wayidx[num][i]]->belongs] ++;
        }

        if (owners[0])
           return 1;
        else
            return owners[1] * owners[2] ? 1 : 0;
}

int way_ok (int num)
{
        if (check_city (way[num]->from) && check_city (way[num]->to))
           return 1;
        else
            return 0;
}

void try_way (int num)
{
        int
           i;

        if (alldone)
           return;

        if (num >= ways)
        {
                // check all
                for (i = 1; i <= N; i ++)
                    if (!check_city (i))
                       return;

                alldone = 1;
                // in god we trust :-) // 30 30 30 30 30
                return;
        }

        way[num]->belongs = 1;
        if (way_ok (num))
        {
           try_way (num + 1);
           if (alldone)
              return;
        }

        way[num]->belongs = 2;
        if (way_ok (num))
        {
           try_way (num + 1);
        }

        return;
}

void process (void)
{
        int i;

        if (ways)
           try_way (0);

        if (alldone)
        {
                for (i = 0; i < ways; i ++)
                    if (way[i]->belongs == 1)
                       fprintf (out, "%d %d\n", way[i]->from, way[i]->to);
        }
        else
            fprintf (out, "NO SOLUTION\n");
}

void mark_way (int waynum, int citynum)
{
        for (int i = 0; i < 3; i ++)
            if (wayidx[citynum][i] == -1)
            {
                wayidx[citynum][i] = waynum;
                return;
            }
}

/*
void set_owner (int citynum, int waynum, int owner)
{
        for (int i = 0; i < 3; i ++)
            if (wayidx[citynum][i] == waynum)
               way[
}
*/


int way_from_to (int from, int to)
{
        int i;

        for (i = 0; i < 3; i ++)
            if (wayidx[from][i] >= 0)
               if (way[wayidx[from][i]]->from == from)
                  if (way[wayidx[from][i]]->to == to)
                     return 1;

        return 0;
}

int way_exists (int city1, int city2)
{
        return way_from_to (city1, city2) || way_from_to (city2, city1);;
}

int no_way (int city1, int city2)
{
        return !way_exists (city1, city2);
}

int main (void)
{
        int i, n;
        int from, to0, to1, to2;

        // 뢠 䠩.
        if ((in = fopen (INPUT, "rt")) == NULL)
        {
                printf ("Can't open "INPUT"\n");
                return 1;
        }

        if ((out = fopen (OUTPUT, "wt")) == NULL)
        {
                fclose (in);
                printf ("Can't create "OUTPUT"\n");
                return 2;
        }


        // Read data.
        fscanf (in, "%d", &N);
        wayidx = new int*[N + 1];
        for (i = 1; i <= N; i ++)
        {
            wayidx[i] = new int[3];
            wayidx[i][0] = wayidx[i][1] = wayidx[i][2] = -1;
        }

        // Read links info.
        for (ways = 0, i = 1; i <= N; i ++)
        {
                fscanf (in, "%d %d %d", &to0, &to1, &to2);
                if (no_way (i, to0))
                {
                        mark_way (ways, to0);
                        mark_way (ways, i);
                        way[ways ++] = new railway (i, to0);
                }

                if (no_way (i, to1))
                {
                        mark_way (ways, to1);
                        mark_way (ways, i);
                        way[ways ++] = new railway (i, to1);
                }

                if (no_way (i, to2))
                {
                        mark_way (ways, to2);
                        mark_way (ways, i);
                        way[ways ++] = new railway (i, to2);
                }
        }

        process ();

        // shutdown
        for (i = 1; i <= N; i ++)
            delete wayidx[i];
        delete wayidx;

        fclose (in);
        fclose (out);

        return 0;
}