#include <stdio.h>
#include <assert.h>

#if defined(TEST)
#define INPUT    "con"
#else
#define INPUT     "filya.in"
#endif
#define OUTPUT    "filya.out"

FILE *in, *out;

#define K 0.65  // 樥 ।. :-)
#define X 45
#define Y 41

int field[X][Y];
int save[X][Y];

int mycol;
int hiscol;

int count[7];
int mine[7], enemy[7];

int readdata (void)
{
        int x, y;
        char tmp[80];

        for (y = 0; y < Y; y ++)
        {
                fscanf (in, "%s", tmp);
                for (x = 0; x < X; x ++)
                    save[x][y] = field[x][y] = tmp[x] - '0';
        }

        mycol = field[0][0];
        hiscol = field[X - 1][Y - 1];
        return 1;
}

void copy_count (int *where)
{
        for (int i = 0; i < 7; i ++)
            where[i] = count[i];
}

int change_block (int x, int y, int which, int to)
{
        int changed = 0;
        if (field[x][y] == which)
           { field[x][y] = to; changed ++; }

        return changed;
}

int change (int x, int y, int which, int to)
{
        int changed = 0;

        if (y > 0)
           changed += change_block (x, y - 1, which, to);

        if (x > 0)
           changed += change_block (x - 1, y, which, to);

        if (y < (Y - 1))
           changed += change_block (x, y + 1, which, to);

        if (x < (X - 1))
           changed += change_block (x + 1, y, which, to);

        return changed ? 1 : 0;
}

int neighbours (int x, int y, int what)
{
        if (x > 0)
           if (field[x - 1][y] == what)
              return 1;

        if (y > 0)
           if (field[x][y - 1] == what)
              return 1;

        if (x < (X - 1))
           if (field[x + 1][y] == what)
              return 1;

        if (y < (Y - 1))
           if (field[x][y + 1] == what)
              return 1;

        return 0;
}

void count_neighbours (void)
{
        int i, x, y;

        for (i = 0; i <= 6; i ++)
            count[i] = 0;

        for (x = 0; x < X; x ++)
            for (y = 0; y < Y; y ++)
            {
                if (field[x][y] > 0)
                   if (neighbours (x, y, 0))
                   {
                        count[field[x][y]] ++;
                        field[x][y] = -field[x][y];
                   }
            }
}

void restore_field (void)
{
        int x, y;

        for (x = 0; x < X; x ++)
            for (y = 0; y < Y; y ++)
                field[x][y] = save[x][y];
}


void markup (int sx, int sy, int origcol)
{
        int
           x,
           y,
           changed = 0;

        field[sx][sy] = 0;

        do
        {
                changed = 0;
                for (x = 0; x < X; x ++)
                    for (y = 0; y < Y; y ++)
                        if (!field[x][y])
                           changed = change (x, y, origcol, 0) ? 1 : changed;
        } while (changed);
}

void process (void)
{
        int
           i,
           max;

        markup (0, 0, mycol);

        // make turn
        count_neighbours ();

        restore_field ();
        copy_count (mine);

        markup (X - 1, Y - 1, hiscol);
        count_neighbours ();
        copy_count (enemy);

        for (i = 0; i <= 6; i ++)
            count[i] = enemy[i] * K + mine[i];

        count[hiscol] = 0;
        count[mycol] = 0;
        count[0] = 0;

        for (max = 0, i = 1; i <= 6; i ++)
               if (count[i] > count[max])
                  max = i;

        assert (max > 0 && max < 7);

        fprintf (out, "%d\n", max);
}

int main (void)
{

        if ((in = fopen (INPUT, "rt")) == NULL)
        {
                printf ("Can't read "INPUT"\n");
                return 1;
        }

        if ((out = fopen (OUTPUT, "wt")) == NULL)
        {
                printf ("Can't create "OUTPUT"\n");
                fclose (in);
                return 2;
        }

        if (readdata ())
        process ();

        fclose (in);
        fclose (out);
        return 0;
}