#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ROWS	41
#define COLS	45

int currColor;

char field[ROWS][COLS];
char table[ROWS][COLS];
char table2[ROWS][COLS];
char secondfield[ROWS][COLS];

int getcolor(int x,int y) {return table[y][x];};
int _match;

int istable2(int x,int y)
{
	if((x<0)||(x>=COLS)||(y<0)||(y>=ROWS))
		return 1;
	if(field[y][x]==field[0][0])
		return 1;
	return 0;
}

int setcolor(int y,int x)
{
	if((x<0)||(x>=COLS)||(y<0)||(y>=ROWS))
		return 0;
	if(table2[y][x])
		return 0;
	if(getcolor(x,y)!=currColor)
		return 0;
	if(istable2(x-1,y)&&istable2(x+1,y)&&istable2(x,y-1)&&istable2(x,y+1))
		_match--;
	table2[y][x]=1;
	return 1;
}

int setcolor2(int y,int x)
{
	if((x<0)||(x>=COLS)||(y<0)||(y>=ROWS))
		return 0;
	if(table2[y][x])
		return 0;
	if(getcolor(x,y)!=currColor)
		return 0;
	table2[y][x]=1;
	return 1;
}

void cleartable2(void)
{
	memset(table2,0,sizeof(table2));
}

int countmatch(int color)
{
	int flag=1;
	_match=1;
	currColor=color;

	if(getcolor(0,0)!=color)
		return 0;
	cleartable2();
	table2[0][0]=1;
	while(flag)
	{
		flag=0;
		for(int i=0;i<ROWS;i++)
		{
			for(int j=0;j<COLS;j++)
			{
				if(table2[i][j])
				{
					if(setcolor(i-1,j))
					{
						_match++;
						flag=1;
					}
					else
					if(setcolor(i+1,j))
					{
						_match++;
						flag=1;
					}
					else
					if(setcolor(i,j-1))
					{
						_match++;
						flag=1;
					}
					else
					if(setcolor(i,j+1))
					{
						_match++;
						flag=1;
					}
				}
			}
		}
	}

	return _match;
}

int countmatch2(int color)
{
	int flag=1;
	_match=1;
	currColor=color;

	if(getcolor(0,0)!=color)
		return 0;
	cleartable2();
	table2[0][0]=1;
	while(flag)
	{
		flag=0;
		for(int i=0;i<ROWS;i++)
		{
			for(int j=0;j<COLS;j++)
			{
				if(table2[i][j])
				{
					if(setcolor2(i-1,j))
					{
						_match++;
						flag=1;
					}
					else
					if(setcolor2(i+1,j))
					{
						_match++;
						flag=1;
					}
					else
					if(setcolor2(i,j-1))
					{
						_match++;
						flag=1;
					}
					else
					if(setcolor2(i,j+1))
					{
						_match++;
						flag=1;
					}
				}
			}
		}
	}

	return _match;
}

int repaintwith(int color,int with)
{
	int flag=1;
	int _match=1;
	currColor=color;

	if(getcolor(0,0)!=color)
		return 0;
	cleartable2();
	table2[0][0]=1;
	table[0][0]=with;
	while(flag)
	{
		flag=0;
		for(int i=0;i<ROWS;i++)
		{
			for(int j=0;j<COLS;j++)
			{
				if(table2[i][j])
				{
					if(setcolor2(i-1,j))
					{
						_match++;
						table[i-1][j]=with;
						flag=1;
					}
					else
					if(setcolor2(i+1,j))
					{
						_match++;
						table[i+1][j]=with;
						flag=1;
					}
					else
					if(setcolor2(i,j-1))
					{
						_match++;
						table[i][j-1]=with;
						flag=1;
					}
					else
					if(setcolor2(i,j+1))
					{
						_match++;
						table[i][j+1]=with;
						flag=1;
					}
				}
			}
		}
	}

	return _match;
}

void copyfield(void)
{
	memcpy(table,field,sizeof(field));
}

void copy2(void)
{
	memcpy(secondfield,table,sizeof(field));
}

void copyback(void)
{
	memcpy(table,secondfield,sizeof(field));
}

char buf[256];

void main(void)
{
	FILE *fp,*fo;
	fp=fopen("filya.in","rt");
	fo=fopen("filya.out","wt");

	randomize();

	for(int i=0;i<ROWS;i++)
	{
		fgets(buf,256,fp);
		for(int j=0;j<COLS;j++)
			field[i][j]=buf[j]-'0';
	}

	copyfield();
	int prev=countmatch(field[0][0]);
	int maxi,max=-32768;
	for(i=1;i<7;i++)
	{
		if((i==field[ROWS-1][COLS-1])||(i==field[0][0]))
			continue;
		copyfield();
		repaintwith(field[0][0],i);
		int zzz=countmatch(i);

		if(zzz>max)
		{
			maxi=i;
			max=zzz;
		}
	}

	if(max==prev)
	{
		max=-32768;
		for(i=1;i<7;i++)
		{
			if((i==field[ROWS-1][COLS-1])||(i==field[0][0]))
				continue;
			copyfield();
			repaintwith(field[0][0],i);
			int zzz=countmatch2(i);

			if(zzz>max)
			{
				maxi=i;
				max=zzz;
			}
		}
	}

	fprintf(fo,"%d",maxi);
	fclose(fp);
	fclose(fo);
}
