#include <stdio.h>
#include <stdlib.h>

long N,L;
long T[1000];	// t[n]=t[n-1]+t[n-2]+...+t[0]
long V[1000];
unsigned long _path[1005];

int lookup(double tau)
{
	int left=0;
	int right=N;
	int center=(left+right)/2;
	while((right-left)!=1)
	{
		if(T[center]<tau)
		{
			left=center;
			center=(left+right)/2;
		}
		else
		{
			right=center;
			center=(left+right)/2;
		}
	}
	return right;
}

double find(double t)
{
	double path=0;
	int i=lookup(t);
	path=_path[i]+(t-T[i-1])*V[i];
	return path;
}

double count(double tau)
{
	int i;
	double min=1e50;

	for(i=0;i<N;i++)
	{
		if(T[i]<tau)
			continue;
		double there=T[i]-tau;
		double high=find(T[i]);
		double low=find(there);
		if(high-low<min)
			min=high-low;
	}

	for(i=0;i<N;i++)
	{
		if(T[i]>T[N-1]-tau)
			break;
		double there=T[i]+tau;
		double low=find(T[i]);
		double high=find(there);
		if(high-low<min)
			min=high-low;
	}
	return min;
}

void main(void)
{
	double left,right,tau;

	FILE *fp,*fo;
	fp=fopen("train.in","rt");
	fo=fopen("train.out","wt");

	fscanf(fp,"%ld",&L);
	fscanf(fp,"%ld",&N);

	for(long i=0;i<N;i++)
	{
		fscanf(fp,"%ld %ld",T+i,V+i);
		if(i)
			T[i]+=T[i-1];
	}

	left=0;
	right=T[N-1];
	tau=(left+right)/2.0;

	unsigned long path=0;
//	_path[0]=0;
	for(i=0;i<N+2;i++)
	{
		if(i)
			path+=(T[i]-T[i-1])*V[i];
		else
			path+=T[i]*V[i];
		_path[i+1]=path;
	}

	double t=count(tau);

	while(right-left>0.0005)
	{
		if(t<L)
		{
			left=tau;
			tau=(left+right)/2;
			t=count(tau);
		}
		else
		{
			right=tau;
			tau=(left+right)/2;
			t=count(tau);
		}
	}

	fprintf(fo,"%.3f\n",tau);
	fclose(fo);
	fclose(fp);
}
