 const
  NlMax = 1000;
 type
  T4Num = array [1..4] of Integer;
 var
  Lines, pr: array [1..nlMax] of T4Num;
  Nl, Np: Integer;
  xb, yb: Integer;

  function Betw(a, b, c: Integer): Boolean;
   begin
    Betw := (c >= a) and (c <= b);
   end;

  function Bettw(a, b, c, d: Integer): Boolean;
   var
    Eq1, Eq2: Boolean;
   begin
    Bettw := true;

    if not (Betw(a, b, c) or Betw(a, b, d))
       then exit;

    if (d = a) or (b = c) then exit;

    Bettw := false;
   end;

  function Intr(a, b: T4Num): boolean;
   var
    Eq1, Eq2: Boolean;
   begin
    Intr := False;

    if Bettw(a[1], a[3], b[1], b[3]) then exit;
    if Bettw(a[2], a[4], b[2], b[4]) then exit;

    if (b[1] = b[3]) and ((b[1] = a[1]) or (b[1] = a[3])) then exit;
    if (b[2] = b[4]) and ((b[2] = a[2]) or (b[2] = a[4])) then exit;

    Intr := true;
   end;

  function Intrs(a, b: T4Num): boolean;
   begin
    Intrs := Intr(a,  b) or Intr(b, a);
   end;

  function CanP(pp: T4Num): Boolean;
   var
    i: Integer;
   begin
    CanP := False;

    for i := 1 to Nl do
     if Intrs(pp, Lines[i]) then exit;

    for i := 1 to Np do
     if Intrs(pp, Pr[i]) then exit;

    CanP := True;
   end;

  procedure ReadAll;
   var
    i, j: Integer;

    procedure Swap(var a, b: Integer);
     var
      x: Integer;
     begin
      x := a;
      a := b;
      b := x;
     end;

   begin
    Assign(Input, 'divide.in');
    Reset(Input);

    ReadLn(xb, yb);
    ReadLn(Nl);

    for i := 1 to Nl do
     begin
      for j := 1 to 4 do
        Read(Lines[i, j]);
      if Lines[i, 1] > Lines[i, 3] then Swap(Lines[i, 1], Lines[i, 3]);
      if Lines[i, 2] > Lines[i, 4] then Swap(Lines[i, 2], Lines[i, 4]);
     end;

    Close(Input);
   end;

  function Min(a, b: Integer): Integer;
   begin
    if a > b then Min := b else Min := a;
   end;

  function Max(a, b: Integer): Integer;
   begin
    if a < b then Max := b else Max := a;
   end;

  procedure Grow(var A: T4Num);
   var
    Ok: Boolean;
    ww: T4Num;
   begin
    repeat
     Ok := True;

     ww := a;
     if ww[1] > 0 then
      begin
       dec(ww[1]);
       if CanP(ww) then
        begin
         a := ww;
         Ok := False;
        end;
      end;

     ww := a;
     if ww[2] > 0 then
      begin
       dec(ww[2]);
       if CanP(ww) then
        begin
         a := ww;
         Ok := False;
        end;
      end;

     ww := a;
     if ww[3] < xb then
      begin
       inc(ww[3]);
       if CanP(ww) then
        begin
         a := ww;
         Ok := False;
        end;
      end;

     ww := a;
     if ww[4] < yb then
      begin
       inc(ww[4]);
       if CanP(ww) then
        begin
         a := ww;
         Ok := False;
        end;
      end;

    until  Ok;
   end;

  procedure Pare(a, b:  Integer);
   var
    cp: T4Num;
   begin
    cp[1] := Min(Lines[a, 1], Lines[b, 1]);
    cp[3] := Max(Lines[a, 3], Lines[b, 3]);
    cp[2] := Min(Lines[a, 2], Lines[b, 2]);
    cp[4] := Max(Lines[a, 4], Lines[b, 4]);

    if not CanP(cp) then exit;

    Grow(cp);
    inc(Np);
    Pr[Np] := cp;
   end;

  procedure Solve;
   var
    i, j, x, y: Integer;
    cc: T4Num;
   begin
    np := 0;
    for i := 1 to Nl do
     for j := 1 to Nl do
      if i <> j then Pare(i, j);

    for x := 0 to xb-1 do
     for y := 0 to yb-1 do
      begin
       cc[1] := x;
       cc[2] := y;
       cc[3] := x + 1;
       cc[4] := y +  1;
       if CanP(cc) then
        begin
         Grow(cc);
         inc(Np);
         Pr[Np] := cc;
        end;
      end;
   end;

  procedure Out;
   var
    i, j: Integer;
   begin
    Assign(Output, 'divide.out');
    ReWrite(Output);

    WriteLn(Np);
    for i := 1 to Np do
     begin
      for j := 1 to 4 do Write(Pr[i, j], ' ');
      WriteLn;
     end;

    Close(Output);
   end;

 begin
  ReadAll;
  Solve;
  Out;
 end.