{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}

const max_n = 1000;
type coord = record x,y : integer end;
     line_cut = record c1,c2 : coord end;
     tData = array[1..max_n] of line_cut;

var  hc, vc, nh, nv : tData;
     hl, vl, n, tot : integer;
     up        : coord;
     hb, vb    : array[1..max_n] of boolean;
     ff        : text;

procedure init_data;
var i : integer;
begin
     tot := 0;
     for i := 1 to max_n do hb[i] := false;
     vb := hb;
     assign(ff,'temp.tmp'); rewrite(ff); writeln(ff);
end;

procedure read_data(s : string);
var f : text; i : integer; c1, c2 : coord;
begin
     hl := 0; vl := 0;
     assign(f,s); reset(f);
     read(f,up.x,up.y);
     read(f,n);
     for i := 1 to n do begin
         readln(f, c1.x, c1.y, c2.x, c2.y);
         if c1.y = c2.y
            then begin inc(hl); hc[hl].c1 := c1; hc[hl].c2 := c2 end
            else begin inc(vl); vc[vl].c1 := c1; vc[vl].c2 := c2 end;
     end;
     close(f);
end;

function min(x,y : integer) : integer;
begin if x < y then min := x else min := y end;

function max(x,y : integer) : integer;
begin if x > y then max := x else max := y end;

procedure horizontal;
var i,j,a,b,xa,xb : integer; inter : boolean;
begin
     for i := 1 to hl do begin
         a := 0; b := 0; xa := 0; xb := up.x;
         for j := 1 to vl do begin
             if ((hc[i].c1.y >= vc[j].c1.y) and (hc[i].c1.y <= vc[j].c2.y)) or
                ((hc[i].c1.y <= vc[j].c1.y) and (hc[i].c1.y >= vc[j].c2.y))
                then begin
                     if (xa < vc[j].c1.x) and
                        (vc[j].c1.x <= min(hc[i].c1.x, hc[i].c2.x))
                        then begin xa := vc[j].c1.x; a := j end;
                     if (xb > vc[j].c1.x) and
                        (vc[j].c1.x >= max(hc[i].c1.x, hc[i].c2.x))
                        then begin xb := vc[j].c1.x; b := j end;
                end;
         end;
         nh[i] := hc[i];
         nh[i].c1.x := xa; nh[i].c2.x := xb;
     end;
end;

procedure vertical;
var i,j,a,b,ya,yb : integer;
begin
     for i := 1 to vl do begin
         a := 0; b := 0; ya := 0; yb := up.y;
         for j := 1 to hl do begin
             if ((vc[i].c1.x > nh[j].c1.x) and (vc[i].c1.x < nh[j].c2.x)) or
                ((vc[i].c1.x < nh[j].c1.x) and (vc[i].c1.x > nh[j].c2.x))
                then begin
                     if (ya < nh[j].c1.y) and
                        (nh[j].c1.y <= min(vc[i].c1.y, vc[i].c2.y))
                        then begin ya := nh[j].c1.y; a := j end;
                     if (yb > nh[j].c1.y) and
                        (nh[j].c1.y >= max(vc[i].c1.y, vc[i].c2.y))
                        then begin yb := nh[j].c1.y; b := j end;
                end;
         end;
         nv[i] := vc[i];
         nv[i].c1.y := ya; nv[i].c2.y := yb;
     end;
end;

procedure arrange;
var i : integer; c : coord;
begin
     for i := 1 to hl do begin
         if hc[i].c1.x > hc[i].c2.x
            then begin
                 c := hc[i].c1; hc[i].c1 := hc[i].c2; hc[i].c2 := c;
            end;
     end;
     for i := 1 to vl do begin
         if vc[i].c1.y > vc[i].c2.y
            then begin
                 c := vc[i].c1; vc[i].c1 := vc[i].c2; vc[i].c2 := c;
            end;
     end;
end;

procedure count;
var i,j : integer; c1,c2,c3 : coord; f : boolean;
begin
     inc(hl);
     nh[hl].c1.x := 0;    nh[hl].c1.y := 0;
     nh[hl].c2.x := up.x; nh[hl].c2.y := 0;
     inc(hl);
     nh[hl].c1.x := 0;    nh[hl].c1.y := up.y;
     nh[hl].c2 := up;
     arrange;

     for i := 1 to hl do begin
         c2 := nh[i].c2; c1 := nh[i].c1;
         f := true;
         for j := 1 to vl do
             if (nv[j].c1.x <= c2.x) and (nv[j].c1.x > c1.x) and
                (nv[j].c1.y = c2.y)
                then begin c2 := nv[j].c1; c3 := nv[j].c2; f := false end;
         if f
            then begin
                 c3.y := up.y; c3.x := -1;
                 for j := 1 to hl do begin
                     if (nh[j].c1.y > c2.y) and (nh[j].c1.y <= c3.y)
                        then c3 := nh[j].c1;
                     if (nh[j].c2.y > c2.y) and (nh[j].c2.y <= c3.y)
                        then c3 := nh[j].c2;
                 end;
            end;
         if c3.x <> -1
            then begin
                 inc(tot);
                 writeln(ff, c1.x,' ', c1.y,' ', c3.x,' ', c3.y);
            end;
     end;

     for i := 1 to vl do begin
         c1 := nv[i].c1; c2.x := up.x+1;
         for j := 1 to vl do begin
             if (nv[j].c1.y = c1.y) and (nv[j].c1.x > c1.x) and
                (nv[j].c1.x < c2.x)
                then c2 := nv[j].c1;
             if (nv[j].c2.y = c1.y) and (nv[j].c2.x > c1.x) and
                (nv[j].c2.x < c2.x)
                then c2 := nv[j].c2;
         end;
         for j := 1 to hl do begin
             if (nh[j].c2.y = c1.y) and (nh[j].c2.x > c1.x) and
                (nh[j].c2.x < c2.x)
                then c2 := nh[j].c2;
             if (nh[j].c1.y = c1.y) and (nh[j].c1.x > c1.x) and
                (nh[j].c1.x < c2.x)
                then c2 := nh[j].c1;
         end;
         if c2.x = up.x+1 then continue;

         c3.y := up.y+1;
         for j := 1 to vl do begin
             if (nv[j].c1.x = c2.x) and (nv[j].c1.y > c2.y) and
                (nv[j].c1.y < c3.y)
                then c3 := nv[j].c1;
             if (nv[j].c2.x = c2.x) and (nv[j].c2.y > c2.y) and
                (nv[j].c2.y < c3.y)
                then c3 := nv[j].c2;
         end;
         for j := 1 to hl do begin
             if (nh[j].c1.x = c2.x) and (nh[j].c1.y > c2.y) and
                (nh[j].c1.y < c3.y)
                then c3 := nh[j].c1;
             if (nh[j].c2.x = c2.x) and (nh[j].c2.y > c2.y) and
                (nh[j].c2.y < c3.y)
                then c3 := nh[j].c2;
         end;
         if c3.y = up.y+1 then continue;

         writeln(ff, c1.x,' ', c1.y,' ', c3.x,' ', c3.y);
         inc(tot);
     end;
end;

procedure write_data(k : string);
var f : text; s : string;
begin
     assign(f,k); rewrite(f);
     reset(ff);
     write(f,tot);
     while not eof(ff) do begin
           readln(ff,s);
           writeln(f,s);
     end;
     close(f);
     close(ff);
end;

begin
     init_data;
     read_data('divide.in');
     horizontal;
     vertical;
     count;
     close(ff);
     write_data('divide.out');
end.
