{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}

const max = 1000;
type  tRoad = array[0..max] of record t,v : integer end;
      tRass = array[0..max] of integer;
var   l,n  : integer;
      r    : tRoad;
      s,tm : tRass;
      dt   : real;

procedure read_data(s : string);
var f : text; i : integer;
begin
     assign(f,s); reset(f);
     read(f,l,n);
     for i := 1 to n do read(f, r[i].t, r[i].v);
     close(f);
     r[0].t := 0;
end;

procedure init_data;
var i : integer;
begin
     s[0] := 0; tm[0] := 0;
     for i := 1 to n do begin
         s[i] := s[i-1] + r[i].t*r[i].v;
         tm[i] := tm[i-1] + r[i].t;
     end;
end;

function proehal(t : real) : real;
var i : integer;
begin
     i := 1;
     while tm[i] < t do inc(i);
     dec(i);

     proehal := s[i] + (t-tm[i]) * r[i+1].v;
end;

procedure process_data;
var i,j : integer;
    t1,t2,t,s1,s2 : real;
    stolk   : boolean;
begin
     for i := 1 to n do begin
         if r[i].v = 0 then continue;

         t1 := (s[i]+l)/r[i].v; t2 := l/r[i].v;
         t := (t1 + t2) / 2;

         if (i = 1) and (s[1] >= l)
            then begin
                 t1 := s[1]/r[1].v;
                 t2 := (s[1]-l)/r[1].v;
                 t := t1 - t2;
            end;

         stolk := false;
         for j := i to n do begin
             if r[i].v >= r[j].v
                then begin
                     s1 := s[j];
                     s2 := proehal(t);
                     if abs(s1-s2) < l
                        then begin
                             stolk := true;
                             break;
                        end;
                end;
         end;
         if stolk = false then break;
     end;
     dt := t;
end;

procedure write_data(s : string);
var f : text;
begin
     assign(f,s); rewrite(f);
     writeln(f, dt:0:3);
     close(f);
end;

begin
     read_data('train.in');
     init_data;
     process_data;
     write_data('train.out');
end.
