#include <stdio.h>

typedef struct vec
{
    int v, c;
    struct vec *next;
} vec;
vec *V[1001];
int N;

#define EPS 1e-10
#define SEPS 1e-7
#define MAXVAL 100000

int negcycle(double R)
{
    double A[1001];
    int i, s;
    vec *v;
    
    for (i = 1; i <= N; i++) A[i] = 0;
    
    for (s = 0; s < N; s++)
     for (i = 1; i <= N; i++)
      for (v = V[i]; v; v = v->next)
       if (A[v->v] > A[i] + v->c - R)
           A[v->v] = A[i] + v->c - R;
           
    for (i = 1; i <= N; i++)
     for (v = V[i]; v; v = v->next)
      if (A[v->v] > A[i] + v->c - R + EPS)
       return 1;
       
    return 0;
}

double solve()
{
    double l, r, m;
    for (l = -MAXVAL, r = MAXVAL; l+SEPS < r; )
        if (negcycle(m = 0.5*(l + r)))
           r = m;
        else
           l = m;
    return 0.5*(l+r);
}

void print(double res)
{
    FILE *fo = fopen("graph.out", "wt");
    fprintf(fo, "%.5lf\n", res);
    fclose(fo);
}

void read_data()
{
    int i, j, c, m;
    vec *v;
    
    FILE *fi = fopen("graph.in", "rt");
    fscanf(fi, "%d %d", &N, &m);
    for (; m; m--)
    {
        fscanf(fi, "%d %d %d", &i, &j, &c);
        v = (vec *) malloc(sizeof(vec));
        v->v = j, v->c = c, v->next = V[i], V[i] = v;
    }

    fclose(fi);
}

int main()
{
    read_data();
    print(solve());
    return 0;
}

