#include <stdio.h>
#include <string.h>

#define MULTSIZE 1024
#define SSIZE 100013

char Wc[SSIZE];
int P;
int Wn[SSIZE];
int N;

int Num[SSIZE];
int Nr;

char S[SSIZE];

typedef struct mult
{
    unsigned char A[MULTSIZE];
} mult;

mult numar();

mult expresie()
{
    mult x = numar(), y;
    char c;
    int i;
    
    while (Wc[P] == '*' || Wc[P] == '+' || Wc[P] == '-' || Wc[P] == '%')
    {
        c = Wc[P++];
        y = numar();
        switch (c)
        {
        case '*': for (i = 0; i < MULTSIZE; i++) x.A[i] &= y.A[i]; break;
        case '+': for (i = 0; i < MULTSIZE; i++) x.A[i] |= y.A[i]; break;
        case '-': for (i = 0; i < MULTSIZE; i++) x.A[i] ^= (x.A[i] & y.A[i]); break;
        case '%': for (i = 0; i < MULTSIZE; i++) x.A[i] ^= y.A[i]; break;
        }
    }
    return x;
}

mult numar()
{
    mult x;
    if (Wc[P] == '(')
    {
        P++, x = expresie(), P++;
        return x;
    }
    if (Wc[P] != '{') printf("Error\n");
    P++;
    memset(&x, 0, sizeof(x));
    
    for (; Wc[P] != '}'; P++)
        x.A[Wn[P] >> 3] |= (1 << (Wn[P]&7));
    P++;
    return x;
}


int search(int x)
{
    int l, r, m;
    for (l = 0, r = Nr-1; l < r; )
    if (Num[m = (l+r)/2] < x)
       l = m+1;
    else
       r = m;
    return l;
}

int cmp(const void *a, const void *b)
{
    return *(int *) a - *(int *) b;
}

mult Res;

void solve()
{
    char x[SSIZE], *p;
    int i, j;
    
    for (i = 0; S[i]; i++)
    {
        Wc[N++] = S[i];
        if (S[i] != '{') continue;
        
        for (j = i+1; S[j] != '}'; j++) x[j-i-1] = S[j];
        
        x[j-i-1] = 0;
        for (p = strtok(x, ","); p; p = strtok(NULL, ","))
            Num[Nr++] = Wn[N] = atoi(p), Wc[N++] = 'x';
        i = j-1;
    }
    
    qsort(Num, Nr, sizeof(int), cmp);
    for (i = j = 1; ; )
    {
        for (; j < Nr && Num[j] == Num[i-1]; j++);
        if (j >= Nr) break;
        Num[i++] = Num[j];
    }
    Nr = Nr ? i : 0;
    for (i = 0; i < N; i++)
    if (Wc[i] == 'x')
       Wn[i] = search(Wn[i]);
       
    Res = expresie();
}

void print()
{
    int i, x = 0;
    FILE *fo = fopen("expr.out", "wt");
    fprintf(fo, "{");
    for (i = 0; i < Nr; i++)
        if ((Res.A[i>>3] & (1 << (i&7))) != 0)
        {
           if (x) fprintf(fo, ",");
           fprintf(fo, "%d", Num[i]), x = 1;
        }
    fprintf(fo, "}\n");
    fclose(fo);
}

void read_data()
{
    FILE *fi = fopen("expr.in", "rt");
    fscanf(fi, "%s", S);
    fclose(fi);
}

int main()
{
    read_data();
    solve();
    print();
    return 0;
}
