#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int A[1001][1001];

int N[2]; /* 0 is the smaller one, 1 is the bigger one */
int P[2][1001];
int G[2][1001], Lev[2][1001];
int F[2][1001][16];

int M[16], Gm[1001];
int trymatch(int a, int b);

int similar(int a, int b)
{
    if (G[0][a] > G[1][b] || P[0][a] > P[1][b] ||
        Lev[0][a] != Lev[1][b] || !trymatch(a, b))
        return 0;
    return 1;
}

void getsol(int a, int b)
{
    int i;
    trymatch(a, b);
    for (i = 0; i < G[0][a]; i++)
        Gm[F[0][a][i]] = F[1][b][M[i]];
    for (i = 0; i < G[0][a]; i++)
        getsol(F[0][a][i], Gm[F[0][a][i]]);
}

void df(int n, int j)
{
    int i;
    for (i = 0; i < G[j][n]; i++)
    {
        Lev[j][F[j][n][i]] = Lev[j][n] + 1;
        df(F[j][n][i], j);
    }
}

void solve()
{
    int d, i, j;
    df(1, 0);
    df(1, 1);

    for (d = N[0]; d >= 0; d--)
     for (i = 1; i <= N[0]; i++)
     if (Lev[0][i] == d)
      for (j = 1; j <= N[1]; j++)
          A[i][j] = similar(i, j);
}

void print()
{
    FILE *fo = fopen("arbori.out", "wt");
    int i;
    getsol(1, 1);
    Gm[1] = 1;
    for (i = 1; i <= N[0]; i++)
        fprintf(fo, "%d ", Gm[i]);
    fprintf(fo, "\n");
    fclose(fo);
}

void read_data()
{
    FILE *fi = fopen("arbori.in", "rt");
    int i, j, k;
    for (j = 1; j >= 0; j--)
        for (fscanf(fi, "%d", N+j), i = 1; i <= N[j]; i++)
        {
            fscanf(fi, "%d %d", P[j]+i, G[j]+i);
            for (k = 0; k < G[j][i]; k++)
                fscanf(fi, "%d", F[j][i]+k);
        }
    fclose(fi);
}

int main()
{
    read_data();
    solve();
    print();
    return 0;
}

/* Bipartite matching */

int E[16][16], Cl[16], Cr[16], Tl[16], Tr[16];
int L, R;
int coada[256], cside[256], cl, cr;

int bf(int n)
{
    int i, j;
    memset(Tl, 0, sizeof(Tl));
    memset(Tr, 0, sizeof(Tr));
    coada[0] = n, cside[0] = 0, Tl[n] = -1;
    for (cl = cr = 0; cl <= cr; cl++)
    {
        i = coada[cl];
        if (cside[cl] == 0)
        {
            for (j = 1; j <= R; j++)
            if (Cl[i] != j && !Tr[j] && E[i][j])
            {
                coada[++cr] = j, cside[cr] = 1, Tr[j] = i;
                if (!Cr[j]) return j;
            }
        } else
        if (!Tl[Cr[i]])
           coada[++cr] = Cr[i], cside[cr] = 0, Tl[Cr[i]] = i;
    }
    return 0;
}

int drum(int n)
{
    for (; n > 0; n = Tl[Tr[n]])
        Cr[n] = Tr[n], Cl[Tr[n]] = n;
    return n != 0;
}
    

int trymatch(int a, int b)
{
    int i, j;
    memset(Cl, 0, sizeof(Cl));
    memset(Cr, 0, sizeof(Cr));
    L = G[0][a], R = G[1][b];
    for (i = 1; i <= L; i++)
     for (j = 1; j <= R; j++)
      E[i][j] = A[F[0][a][i-1]][F[1][b][j-1]];
    for (i = 1; i <= L; i++)
        if (!drum(bf(i))) return 0;
    for (i = 0; i < L; i++)
        M[i] = Cl[i+1]-1;
    return 1;
}
