/*
Solution by Algostorm
Time Complexity: O(2^N * S)
Space Memory: O(N*S)
*/

#include <cstdio>
#include <cstring>

using namespace std;

#define maxN 32
#define maxS 1024

int N, S, sol, A[maxN], T[maxN][maxS], W[maxS];

void read_data()
{
    int i;
    FILE *f = fopen("monezi.in", "rt");
    fscanf(f, "%d %d", &N, &S);
    for (i = 1; i <= N; ++ i)
	fscanf(f, "%d", A + i);
    fclose(f);
}

void back(int lev, int last)
{
    int i;
    if (lev == 1 + N) {
	for (i = 1; i <= S; ++ i)
	    sol += T[last][i];
	return ;
    }
    
    // nu selectam tipul de moneda "lev"
    back(lev + 1, last);
    
    // selectam tipul de moneda "lev"
    memcpy(W, T[last], sizeof(W));
    for (i = A[lev]; i <= S; ++ i) 
	if (W[i - A[lev]]) W[i] = 1;
    memcpy(T[lev], W, sizeof(W));
	
    back(lev + 1, lev);
}

void solve()
{
    memset(T, 0, sizeof(T));
    T[0][0] = 1;
    back(1, 0);
}

void write_data()
{
    FILE *f = fopen("monezi.out", "wt");
    fprintf(f, "%d\n", sol);
    fclose(f);
}

int main()
{
    read_data();
    solve();
    write_data();
    return 0;
}
