/*
Solution by Algostorm
Time Complexity: O(2^N * N * S)
Space Memory: O(N + S)
*/

#include <iostream>

using namespace std;

#define maxN 32
#define maxS 1024

int N, S, sol, A[maxN], T[maxS];

void read_data()
{
    int i;
    FILE *f = fopen("monezi.in", "rt");
    fscanf(f, "%d %d", &N, &S);
    for (i = 1; i <= N; ++ i)
	fscanf(f, "%d", A + i);
    fclose(f);
}

void solve()
{
    int i, j, cfg, pow2n = 1 << N, tmp;
    
    for (cfg = 1; cfg < pow2n; ++ cfg) {
	memset(T, 0, sizeof(T));
	T[0] = 1;
	for (i = 0; i < N; ++ i)
	    if (1 << i & cfg) {
		tmp = S - A[i + 1];
		for (j = 0; j <= tmp; j ++)
		    if (T[j]) T[j + A[i + 1]] = 1;
	    }
	for (i = 1; i <= S; i ++)
	    sol += T[i];
    }
}

void write_data()
{
    FILE *f = fopen("monezi.out", "wt");
    fprintf(f, "%d\n", sol);
    fclose(f);
}

int main()
{
    read_data();
    solve();
    write_data();
    return 0;
}
