/*
Solution By Algostorm
Time Complexity: O(N)
Memory space: 2*K (sometimes, constants are very important)
*/

#include <cstdio>
#include <string>
#include <cstdlib>

using namespace std;

#define ll long long
#define maxC 512 * 1024

int N, K, C;
int cnt[maxC], in_reg[maxC], no_free;
ll A, B, invA;

int main()
{
	int nr_t, a, b, c, i, j, first, last;
	FILE *FIN, *FOUT;

	FIN = fopen("reg.in", "rt");
	FOUT = fopen("reg.out", "wt");

	for (fscanf(FIN, "%d", &nr_t); nr_t; -- nr_t) {

		fscanf(FIN, "%d %d %d %d %d", &a, &b, &c, &N, &K);

		/* init */
		A = a % c, B = b % c, C = c;
		
		if (A) {
    		    for (invA = 1; ; invA ++)
			if ( (invA * A) % C == 1 ) break;
		}
		else {
		    invA = -1;
		    printf("Bad Santa! %d\n", nr_t);
		}

		memset(cnt, 0, sizeof(cnt));
		memset(in_reg, 0, sizeof(in_reg));
		no_free = 0;

		/* init X */
		for (first = i = 1; i <= N; ++ i) {
			cnt[ first ] ++;
			first = (int) (( A * first + B * (i + 1) ) % C);
		}
		last = first;

		/* solve */
		for (i = first = 1, j = N + 1; i < j; ++ i) {

			cnt[ first ] --;

			if (in_reg[ first ])
				;
			else {
				if (no_free < K) no_free ++;
				else {
					while (true) {
						if (invA > 0) {
    						    last = (last + C - (B * j) % C) % C;
						    last = (invA * (ll) last) % C; 
						}
						else {
    						    last = (B * (j - 1)) % C;
						}
						
						j --;
						cnt[ last ] --;
						if (in_reg[ last ] && cnt[ last ] == 0) {
							in_reg[ last ] = 0;
							break;
						}
					}
				}
			}

			if (cnt[ first ] == 0) 
				no_free --; 
			else
				in_reg[ first ] = 1;
			
			first = (int) (( A * first + B * (i + 1) ) % C);
		}
		fprintf(FOUT, "%d\n", j - 1);
	}

	fclose(FIN);
	fclose(FOUT);

	return 0;
}

