/*
Solution By Algostorm
Time Complexity: O(N)
Memory space: N + 2*K (constants are very important here)
*/

#include <cstdio>
#include <string>
#include <cstdlib>

using namespace std;

//#define STATICS
#define ll long long

int *X, N, K, C;
int *cnt, *in_reg, no_free;
ll A, B;

int main()
{
	int nr_t, a, b, c, i, j, first, last;
	FILE *FIN, *FOUT;

	FIN = fopen("reg.in", "rt");
	FOUT = fopen("reg.out", "wt");

	for (fscanf(FIN, "%d", &nr_t); nr_t; -- nr_t) {

		fscanf(FIN, "%d %d %d %d %d", &a, &b, &c, &N, &K);

		/* init */
		A = a, B = b, C = c;

		cnt = (int *) realloc(cnt, sizeof(int) * (C + 10));
		in_reg = (int *) realloc(in_reg, sizeof(int) * (C + 10));
		X = (int *) realloc(X, sizeof(int) * (N + 10) );

		memset(cnt, 0, sizeof(int) * (C + 10));
		memset(in_reg, 0, sizeof(int) * (C + 10));
		no_free = 0;
		X[1] = 1; cnt[1] ++;

		/* init X */
		for (i = 2; i <= N; ++ i) {
			X[i] = (int) (( A * X[i - 1] + B * i ) % C);
			cnt[ X[i] ] ++;
		}

		/* solve */
		for (i = 1, j = N + 1; i < j; ++ i) {

			first = X[i];
			cnt[ first ] --;

			if (in_reg[ first ])
				;
			else {
				if (no_free < K) no_free ++;
				else {
					while (true) {
						j --;
						last = X[j];
						cnt[ last ] --;
						if (in_reg[ last ] && cnt[ last ] == 0) {
							in_reg[ last ] = 0;
							break;
						}
					}
				}
			}

			if (cnt[ first ] == 0) 
				no_free --; 
			else
				in_reg[ first ] = 1;
		}

		if (i != j) exit(1);
		fprintf(FOUT, "%d\n", j - 1);

#ifdef STATICS
		for (i = 1; i <= N; ++ i)
			fprintf(FOUT, "%d\n", X[i]);
#endif
	}

	fclose(FIN);
	fclose(FOUT);

	return 0;
}

